/* game-headerbar.c generated by valac 0.44.3, the Vala compiler
 * generated from game-headerbar.vala, do not modify */

/* Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
 * Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of GNOME 2048.
 *
 * GNOME 2048 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME 2048 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME 2048; if not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_GAME_HEADER_BAR (game_header_bar_get_type ())
#define GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBar))
#define GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))
#define IS_GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_HEADER_BAR))
#define IS_GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_HEADER_BAR))
#define GAME_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))

typedef struct _GameHeaderBar GameHeaderBar;
typedef struct _GameHeaderBarClass GameHeaderBarClass;
typedef struct _GameHeaderBarPrivate GameHeaderBarPrivate;
enum  {
	GAME_HEADER_BAR_0_PROPERTY,
	GAME_HEADER_BAR_NUM_PROPERTIES
};
static GParamSpec* game_header_bar_properties[GAME_HEADER_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL,
	GAME_HEADER_BAR_NUM_SIGNALS
};
static guint game_header_bar_signals[GAME_HEADER_BAR_NUM_SIGNALS] = {0};

struct _GameHeaderBar {
	GtkHeaderBar parent_instance;
	GameHeaderBarPrivate * priv;
};

struct _GameHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

struct _GameHeaderBarPrivate {
	GtkLabel* _score;
	GtkMenuButton* _new_game_button;
	GtkMenuButton* _hamburger_button;
};

static gint GameHeaderBar_private_offset;
static gpointer game_header_bar_parent_class = NULL;

GType game_header_bar_get_type (void) G_GNUC_CONST;
static void game_header_bar_test_popover_closed (GameHeaderBar* self);
gboolean game_header_bar_has_popover (GameHeaderBar* self);
void game_header_bar_clear_subtitle (GameHeaderBar* self);
void game_header_bar_finished (GameHeaderBar* self);
void game_header_bar_set_score (GameHeaderBar* self,
                                GObject* game,
                                GParamSpec* unused);
GType game_get_type (void) G_GNUC_CONST;
glong game_get_score (Game* self);
void _game_header_bar_update_hamburger_menu (GameHeaderBar* self,
                                             gboolean allow_undo);
static inline void _game_header_bar_append_undo_section (GMenu* * menu);
static inline void _game_header_bar_append_scores_section (GMenu* * menu);
static inline void _game_header_bar_append_app_actions_section (GMenu* * menu);
void game_header_bar_toggle_hamburger_menu (GameHeaderBar* self);
void _game_header_bar_update_new_game_menu (GameHeaderBar* self,
                                            gint rows,
                                            gint cols);
static void _game_header_bar_append_new_game_item (const gchar* label,
                                            gint rows,
                                            gint cols,
                                            GMenu* * menu);
gboolean grid_is_disallowed_grid_size (gint* rows,
                                       gint* cols);
void game_header_bar_toggle_new_game (GameHeaderBar* self);
GameHeaderBar* game_header_bar_new (void);
GameHeaderBar* game_header_bar_construct (GType object_type);
static GObject * game_header_bar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _game_header_bar_test_popover_closed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void game_header_bar_finalize (GObject * obj);

static inline gpointer
game_header_bar_get_instance_private (GameHeaderBar* self)
{
	return G_STRUCT_MEMBER_P (self, GameHeaderBar_private_offset);
}

static void
game_header_bar_test_popover_closed (GameHeaderBar* self)
{
#line 41 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/game-headerbar.vala"
	if (!game_header_bar_has_popover (self)) {
#line 44 "../src/game-headerbar.vala"
		g_signal_emit (self, game_header_bar_signals[GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL], 0);
#line 135 "game-headerbar.c"
	}
}

gboolean
game_header_bar_has_popover (GameHeaderBar* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 47 "../src/game-headerbar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_hamburger_button;
#line 49 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 49 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 49 "../src/game-headerbar.vala"
	if (_tmp3_) {
#line 49 "../src/game-headerbar.vala"
		_tmp0_ = TRUE;
#line 159 "game-headerbar.c"
	} else {
		GtkMenuButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 49 "../src/game-headerbar.vala"
		_tmp4_ = self->priv->_new_game_button;
#line 49 "../src/game-headerbar.vala"
		_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
#line 49 "../src/game-headerbar.vala"
		_tmp6_ = _tmp5_;
#line 49 "../src/game-headerbar.vala"
		_tmp0_ = _tmp6_;
#line 172 "game-headerbar.c"
	}
#line 49 "../src/game-headerbar.vala"
	result = _tmp0_;
#line 49 "../src/game-headerbar.vala"
	return result;
#line 178 "game-headerbar.c"
}

void
game_header_bar_clear_subtitle (GameHeaderBar* self)
{
#line 56 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/game-headerbar.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, NULL);
#line 59 "../src/game-headerbar.vala"
	gtk_header_bar_set_has_subtitle ((GtkHeaderBar*) self, FALSE);
#line 190 "game-headerbar.c"
}

void
game_header_bar_finished (GameHeaderBar* self)
{
#line 62 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/game-headerbar.vala"
	gtk_header_bar_set_has_subtitle ((GtkHeaderBar*) self, TRUE);
#line 66 "../src/game-headerbar.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _ ("Game Over"));
#line 202 "game-headerbar.c"
}

void
game_header_bar_set_score (GameHeaderBar* self,
                           GObject* game,
                           GParamSpec* unused)
{
	GtkLabel* _tmp0_;
	glong _tmp1_;
	glong _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 69 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/game-headerbar.vala"
	g_return_if_fail (game != NULL);
#line 69 "../src/game-headerbar.vala"
	g_return_if_fail (unused != NULL);
#line 71 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_score;
#line 71 "../src/game-headerbar.vala"
	_tmp1_ = game_get_score (G_TYPE_CHECK_INSTANCE_CAST (game, TYPE_GAME, Game));
#line 71 "../src/game-headerbar.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/game-headerbar.vala"
	_tmp3_ = g_strdup_printf ("%li", _tmp2_);
#line 71 "../src/game-headerbar.vala"
	_tmp4_ = _tmp3_;
#line 71 "../src/game-headerbar.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 71 "../src/game-headerbar.vala"
	_g_free0 (_tmp4_);
#line 235 "game-headerbar.c"
}

void
_game_header_bar_update_hamburger_menu (GameHeaderBar* self,
                                        gboolean allow_undo)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GtkMenuButton* _tmp2_;
	GMenu* _tmp3_;
#line 78 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 80 "../src/game-headerbar.vala"
	menu = _tmp0_;
#line 82 "../src/game-headerbar.vala"
	if (allow_undo) {
#line 83 "../src/game-headerbar.vala"
		_game_header_bar_append_undo_section (&menu);
#line 257 "game-headerbar.c"
	}
#line 84 "../src/game-headerbar.vala"
	_game_header_bar_append_scores_section (&menu);
#line 85 "../src/game-headerbar.vala"
	_game_header_bar_append_app_actions_section (&menu);
#line 87 "../src/game-headerbar.vala"
	_tmp1_ = menu;
#line 87 "../src/game-headerbar.vala"
	g_menu_freeze (_tmp1_);
#line 88 "../src/game-headerbar.vala"
	_tmp2_ = self->priv->_hamburger_button;
#line 88 "../src/game-headerbar.vala"
	_tmp3_ = menu;
#line 88 "../src/game-headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_menu_model_get_type (), GMenuModel));
#line 78 "../src/game-headerbar.vala"
	_g_object_unref0 (menu);
#line 275 "game-headerbar.c"
}

static inline void
_game_header_bar_append_undo_section (GMenu* * menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 91 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 93 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 93 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 96 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Undo"), "ui.undo");
#line 98 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 99 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 91 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 297 "game-headerbar.c"
}

static inline void
_game_header_bar_append_scores_section (GMenu* * menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 102 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 104 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 104 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 107 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Scores"), "ui.scores");
#line 109 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 110 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 102 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 319 "game-headerbar.c"
}

static inline void
_game_header_bar_append_app_actions_section (GMenu* * menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 113 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 115 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 115 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 118 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Keyboard Shortcuts"), "win.show-help-overlay");
#line 121 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("About 2048"), "ui.about");
#line 123 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 124 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 113 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 343 "game-headerbar.c"
}

void
game_header_bar_toggle_hamburger_menu (GameHeaderBar* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 127 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_hamburger_button;
#line 129 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_hamburger_button;
#line 129 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 129 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 129 "../src/game-headerbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 365 "game-headerbar.c"
}

void
_game_header_bar_update_new_game_menu (GameHeaderBar* self,
                                       gint rows,
                                       gint cols)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	gboolean is_square = FALSE;
	gboolean disallowed_grid = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GMenu* _tmp8_;
	GtkMenuButton* _tmp9_;
	GMenu* _tmp10_;
#line 136 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 138 "../src/game-headerbar.vala"
	menu = _tmp0_;
#line 141 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("3 × 3"), 3, 3, &menu);
#line 147 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("4 × 4"), 4, 4, &menu);
#line 153 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("5 × 5"), 5, 5, &menu);
#line 158 "../src/game-headerbar.vala"
	is_square = rows == cols;
#line 159 "../src/game-headerbar.vala"
	_tmp1_ = grid_is_disallowed_grid_size (&rows, &cols);
#line 159 "../src/game-headerbar.vala"
	disallowed_grid = _tmp1_;
#line 160 "../src/game-headerbar.vala"
	if (disallowed_grid) {
#line 160 "../src/game-headerbar.vala"
		_tmp2_ = !is_square;
#line 405 "game-headerbar.c"
	} else {
#line 160 "../src/game-headerbar.vala"
		_tmp2_ = FALSE;
#line 409 "game-headerbar.c"
	}
#line 160 "../src/game-headerbar.vala"
	if (_tmp2_) {
#line 162 "../src/game-headerbar.vala"
		g_warning ("game-headerbar.vala:162: %s", _ ("Grids of size 1 by 2 are disallowed."));
#line 415 "game-headerbar.c"
	}
#line 164 "../src/game-headerbar.vala"
	if (!disallowed_grid) {
#line 419 "game-headerbar.c"
		gboolean _tmp4_ = FALSE;
#line 164 "../src/game-headerbar.vala"
		if (!is_square) {
#line 164 "../src/game-headerbar.vala"
			_tmp4_ = TRUE;
#line 425 "game-headerbar.c"
		} else {
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 164 "../src/game-headerbar.vala"
			if (is_square) {
#line 164 "../src/game-headerbar.vala"
				_tmp7_ = rows != 4;
#line 434 "game-headerbar.c"
			} else {
#line 164 "../src/game-headerbar.vala"
				_tmp7_ = FALSE;
#line 438 "game-headerbar.c"
			}
#line 164 "../src/game-headerbar.vala"
			if (_tmp7_) {
#line 164 "../src/game-headerbar.vala"
				_tmp6_ = rows != 3;
#line 444 "game-headerbar.c"
			} else {
#line 164 "../src/game-headerbar.vala"
				_tmp6_ = FALSE;
#line 448 "game-headerbar.c"
			}
#line 164 "../src/game-headerbar.vala"
			if (_tmp6_) {
#line 164 "../src/game-headerbar.vala"
				_tmp5_ = rows != 5;
#line 454 "game-headerbar.c"
			} else {
#line 164 "../src/game-headerbar.vala"
				_tmp5_ = FALSE;
#line 458 "game-headerbar.c"
			}
#line 164 "../src/game-headerbar.vala"
			_tmp4_ = _tmp5_;
#line 462 "game-headerbar.c"
		}
#line 164 "../src/game-headerbar.vala"
		_tmp3_ = _tmp4_;
#line 466 "game-headerbar.c"
	} else {
#line 164 "../src/game-headerbar.vala"
		_tmp3_ = FALSE;
#line 470 "game-headerbar.c"
	}
#line 164 "../src/game-headerbar.vala"
	if (_tmp3_) {
#line 166 "../src/game-headerbar.vala"
		_game_header_bar_append_new_game_item (_ ("Custom"), rows, cols, &menu);
#line 476 "game-headerbar.c"
	}
#line 168 "../src/game-headerbar.vala"
	_tmp8_ = menu;
#line 168 "../src/game-headerbar.vala"
	g_menu_freeze (_tmp8_);
#line 169 "../src/game-headerbar.vala"
	_tmp9_ = self->priv->_new_game_button;
#line 169 "../src/game-headerbar.vala"
	_tmp10_ = menu;
#line 169 "../src/game-headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_menu_model_get_type (), GMenuModel));
#line 136 "../src/game-headerbar.vala"
	_g_object_unref0 (menu);
#line 490 "game-headerbar.c"
}

static void
_game_header_bar_append_new_game_item (const gchar* label,
                                       gint rows,
                                       gint cols,
                                       GMenu* * menu)
{
	GVariant* variant = NULL;
	GVariant* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 171 "../src/game-headerbar.vala"
	g_return_if_fail (label != NULL);
#line 171 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 173 "../src/game-headerbar.vala"
	_tmp0_ = g_variant_new ("(ii)", rows, cols, NULL);
#line 173 "../src/game-headerbar.vala"
	g_variant_ref_sink (_tmp0_);
#line 173 "../src/game-headerbar.vala"
	variant = _tmp0_;
#line 174 "../src/game-headerbar.vala"
	_tmp1_ = g_variant_print (variant, TRUE);
#line 174 "../src/game-headerbar.vala"
	_tmp2_ = _tmp1_;
#line 174 "../src/game-headerbar.vala"
	_tmp3_ = g_strconcat ("ui.new-game-sized(", _tmp2_, NULL);
#line 174 "../src/game-headerbar.vala"
	_tmp4_ = _tmp3_;
#line 174 "../src/game-headerbar.vala"
	_tmp5_ = g_strconcat (_tmp4_, ")", NULL);
#line 174 "../src/game-headerbar.vala"
	_tmp6_ = _tmp5_;
#line 174 "../src/game-headerbar.vala"
	g_menu_append (*menu, label, _tmp6_);
#line 174 "../src/game-headerbar.vala"
	_g_free0 (_tmp6_);
#line 174 "../src/game-headerbar.vala"
	_g_free0 (_tmp4_);
#line 174 "../src/game-headerbar.vala"
	_g_free0 (_tmp2_);
#line 171 "../src/game-headerbar.vala"
	_g_variant_unref0 (variant);
#line 539 "game-headerbar.c"
}

void
game_header_bar_toggle_new_game (GameHeaderBar* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 177 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_new_game_button;
#line 179 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_new_game_button;
#line 179 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 179 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 179 "../src/game-headerbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 561 "game-headerbar.c"
}

GameHeaderBar*
game_header_bar_construct (GType object_type)
{
	GameHeaderBar * self = NULL;
#line 23 "../src/game-headerbar.vala"
	self = (GameHeaderBar*) g_object_new (object_type, NULL);
#line 23 "../src/game-headerbar.vala"
	return self;
#line 572 "game-headerbar.c"
}

GameHeaderBar*
game_header_bar_new (void)
{
#line 23 "../src/game-headerbar.vala"
	return game_header_bar_construct (TYPE_GAME_HEADER_BAR);
#line 580 "game-headerbar.c"
}

static void
_game_header_bar_test_popover_closed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 37 "../src/game-headerbar.vala"
	game_header_bar_test_popover_closed ((GameHeaderBar*) self);
#line 590 "game-headerbar.c"
}

static GObject *
game_header_bar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameHeaderBar * self;
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
#line 35 "../src/game-headerbar.vala"
	parent_class = G_OBJECT_CLASS (game_header_bar_parent_class);
#line 35 "../src/game-headerbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/game-headerbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_HEADER_BAR, GameHeaderBar);
#line 37 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_hamburger_button;
#line 37 "../src/game-headerbar.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) _game_header_bar_test_popover_closed_g_object_notify, self, 0);
#line 38 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_new_game_button;
#line 38 "../src/game-headerbar.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::active", (GCallback) _game_header_bar_test_popover_closed_g_object_notify, self, 0);
#line 35 "../src/game-headerbar.vala"
	return obj;
#line 619 "game-headerbar.c"
}

static void
game_header_bar_class_init (GameHeaderBarClass * klass,
                            gpointer klass_data)
{
#line 23 "../src/game-headerbar.vala"
	game_header_bar_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/game-headerbar.vala"
	g_type_class_adjust_private_offset (klass, &GameHeaderBar_private_offset);
#line 23 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (klass)->constructor = game_header_bar_constructor;
#line 23 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (klass)->finalize = game_header_bar_finalize;
#line 23 "../src/game-headerbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/TwentyFortyEight/ui/game-headerbar.ui");
#line 23 "../src/game-headerbar.vala"
	game_header_bar_signals[GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL] = g_signal_new ("popover-closed", TYPE_GAME_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_score", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _score));
#line 23 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_new_game_button", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _new_game_button));
#line 23 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_hamburger_button", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _hamburger_button));
#line 644 "game-headerbar.c"
}

static void
game_header_bar_instance_init (GameHeaderBar * self,
                               gpointer klass)
{
#line 23 "../src/game-headerbar.vala"
	self->priv = game_header_bar_get_instance_private (self);
#line 23 "../src/game-headerbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 655 "game-headerbar.c"
}

static void
game_header_bar_finalize (GObject * obj)
{
	GameHeaderBar * self;
#line 23 "../src/game-headerbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_HEADER_BAR, GameHeaderBar);
#line 25 "../src/game-headerbar.vala"
	_g_object_unref0 (self->priv->_score);
#line 26 "../src/game-headerbar.vala"
	_g_object_unref0 (self->priv->_new_game_button);
#line 27 "../src/game-headerbar.vala"
	_g_object_unref0 (self->priv->_hamburger_button);
#line 23 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (game_header_bar_parent_class)->finalize (obj);
#line 672 "game-headerbar.c"
}

GType
game_header_bar_get_type (void)
{
	static volatile gsize game_header_bar_type_id__volatile = 0;
	if (g_once_init_enter (&game_header_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHeaderBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_header_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHeaderBar), 0, (GInstanceInitFunc) game_header_bar_instance_init, NULL };
		GType game_header_bar_type_id;
		game_header_bar_type_id = g_type_register_static (gtk_header_bar_get_type (), "GameHeaderBar", &g_define_type_info, 0);
		GameHeaderBar_private_offset = g_type_add_instance_private (game_header_bar_type_id, sizeof (GameHeaderBarPrivate));
		g_once_init_leave (&game_header_bar_type_id__volatile, game_header_bar_type_id);
	}
	return game_header_bar_type_id__volatile;
}

