/* game-window.c generated by valac 0.44.3, the Vala compiler
 * generated from game-window.vala, do not modify */

/* Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
 * Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of GNOME 2048.
 *
 * GNOME 2048 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME 2048 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME 2048; if not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <clutter-gtk/clutter-gtk.h>
#include <glib.h>
#include <libgnome-games-support.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;

#define TYPE_GAME_HEADER_BAR (game_header_bar_get_type ())
#define GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBar))
#define GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))
#define IS_GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_HEADER_BAR))
#define IS_GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_HEADER_BAR))
#define GAME_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))

typedef struct _GameHeaderBar GameHeaderBar;
typedef struct _GameHeaderBarClass GameHeaderBarClass;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameWindow {
	GtkApplicationWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _GameWindowPrivate {
	GSettings* _settings;
	GameHeaderBar* _header_bar;
	GtkClutterEmbed* _embed;
	GtkButton* _unfullscreen_button;
	Game* _game;
	gint _window_width;
	gint _window_height;
	gboolean _window_maximized;
	gboolean _window_fullscreen;
	gboolean _window_is_tiled;
	GSimpleAction* undo_action;
	GtkGestureSwipe* gesture;
	GtkMessageDialog* _congrats_dialog;
	gboolean _should_create_congrats_dialog;
	GamesScoresContext* _scores_ctx;
	GamesScoresCategory* _grid4_cat;
	GamesScoresCategory* _grid3_cat;
	GamesScoresCategory* _grid5_cat;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;

GType game_window_get_type (void) G_GNUC_CONST;
GType game_header_bar_get_type (void) G_GNUC_CONST;
GType game_get_type (void) G_GNUC_CONST;
#define GAME_WINDOW_WINDOW_MINIMUM_SIZE_HEIGHT 600
#define GAME_WINDOW_WINDOW_MINIMUM_SIZE_WIDTH 600
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_new_game_sized_cb (GameWindow* self,
                                    GSimpleAction* action,
                                    GVariant* variant);
static void _game_window_new_game_sized_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void game_window_toggle_new_game_cb (GameWindow* self);
static void _game_window_toggle_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void game_window_toggle_hamburger_menu (GameWindow* self);
static void _game_window_toggle_hamburger_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static inline void game_window_scores_cb (GameWindow* self);
static void _game_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self);
static void game_window_about_cb (GameWindow* self);
static void _game_window_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
static void _gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
#define GAME_WINDOW_KEYCODE_W ((guint16) 25)
#define GAME_WINDOW_KEYCODE_A ((guint16) 38)
#define GAME_WINDOW_KEYCODE_S ((guint16) 39)
#define GAME_WINDOW_KEYCODE_D ((guint16) 40)
static void game_window_on_destroy (GameWindow* self);
void game_save_game (Game* self);
static void _game_window_save_window_state (GameWindow* _this,
                                     GSettings* * _settings);
static void _game_window_on_destroy_gtk_widget_destroy (GtkWidget* _sender,
                                                 gpointer self);
static void _game_window_init_game (GameWindow* self);
Game* game_new (GSettings* * settings);
Game* game_construct (GType object_type,
                      GSettings* * settings);
void game_header_bar_set_score (GameHeaderBar* self,
                                GObject* game,
                                GParamSpec* unused);
static void _game_header_bar_set_score_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void __lambda4_ (GameWindow* self,
                 gboolean show_scores);
void game_header_bar_finished (GameHeaderBar* self);
static inline void _game_window_show_best_scores (GameWindow* self);
static void ___lambda4__game_finished (Game* _sender,
                                gboolean show_scores,
                                gpointer self);
static inline void game_window_target_value_reached_cb (GameWindow* self,
                                          guint target_value);
static void _game_window_target_value_reached_cb_game_target_value_reached (Game* _sender,
                                                                     guint val,
                                                                     gpointer self);
static void __lambda8_ (GameWindow* self);
static void ___lambda8__game_undo_enabled (Game* _sender,
                                    gpointer self);
static void __lambda9_ (GameWindow* self);
static void ___lambda9__game_undo_disabled (Game* _sender,
                                     gpointer self);
static void _game_window_init_window (GameWindow* self);
static void _game_window_init_window_state (GameWindow* _this);
static void _game_window_load_window_state (GameWindow* _this,
                                     GSettings* * _settings);
static void __lambda10_ (GameWindow* self);
static void ___lambda10__game_header_bar_popover_closed (GameHeaderBar* _sender,
                                                  gpointer self);
static void __lambda11_ (GameWindow* self,
                  GSettings* settings,
                  const gchar* key_name);
void _game_header_bar_update_new_game_menu (GameHeaderBar* self,
                                            gint rows,
                                            gint cols);
void _game_header_bar_update_hamburger_menu (GameHeaderBar* self,
                                             gboolean allow_undo);
void game_load_settings (Game* self,
                         GSettings* * settings);
static void ___lambda11__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
void game_set_view (Game* self,
                    ClutterActor* value);
static gboolean game_window_state_event_cb (GtkWidget* widget,
                                     GdkEventWindowState* event);
static gboolean _game_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                    GdkEventWindowState* event,
                                                                    gpointer self);
static void game_window_size_allocate_cb (GtkWidget* widget,
                                   GtkAllocation* allocation);
static void _game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static gint* _int_dup (gint* self);
static void _game_window_install_ui_action_entries (GameWindow* self);
void game_header_bar_clear_subtitle (GameHeaderBar* self);
void game_undo (Game* self);
void game_new_game (Game* self,
                    GSettings* * settings);
void game_header_bar_toggle_new_game (GameHeaderBar* self);
void game_header_bar_toggle_hamburger_menu (GameHeaderBar* self);
static inline void _game_window_init_keyboard (GameWindow* self);
static gboolean game_window_key_press_event_cb (GtkWidget* widget,
                                         GdkEventKey* event);
static gboolean _game_window_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                     GdkEventKey* event,
                                                                     gpointer self);
gboolean game_header_bar_has_popover (GameHeaderBar* self);
gboolean game_cannot_move (Game* self);
GType move_request_get_type (void) G_GNUC_CONST;
void game_move (Game* self,
                MoveRequest request);
static inline guint _game_window_upper_key (guint keyval);
static inline void _game_window_init_gestures (GameWindow* self);
static inline void _game_window_on_swipe (GameWindow* self,
                            GtkGestureSwipe* gesture,
                            gdouble velocity_x,
                            gdouble velocity_y);
static void __game_window_on_swipe_gtk_gesture_swipe_swipe (GtkGestureSwipe* _sender,
                                                     gdouble velocity_x,
                                                     gdouble velocity_y,
                                                     gpointer self);
static inline void _game_window_create_congrats_dialog (GameWindow* self);
static void __lambda6_ (GameWindow* self,
                 gint response_id);
static void ___lambda6__gtk_dialog_response (GtkDialog* _sender,
                                      gint response_id,
                                      gpointer self);
static gboolean __lambda7_ (GameWindow* self,
                     GdkEventAny* response_id);
static gboolean ___lambda7__gtk_widget_delete_event (GtkWidget* _sender,
                                              GdkEventAny* event,
                                              gpointer self);
static inline void _game_window_create_scores_dialog (GameWindow* self);
static inline GamesScoresCategory* game_window_category_request (GameWindow* self,
                                                   const gchar* key);
static GamesScoresCategory* _game_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                                               gpointer self);
glong game_get_score (Game* self);
static void __lambda5_ (GameWindow* self,
                 GObject* object,
                 GAsyncResult* _result_);
static void ___lambda5__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
GameWindow* game_window_new (void);
GameWindow* game_window_construct (GType object_type);
static GObject * game_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _game_window___lambda12_ (GameWindow* self);
static void __game_window___lambda12__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self);
gboolean game_restore_game (Game* self,
                            GSettings* * settings);
static void game_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry GAME_WINDOW__ui_action_entries[8] = {{"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"new-game-sized", _game_window_new_game_sized_cb_gsimple_action_activate_callback, "(ii)"}, {"toggle-new-game", _game_window_toggle_new_game_cb_gsimple_action_activate_callback}, {"toggle-hamburger", _game_window_toggle_hamburger_menu_gsimple_action_activate_callback}, {"scores", _game_window_scores_cb_gsimple_action_activate_callback}, {"about", _game_window_about_cb_gsimple_action_activate_callback}, {"unfullscreen", _gtk_window_unfullscreen_gsimple_action_activate_callback}};

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_undo_cb ((GameWindow*) self);
#line 317 "game-window.c"
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_new_game_cb ((GameWindow*) self);
#line 327 "game-window.c"
}

static void
_game_window_new_game_sized_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_new_game_sized_cb ((GameWindow*) self, action, parameter);
#line 337 "game-window.c"
}

static void
_game_window_toggle_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_toggle_new_game_cb ((GameWindow*) self);
#line 347 "game-window.c"
}

static void
_game_window_toggle_hamburger_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_toggle_hamburger_menu ((GameWindow*) self);
#line 357 "game-window.c"
}

static void
_game_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                         GVariant* parameter,
                                                         gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_scores_cb ((GameWindow*) self);
#line 367 "game-window.c"
}

static void
_game_window_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 217 "../src/game-window.vala"
	game_window_about_cb ((GameWindow*) self);
#line 377 "game-window.c"
}

static void
_gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 217 "../src/game-window.vala"
	gtk_window_unfullscreen ((GtkWindow*) self);
#line 387 "game-window.c"
}

static void
game_window_on_destroy (GameWindow* self)
{
	Game* _tmp0_;
#line 58 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/game-window.vala"
	_tmp0_ = self->priv->_game;
#line 60 "../src/game-window.vala"
	game_save_game (_tmp0_);
#line 61 "../src/game-window.vala"
	_game_window_save_window_state (self, &self->priv->_settings);
#line 62 "../src/game-window.vala"
	GTK_WIDGET_CLASS (game_window_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 404 "game-window.c"
}

static void
_game_window_on_destroy_gtk_widget_destroy (GtkWidget* _sender,
                                            gpointer self)
{
#line 24 "../src/game-window.vala"
	game_window_on_destroy ((GameWindow*) self);
#line 413 "game-window.c"
}

static void
_game_header_bar_set_score_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 72 "../src/game-window.vala"
	game_header_bar_set_score ((GameHeaderBar*) self, _sender, pspec);
#line 423 "game-window.c"
}

static void
__lambda4_ (GameWindow* self,
            gboolean show_scores)
{
	GameHeaderBar* _tmp0_;
#line 74 "../src/game-window.vala"
	_tmp0_ = self->priv->_header_bar;
#line 74 "../src/game-window.vala"
	game_header_bar_finished (_tmp0_);
#line 76 "../src/game-window.vala"
	if (show_scores) {
#line 77 "../src/game-window.vala"
		_game_window_show_best_scores (self);
#line 439 "game-window.c"
	}
#line 79 "../src/game-window.vala"
	g_debug ("game-window.vala:79: finished");
#line 443 "game-window.c"
}

static void
___lambda4__game_finished (Game* _sender,
                           gboolean show_scores,
                           gpointer self)
{
#line 73 "../src/game-window.vala"
	__lambda4_ ((GameWindow*) self, show_scores);
#line 453 "game-window.c"
}

static void
_game_window_target_value_reached_cb_game_target_value_reached (Game* _sender,
                                                                guint val,
                                                                gpointer self)
{
#line 81 "../src/game-window.vala"
	game_window_target_value_reached_cb ((GameWindow*) self, val);
#line 463 "game-window.c"
}

static void
__lambda8_ (GameWindow* self)
{
	GSimpleAction* _tmp0_;
#line 82 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 82 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, TRUE);
#line 474 "game-window.c"
}

static void
___lambda8__game_undo_enabled (Game* _sender,
                               gpointer self)
{
#line 82 "../src/game-window.vala"
	__lambda8_ ((GameWindow*) self);
#line 483 "game-window.c"
}

static void
__lambda9_ (GameWindow* self)
{
	GSimpleAction* _tmp0_;
#line 83 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 83 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 494 "game-window.c"
}

static void
___lambda9__game_undo_disabled (Game* _sender,
                                gpointer self)
{
#line 83 "../src/game-window.vala"
	__lambda9_ ((GameWindow*) self);
#line 503 "game-window.c"
}

static void
_game_window_init_game (GameWindow* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameHeaderBar* _tmp2_;
	Game* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	Game* _tmp6_;
#line 69 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/game-window.vala"
	_tmp0_ = game_new (&self->priv->_settings);
#line 71 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_game);
#line 71 "../src/game-window.vala"
	self->priv->_game = _tmp0_;
#line 72 "../src/game-window.vala"
	_tmp1_ = self->priv->_game;
#line 72 "../src/game-window.vala"
	_tmp2_ = self->priv->_header_bar;
#line 72 "../src/game-window.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::score", (GCallback) _game_header_bar_set_score_g_object_notify, _tmp2_, 0);
#line 73 "../src/game-window.vala"
	_tmp3_ = self->priv->_game;
#line 73 "../src/game-window.vala"
	g_signal_connect_object (_tmp3_, "finished", (GCallback) ___lambda4__game_finished, self, 0);
#line 81 "../src/game-window.vala"
	_tmp4_ = self->priv->_game;
#line 81 "../src/game-window.vala"
	g_signal_connect_object (_tmp4_, "target-value-reached", (GCallback) _game_window_target_value_reached_cb_game_target_value_reached, self, 0);
#line 82 "../src/game-window.vala"
	_tmp5_ = self->priv->_game;
#line 82 "../src/game-window.vala"
	g_signal_connect_object (_tmp5_, "undo-enabled", (GCallback) ___lambda8__game_undo_enabled, self, 0);
#line 83 "../src/game-window.vala"
	_tmp6_ = self->priv->_game;
#line 83 "../src/game-window.vala"
	g_signal_connect_object (_tmp6_, "undo-disabled", (GCallback) ___lambda9__game_undo_disabled, self, 0);
#line 546 "game-window.c"
}

static void
__lambda10_ (GameWindow* self)
{
	GtkClutterEmbed* _tmp0_;
#line 91 "../src/game-window.vala"
	_tmp0_ = self->priv->_embed;
#line 91 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 557 "game-window.c"
}

static void
___lambda10__game_header_bar_popover_closed (GameHeaderBar* _sender,
                                             gpointer self)
{
#line 91 "../src/game-window.vala"
	__lambda10_ ((GameWindow*) self);
#line 566 "game-window.c"
}

static void
__lambda11_ (GameWindow* self,
             GSettings* settings,
             const gchar* key_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 93 "../src/game-window.vala"
	static GQuark _tmp1_label0 = 0;
#line 93 "../src/game-window.vala"
	static GQuark _tmp1_label1 = 0;
#line 93 "../src/game-window.vala"
	static GQuark _tmp1_label2 = 0;
#line 93 "../src/game-window.vala"
	static GQuark _tmp1_label3 = 0;
#line 93 "../src/game-window.vala"
	static GQuark _tmp1_label4 = 0;
#line 92 "../src/game-window.vala"
	g_return_if_fail (settings != NULL);
#line 92 "../src/game-window.vala"
	g_return_if_fail (key_name != NULL);
#line 93 "../src/game-window.vala"
	_tmp0_ = key_name;
#line 93 "../src/game-window.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 93 "../src/game-window.vala"
	if ((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("cols")))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("rows"))))) {
#line 93 "../src/game-window.vala"
		switch (0) {
#line 598 "game-window.c"
			default:
			{
				GameHeaderBar* _tmp3_;
				GSettings* _tmp4_;
				GSettings* _tmp5_;
#line 97 "../src/game-window.vala"
				_tmp3_ = self->priv->_header_bar;
#line 97 "../src/game-window.vala"
				_tmp4_ = self->priv->_settings;
#line 97 "../src/game-window.vala"
				_tmp5_ = self->priv->_settings;
#line 97 "../src/game-window.vala"
				_game_header_bar_update_new_game_menu (_tmp3_, g_settings_get_int (_tmp4_, "rows"), g_settings_get_int (_tmp5_, "cols"));
#line 98 "../src/game-window.vala"
				return;
#line 614 "game-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("allow-undo")))) {
#line 93 "../src/game-window.vala"
		switch (0) {
#line 620 "game-window.c"
			default:
			{
				GameHeaderBar* _tmp6_;
				GSettings* _tmp7_;
				Game* _tmp8_;
#line 100 "../src/game-window.vala"
				_tmp6_ = self->priv->_header_bar;
#line 100 "../src/game-window.vala"
				_tmp7_ = self->priv->_settings;
#line 100 "../src/game-window.vala"
				_game_header_bar_update_hamburger_menu (_tmp6_, g_settings_get_boolean (_tmp7_, "allow-undo"));
#line 101 "../src/game-window.vala"
				_tmp8_ = self->priv->_game;
#line 101 "../src/game-window.vala"
				game_load_settings (_tmp8_, &self->priv->_settings);
#line 102 "../src/game-window.vala"
				return;
#line 638 "game-window.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("allow-undo-max")))) || (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("animations-speed"))))) {
#line 93 "../src/game-window.vala"
		switch (0) {
#line 644 "game-window.c"
			default:
			{
				Game* _tmp9_;
#line 105 "../src/game-window.vala"
				_tmp9_ = self->priv->_game;
#line 105 "../src/game-window.vala"
				game_load_settings (_tmp9_, &self->priv->_settings);
#line 106 "../src/game-window.vala"
				return;
#line 654 "game-window.c"
			}
		}
	}
}

static void
___lambda11__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
#line 92 "../src/game-window.vala"
	__lambda11_ ((GameWindow*) self, _sender, key);
#line 667 "game-window.c"
}

static void
_game_window_init_window (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
	GSettings* _tmp1_;
	GameHeaderBar* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GameHeaderBar* _tmp5_;
	GSettings* _tmp6_;
	Game* _tmp7_;
	Game* _tmp8_;
	GtkClutterEmbed* _tmp9_;
	ClutterActor* _tmp10_;
#line 86 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/game-window.vala"
	_game_window_init_window_state (self);
#line 89 "../src/game-window.vala"
	_game_window_load_window_state (self, &self->priv->_settings);
#line 91 "../src/game-window.vala"
	_tmp0_ = self->priv->_header_bar;
#line 91 "../src/game-window.vala"
	g_signal_connect_object (_tmp0_, "popover-closed", (GCallback) ___lambda10__game_header_bar_popover_closed, self, 0);
#line 92 "../src/game-window.vala"
	_tmp1_ = self->priv->_settings;
#line 92 "../src/game-window.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) ___lambda11__g_settings_changed, self, 0);
#line 109 "../src/game-window.vala"
	_tmp2_ = self->priv->_header_bar;
#line 109 "../src/game-window.vala"
	_tmp3_ = self->priv->_settings;
#line 109 "../src/game-window.vala"
	_tmp4_ = self->priv->_settings;
#line 109 "../src/game-window.vala"
	_game_header_bar_update_new_game_menu (_tmp2_, g_settings_get_int (_tmp3_, "rows"), g_settings_get_int (_tmp4_, "cols"));
#line 110 "../src/game-window.vala"
	_tmp5_ = self->priv->_header_bar;
#line 110 "../src/game-window.vala"
	_tmp6_ = self->priv->_settings;
#line 110 "../src/game-window.vala"
	_game_header_bar_update_hamburger_menu (_tmp5_, g_settings_get_boolean (_tmp6_, "allow-undo"));
#line 111 "../src/game-window.vala"
	_tmp7_ = self->priv->_game;
#line 111 "../src/game-window.vala"
	game_load_settings (_tmp7_, &self->priv->_settings);
#line 113 "../src/game-window.vala"
	_tmp8_ = self->priv->_game;
#line 113 "../src/game-window.vala"
	_tmp9_ = self->priv->_embed;
#line 113 "../src/game-window.vala"
	_tmp10_ = gtk_clutter_embed_get_stage (_tmp9_);
#line 113 "../src/game-window.vala"
	game_set_view (_tmp8_, _tmp10_);
#line 115 "../src/game-window.vala"
	gtk_widget_set_events ((GtkWidget*) self, ((gtk_widget_get_events ((GtkWidget*) self) | GDK_STRUCTURE_MASK) | GDK_KEY_PRESS_MASK) | GDK_KEY_RELEASE_MASK);
#line 726 "game-window.c"
}

static gboolean
_game_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                           GdkEventWindowState* event,
                                                           gpointer self)
{
	gboolean result;
	result = game_window_state_event_cb (_sender, event);
#line 133 "../src/game-window.vala"
	return result;
#line 738 "game-window.c"
}

static void
_game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
#line 134 "../src/game-window.vala"
	game_window_size_allocate_cb (_sender, allocation);
#line 748 "game-window.c"
}

static void
_game_window_init_window_state (GameWindow* _this)
{
	GdkGeometry geom = {0};
	GdkGeometry _tmp0_;
#line 131 "../src/game-window.vala"
	g_return_if_fail (_this != NULL);
#line 133 "../src/game-window.vala"
	g_signal_connect ((GtkWidget*) _this, "window-state-event", (GCallback) _game_window_state_event_cb_gtk_widget_window_state_event, NULL);
#line 134 "../src/game-window.vala"
	g_signal_connect ((GtkWidget*) _this, "size-allocate", (GCallback) _game_window_size_allocate_cb_gtk_widget_size_allocate, NULL);
#line 136 "../src/game-window.vala"
	memset (&geom, 0, sizeof (GdkGeometry));
#line 137 "../src/game-window.vala"
	geom.min_height = GAME_WINDOW_WINDOW_MINIMUM_SIZE_HEIGHT;
#line 138 "../src/game-window.vala"
	geom.min_width = GAME_WINDOW_WINDOW_MINIMUM_SIZE_WIDTH;
#line 139 "../src/game-window.vala"
	_tmp0_ = geom;
#line 139 "../src/game-window.vala"
	gtk_window_set_geometry_hints ((GtkWindow*) _this, (GtkWidget*) _this, &_tmp0_, GDK_HINT_MIN_SIZE);
#line 772 "game-window.c"
}

static void
_game_window_load_window_state (GameWindow* _this,
                                GSettings* * _settings)
{
#line 142 "../src/game-window.vala"
	g_return_if_fail (_this != NULL);
#line 142 "../src/game-window.vala"
	g_return_if_fail (*_settings != NULL);
#line 144 "../src/game-window.vala"
	gtk_window_set_default_size ((GtkWindow*) _this, g_settings_get_int (*_settings, "window-width"), g_settings_get_int (*_settings, "window-height"));
#line 147 "../src/game-window.vala"
	if (g_settings_get_boolean (*_settings, "window-maximized")) {
#line 148 "../src/game-window.vala"
		gtk_window_maximize ((GtkWindow*) _this);
#line 789 "game-window.c"
	}
}

static void
_game_window_save_window_state (GameWindow* _this,
                                GSettings* * _settings)
{
	gboolean _tmp0_ = FALSE;
#line 151 "../src/game-window.vala"
	g_return_if_fail (_this != NULL);
#line 151 "../src/game-window.vala"
	g_return_if_fail (*_settings != NULL);
#line 153 "../src/game-window.vala"
	g_settings_delay (*_settings);
#line 154 "../src/game-window.vala"
	g_settings_set_int (*_settings, "window-width", _this->priv->_window_width);
#line 155 "../src/game-window.vala"
	g_settings_set_int (*_settings, "window-height", _this->priv->_window_height);
#line 156 "../src/game-window.vala"
	if (_this->priv->_window_maximized) {
#line 156 "../src/game-window.vala"
		_tmp0_ = TRUE;
#line 812 "game-window.c"
	} else {
#line 156 "../src/game-window.vala"
		_tmp0_ = _this->priv->_window_fullscreen;
#line 816 "game-window.c"
	}
#line 156 "../src/game-window.vala"
	g_settings_set_boolean (*_settings, "window-maximized", _tmp0_);
#line 157 "../src/game-window.vala"
	g_settings_apply (*_settings);
#line 822 "game-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/game-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 830 "game-window.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 167 "../src/game-window.vala"
	dup = g_new0 (gint, 1);
#line 167 "../src/game-window.vala"
	memcpy (dup, self, sizeof (gint));
#line 167 "../src/game-window.vala"
	return dup;
#line 843 "game-window.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 167 "../src/game-window.vala"
	return self ? _int_dup (self) : NULL;
#line 851 "game-window.c"
}

static void
game_window_size_allocate_cb (GtkWidget* widget,
                              GtkAllocation* allocation)
{
	GameWindow* _this = NULL;
	GameWindow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GameWindow* _tmp3_;
	gint* window_width = NULL;
	gint* window_height = NULL;
	GameWindow* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_;
	gint* _tmp10_;
	gint _tmp11_;
	gint* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint* _tmp14_;
	GameWindow* _tmp16_;
	gint* _tmp17_;
	GameWindow* _tmp18_;
	gint* _tmp19_;
#line 160 "../src/game-window.vala"
	g_return_if_fail (widget != NULL);
#line 160 "../src/game-window.vala"
	g_return_if_fail (allocation != NULL);
#line 162 "../src/game-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, TYPE_GAME_WINDOW, GameWindow));
#line 162 "../src/game-window.vala"
	_this = _tmp0_;
#line 163 "../src/game-window.vala"
	_tmp3_ = _this;
#line 163 "../src/game-window.vala"
	if (_tmp3_->priv->_window_maximized) {
#line 163 "../src/game-window.vala"
		_tmp2_ = TRUE;
#line 892 "game-window.c"
	} else {
		GameWindow* _tmp4_;
#line 163 "../src/game-window.vala"
		_tmp4_ = _this;
#line 163 "../src/game-window.vala"
		_tmp2_ = _tmp4_->priv->_window_is_tiled;
#line 899 "game-window.c"
	}
#line 163 "../src/game-window.vala"
	if (_tmp2_) {
#line 163 "../src/game-window.vala"
		_tmp1_ = TRUE;
#line 905 "game-window.c"
	} else {
		GameWindow* _tmp5_;
#line 163 "../src/game-window.vala"
		_tmp5_ = _this;
#line 163 "../src/game-window.vala"
		_tmp1_ = _tmp5_->priv->_window_fullscreen;
#line 912 "game-window.c"
	}
#line 163 "../src/game-window.vala"
	if (_tmp1_) {
#line 164 "../src/game-window.vala"
		_g_object_unref0 (_this);
#line 164 "../src/game-window.vala"
		return;
#line 920 "game-window.c"
	}
#line 165 "../src/game-window.vala"
	window_width = NULL;
#line 166 "../src/game-window.vala"
	window_height = NULL;
#line 167 "../src/game-window.vala"
	_tmp6_ = _this;
#line 167 "../src/game-window.vala"
	gtk_window_get_size ((GtkWindow*) _tmp6_, &_tmp7_, &_tmp8_);
#line 167 "../src/game-window.vala"
	_g_free0 (window_width);
#line 167 "../src/game-window.vala"
	_tmp9_ = _tmp7_;
#line 167 "../src/game-window.vala"
	_tmp10_ = __int_dup0 (&_tmp9_);
#line 167 "../src/game-window.vala"
	window_width = _tmp10_;
#line 167 "../src/game-window.vala"
	_g_free0 (window_height);
#line 167 "../src/game-window.vala"
	_tmp11_ = _tmp8_;
#line 167 "../src/game-window.vala"
	_tmp12_ = __int_dup0 (&_tmp11_);
#line 167 "../src/game-window.vala"
	window_height = _tmp12_;
#line 168 "../src/game-window.vala"
	_tmp14_ = window_width;
#line 168 "../src/game-window.vala"
	if (_tmp14_ == NULL) {
#line 168 "../src/game-window.vala"
		_tmp13_ = TRUE;
#line 952 "game-window.c"
	} else {
		gint* _tmp15_;
#line 168 "../src/game-window.vala"
		_tmp15_ = window_height;
#line 168 "../src/game-window.vala"
		_tmp13_ = _tmp15_ == NULL;
#line 959 "game-window.c"
	}
#line 168 "../src/game-window.vala"
	if (_tmp13_) {
#line 169 "../src/game-window.vala"
		_g_free0 (window_height);
#line 169 "../src/game-window.vala"
		_g_free0 (window_width);
#line 169 "../src/game-window.vala"
		_g_object_unref0 (_this);
#line 169 "../src/game-window.vala"
		return;
#line 971 "game-window.c"
	}
#line 170 "../src/game-window.vala"
	_tmp16_ = _this;
#line 170 "../src/game-window.vala"
	_tmp17_ = window_width;
#line 170 "../src/game-window.vala"
	_tmp16_->priv->_window_width = (gint) (*_tmp17_);
#line 171 "../src/game-window.vala"
	_tmp18_ = _this;
#line 171 "../src/game-window.vala"
	_tmp19_ = window_height;
#line 171 "../src/game-window.vala"
	_tmp18_->priv->_window_height = (gint) (*_tmp19_);
#line 160 "../src/game-window.vala"
	_g_free0 (window_height);
#line 160 "../src/game-window.vala"
	_g_free0 (window_width);
#line 160 "../src/game-window.vala"
	_g_object_unref0 (_this);
#line 991 "game-window.c"
}

static gboolean
game_window_state_event_cb (GtkWidget* widget,
                            GdkEventWindowState* event)
{
	gboolean result = FALSE;
	GameWindow* _this = NULL;
	GameWindow* _tmp0_;
	GdkWindowState _tmp1_;
	gboolean window_fullscreen = FALSE;
	GameWindow* _tmp4_;
	GdkWindowState _tmp5_;
	gboolean _tmp8_ = FALSE;
	GdkWindowState tiled_state = 0U;
	GdkWindowState _tmp16_;
	GdkWindowState _tmp17_;
#line 174 "../src/game-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 174 "../src/game-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 176 "../src/game-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, TYPE_GAME_WINDOW, GameWindow));
#line 176 "../src/game-window.vala"
	_this = _tmp0_;
#line 177 "../src/game-window.vala"
	_tmp1_ = event->changed_mask;
#line 177 "../src/game-window.vala"
	if ((_tmp1_ & GDK_WINDOW_STATE_MAXIMIZED) != 0) {
#line 1021 "game-window.c"
		GameWindow* _tmp2_;
		GdkWindowState _tmp3_;
#line 178 "../src/game-window.vala"
		_tmp2_ = _this;
#line 178 "../src/game-window.vala"
		_tmp3_ = event->new_window_state;
#line 178 "../src/game-window.vala"
		_tmp2_->priv->_window_maximized = (_tmp3_ & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 1030 "game-window.c"
	}
#line 181 "../src/game-window.vala"
	_tmp4_ = _this;
#line 181 "../src/game-window.vala"
	window_fullscreen = _tmp4_->priv->_window_fullscreen;
#line 182 "../src/game-window.vala"
	_tmp5_ = event->changed_mask;
#line 182 "../src/game-window.vala"
	if ((_tmp5_ & GDK_WINDOW_STATE_FULLSCREEN) != 0) {
#line 1040 "game-window.c"
		GameWindow* _tmp6_;
		GdkWindowState _tmp7_;
#line 183 "../src/game-window.vala"
		_tmp6_ = _this;
#line 183 "../src/game-window.vala"
		_tmp7_ = event->new_window_state;
#line 183 "../src/game-window.vala"
		_tmp6_->priv->_window_fullscreen = (_tmp7_ & GDK_WINDOW_STATE_FULLSCREEN) != 0;
#line 1049 "game-window.c"
	}
#line 184 "../src/game-window.vala"
	if (window_fullscreen) {
#line 1053 "game-window.c"
		GameWindow* _tmp9_;
#line 184 "../src/game-window.vala"
		_tmp9_ = _this;
#line 184 "../src/game-window.vala"
		_tmp8_ = !_tmp9_->priv->_window_fullscreen;
#line 1059 "game-window.c"
	} else {
#line 184 "../src/game-window.vala"
		_tmp8_ = FALSE;
#line 1063 "game-window.c"
	}
#line 184 "../src/game-window.vala"
	if (_tmp8_) {
#line 1067 "game-window.c"
		GameWindow* _tmp10_;
		GtkButton* _tmp11_;
#line 185 "../src/game-window.vala"
		_tmp10_ = _this;
#line 185 "../src/game-window.vala"
		_tmp11_ = _tmp10_->priv->_unfullscreen_button;
#line 185 "../src/game-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 1076 "game-window.c"
	} else {
		gboolean _tmp12_ = FALSE;
#line 186 "../src/game-window.vala"
		if (!window_fullscreen) {
#line 1081 "game-window.c"
			GameWindow* _tmp13_;
#line 186 "../src/game-window.vala"
			_tmp13_ = _this;
#line 186 "../src/game-window.vala"
			_tmp12_ = _tmp13_->priv->_window_fullscreen;
#line 1087 "game-window.c"
		} else {
#line 186 "../src/game-window.vala"
			_tmp12_ = FALSE;
#line 1091 "game-window.c"
		}
#line 186 "../src/game-window.vala"
		if (_tmp12_) {
#line 1095 "game-window.c"
			GameWindow* _tmp14_;
			GtkButton* _tmp15_;
#line 187 "../src/game-window.vala"
			_tmp14_ = _this;
#line 187 "../src/game-window.vala"
			_tmp15_ = _tmp14_->priv->_unfullscreen_button;
#line 187 "../src/game-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp15_);
#line 1104 "game-window.c"
		}
	}
#line 190 "../src/game-window.vala"
	tiled_state = (((GDK_WINDOW_STATE_TILED | GDK_WINDOW_STATE_TOP_TILED) | GDK_WINDOW_STATE_BOTTOM_TILED) | GDK_WINDOW_STATE_LEFT_TILED) | GDK_WINDOW_STATE_RIGHT_TILED;
#line 195 "../src/game-window.vala"
	_tmp16_ = event->changed_mask;
#line 195 "../src/game-window.vala"
	_tmp17_ = tiled_state;
#line 195 "../src/game-window.vala"
	if ((_tmp16_ & _tmp17_) != 0) {
#line 1115 "game-window.c"
		GameWindow* _tmp18_;
		GdkWindowState _tmp19_;
		GdkWindowState _tmp20_;
#line 196 "../src/game-window.vala"
		_tmp18_ = _this;
#line 196 "../src/game-window.vala"
		_tmp19_ = event->new_window_state;
#line 196 "../src/game-window.vala"
		_tmp20_ = tiled_state;
#line 196 "../src/game-window.vala"
		_tmp18_->priv->_window_is_tiled = (_tmp19_ & _tmp20_) != 0;
#line 1127 "game-window.c"
	}
#line 198 "../src/game-window.vala"
	result = FALSE;
#line 198 "../src/game-window.vala"
	_g_object_unref0 (_this);
#line 198 "../src/game-window.vala"
	return result;
#line 1135 "game-window.c"
}

static void
_game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
#line 207 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/game-window.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 209 "../src/game-window.vala"
	action_group = _tmp0_;
#line 210 "../src/game-window.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW__ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW__ui_action_entries), self);
#line 211 "../src/game-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
#line 213 "../src/game-window.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
#line 213 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 213 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 213 "../src/game-window.vala"
	self->priv->undo_action = _tmp2_;
#line 214 "../src/game-window.vala"
	_tmp3_ = self->priv->undo_action;
#line 214 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp3_, FALSE);
#line 207 "../src/game-window.vala"
	_g_object_unref0 (action_group);
#line 1170 "game-window.c"
}

static void
game_window_undo_cb (GameWindow* self)
{
	GSettings* _tmp0_;
	GameHeaderBar* _tmp1_;
	Game* _tmp2_;
	GtkClutterEmbed* _tmp3_;
#line 233 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/game-window.vala"
	_tmp0_ = self->priv->_settings;
#line 235 "../src/game-window.vala"
	if (!g_settings_get_boolean (_tmp0_, "allow-undo")) {
#line 236 "../src/game-window.vala"
		return;
#line 1188 "game-window.c"
	}
#line 238 "../src/game-window.vala"
	_tmp1_ = self->priv->_header_bar;
#line 238 "../src/game-window.vala"
	game_header_bar_clear_subtitle (_tmp1_);
#line 239 "../src/game-window.vala"
	_tmp2_ = self->priv->_game;
#line 239 "../src/game-window.vala"
	game_undo (_tmp2_);
#line 240 "../src/game-window.vala"
	_tmp3_ = self->priv->_embed;
#line 240 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 1202 "game-window.c"
}

static void
game_window_new_game_cb (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
	Game* _tmp1_;
	GtkClutterEmbed* _tmp2_;
#line 243 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/game-window.vala"
	_tmp0_ = self->priv->_header_bar;
#line 245 "../src/game-window.vala"
	game_header_bar_clear_subtitle (_tmp0_);
#line 246 "../src/game-window.vala"
	_tmp1_ = self->priv->_game;
#line 246 "../src/game-window.vala"
	game_new_game (_tmp1_, &self->priv->_settings);
#line 247 "../src/game-window.vala"
	_tmp2_ = self->priv->_embed;
#line 247 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1225 "game-window.c"
}

static void
game_window_new_game_sized_cb (GameWindow* self,
                               GSimpleAction* action,
                               GVariant* variant)
{
	gint rows = 0;
	gint cols = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
#line 250 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/game-window.vala"
	g_return_if_fail (action != NULL);
#line 250 "../src/game-window.vala"
	_vala_return_if_fail (variant != NULL, "variant != null");
#line 254 "../src/game-window.vala"
	g_variant_get ((GVariant*) variant, "(ii)", &_tmp0_, &_tmp1_, NULL);
#line 254 "../src/game-window.vala"
	rows = _tmp0_;
#line 254 "../src/game-window.vala"
	cols = _tmp1_;
#line 255 "../src/game-window.vala"
	_tmp2_ = self->priv->_settings;
#line 255 "../src/game-window.vala"
	g_settings_delay (_tmp2_);
#line 256 "../src/game-window.vala"
	_tmp3_ = self->priv->_settings;
#line 256 "../src/game-window.vala"
	g_settings_set_int (_tmp3_, "rows", rows);
#line 257 "../src/game-window.vala"
	_tmp4_ = self->priv->_settings;
#line 257 "../src/game-window.vala"
	g_settings_set_int (_tmp4_, "cols", cols);
#line 258 "../src/game-window.vala"
	_tmp5_ = self->priv->_settings;
#line 258 "../src/game-window.vala"
	g_settings_apply (_tmp5_);
#line 260 "../src/game-window.vala"
	game_window_new_game_cb (self);
#line 1271 "game-window.c"
}

static void
game_window_toggle_new_game_cb (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 263 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/game-window.vala"
	_tmp0_ = self->priv->_header_bar;
#line 265 "../src/game-window.vala"
	game_header_bar_toggle_new_game (_tmp0_);
#line 1284 "game-window.c"
}

static void
game_window_toggle_hamburger_menu (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 268 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/game-window.vala"
	_tmp0_ = self->priv->_header_bar;
#line 270 "../src/game-window.vala"
	game_header_bar_toggle_hamburger_menu (_tmp0_);
#line 1297 "game-window.c"
}

static gboolean
_game_window_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                            GdkEventKey* event,
                                                            gpointer self)
{
	gboolean result;
	result = game_window_key_press_event_cb (_sender, event);
#line 284 "../src/game-window.vala"
	return result;
#line 1309 "game-window.c"
}

static inline void
_game_window_init_keyboard (GameWindow* self)
{
#line 282 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/game-window.vala"
	g_signal_connect ((GtkWidget*) self, "key-press-event", (GCallback) _game_window_key_press_event_cb_gtk_widget_key_press_event, NULL);
#line 1319 "game-window.c"
}

static gboolean
game_window_key_press_event_cb (GtkWidget* widget,
                                GdkEventKey* event)
{
	gboolean result = FALSE;
	GameWindow* _this = NULL;
	GameWindow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GameWindow* _tmp2_;
	GameHeaderBar* _tmp3_;
	GameWindow* _tmp12_;
	Game* _tmp13_;
#line 287 "../src/game-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 287 "../src/game-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 289 "../src/game-window.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, TYPE_GAME_WINDOW, GameWindow));
#line 289 "../src/game-window.vala"
	_this = _tmp0_;
#line 290 "../src/game-window.vala"
	_tmp2_ = _this;
#line 290 "../src/game-window.vala"
	_tmp3_ = _tmp2_->priv->_header_bar;
#line 290 "../src/game-window.vala"
	if (game_header_bar_has_popover (_tmp3_)) {
#line 290 "../src/game-window.vala"
		_tmp1_ = TRUE;
#line 1350 "game-window.c"
	} else {
		gboolean _tmp4_ = FALSE;
		GameWindow* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 290 "../src/game-window.vala"
		_tmp5_ = _this;
#line 290 "../src/game-window.vala"
		_tmp6_ = gtk_window_get_focus_visible ((GtkWindow*) _tmp5_);
#line 290 "../src/game-window.vala"
		_tmp7_ = _tmp6_;
#line 290 "../src/game-window.vala"
		if (_tmp7_) {
#line 1364 "game-window.c"
			GameWindow* _tmp8_;
			GtkClutterEmbed* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 290 "../src/game-window.vala"
			_tmp8_ = _this;
#line 290 "../src/game-window.vala"
			_tmp9_ = _tmp8_->priv->_embed;
#line 290 "../src/game-window.vala"
			g_object_get ((GtkWidget*) _tmp9_, "is-focus", &_tmp10_, NULL);
#line 290 "../src/game-window.vala"
			_tmp11_ = _tmp10_;
#line 290 "../src/game-window.vala"
			_tmp4_ = !_tmp11_;
#line 1379 "game-window.c"
		} else {
#line 290 "../src/game-window.vala"
			_tmp4_ = FALSE;
#line 1383 "game-window.c"
		}
#line 290 "../src/game-window.vala"
		_tmp1_ = _tmp4_;
#line 1387 "game-window.c"
	}
#line 290 "../src/game-window.vala"
	if (_tmp1_) {
#line 291 "../src/game-window.vala"
		result = FALSE;
#line 291 "../src/game-window.vala"
		_g_object_unref0 (_this);
#line 291 "../src/game-window.vala"
		return result;
#line 1397 "game-window.c"
	}
#line 292 "../src/game-window.vala"
	_tmp12_ = _this;
#line 292 "../src/game-window.vala"
	_tmp13_ = _tmp12_->priv->_game;
#line 292 "../src/game-window.vala"
	if (game_cannot_move (_tmp13_)) {
#line 293 "../src/game-window.vala"
		result = FALSE;
#line 293 "../src/game-window.vala"
		_g_object_unref0 (_this);
#line 293 "../src/game-window.vala"
		return result;
#line 1411 "game-window.c"
	}
#line 295 "../src/game-window.vala"
	switch (event->hardware_keycode) {
#line 295 "../src/game-window.vala"
		case GAME_WINDOW_KEYCODE_W:
#line 1417 "game-window.c"
		{
			GameWindow* _tmp14_;
			Game* _tmp15_;
#line 297 "../src/game-window.vala"
			_tmp14_ = _this;
#line 297 "../src/game-window.vala"
			_tmp15_ = _tmp14_->priv->_game;
#line 297 "../src/game-window.vala"
			game_move (_tmp15_, MOVE_REQUEST_UP);
#line 297 "../src/game-window.vala"
			result = TRUE;
#line 297 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 297 "../src/game-window.vala"
			return result;
#line 1433 "game-window.c"
		}
#line 295 "../src/game-window.vala"
		case GAME_WINDOW_KEYCODE_A:
#line 1437 "game-window.c"
		{
			GameWindow* _tmp16_;
			Game* _tmp17_;
#line 298 "../src/game-window.vala"
			_tmp16_ = _this;
#line 298 "../src/game-window.vala"
			_tmp17_ = _tmp16_->priv->_game;
#line 298 "../src/game-window.vala"
			game_move (_tmp17_, MOVE_REQUEST_LEFT);
#line 298 "../src/game-window.vala"
			result = TRUE;
#line 298 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 298 "../src/game-window.vala"
			return result;
#line 1453 "game-window.c"
		}
#line 295 "../src/game-window.vala"
		case GAME_WINDOW_KEYCODE_S:
#line 1457 "game-window.c"
		{
			GameWindow* _tmp18_;
			Game* _tmp19_;
#line 299 "../src/game-window.vala"
			_tmp18_ = _this;
#line 299 "../src/game-window.vala"
			_tmp19_ = _tmp18_->priv->_game;
#line 299 "../src/game-window.vala"
			game_move (_tmp19_, MOVE_REQUEST_DOWN);
#line 299 "../src/game-window.vala"
			result = TRUE;
#line 299 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 299 "../src/game-window.vala"
			return result;
#line 1473 "game-window.c"
		}
#line 295 "../src/game-window.vala"
		case GAME_WINDOW_KEYCODE_D:
#line 1477 "game-window.c"
		{
			GameWindow* _tmp20_;
			Game* _tmp21_;
#line 300 "../src/game-window.vala"
			_tmp20_ = _this;
#line 300 "../src/game-window.vala"
			_tmp21_ = _tmp20_->priv->_game;
#line 300 "../src/game-window.vala"
			game_move (_tmp21_, MOVE_REQUEST_RIGHT);
#line 300 "../src/game-window.vala"
			result = TRUE;
#line 300 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 300 "../src/game-window.vala"
			return result;
#line 1493 "game-window.c"
		}
		default:
#line 295 "../src/game-window.vala"
		break;
#line 1498 "game-window.c"
	}
#line 302 "../src/game-window.vala"
	switch (_game_window_upper_key (event->keyval)) {
#line 302 "../src/game-window.vala"
		case GDK_KEY_Up:
#line 1504 "game-window.c"
		{
			GameWindow* _tmp22_;
			Game* _tmp23_;
#line 304 "../src/game-window.vala"
			_tmp22_ = _this;
#line 304 "../src/game-window.vala"
			_tmp23_ = _tmp22_->priv->_game;
#line 304 "../src/game-window.vala"
			game_move (_tmp23_, MOVE_REQUEST_UP);
#line 304 "../src/game-window.vala"
			result = TRUE;
#line 304 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 304 "../src/game-window.vala"
			return result;
#line 1520 "game-window.c"
		}
#line 302 "../src/game-window.vala"
		case GDK_KEY_Left:
#line 1524 "game-window.c"
		{
			GameWindow* _tmp24_;
			Game* _tmp25_;
#line 305 "../src/game-window.vala"
			_tmp24_ = _this;
#line 305 "../src/game-window.vala"
			_tmp25_ = _tmp24_->priv->_game;
#line 305 "../src/game-window.vala"
			game_move (_tmp25_, MOVE_REQUEST_LEFT);
#line 305 "../src/game-window.vala"
			result = TRUE;
#line 305 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 305 "../src/game-window.vala"
			return result;
#line 1540 "game-window.c"
		}
#line 302 "../src/game-window.vala"
		case GDK_KEY_Down:
#line 1544 "game-window.c"
		{
			GameWindow* _tmp26_;
			Game* _tmp27_;
#line 306 "../src/game-window.vala"
			_tmp26_ = _this;
#line 306 "../src/game-window.vala"
			_tmp27_ = _tmp26_->priv->_game;
#line 306 "../src/game-window.vala"
			game_move (_tmp27_, MOVE_REQUEST_DOWN);
#line 306 "../src/game-window.vala"
			result = TRUE;
#line 306 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 306 "../src/game-window.vala"
			return result;
#line 1560 "game-window.c"
		}
#line 302 "../src/game-window.vala"
		case GDK_KEY_Right:
#line 1564 "game-window.c"
		{
			GameWindow* _tmp28_;
			Game* _tmp29_;
#line 307 "../src/game-window.vala"
			_tmp28_ = _this;
#line 307 "../src/game-window.vala"
			_tmp29_ = _tmp28_->priv->_game;
#line 307 "../src/game-window.vala"
			game_move (_tmp29_, MOVE_REQUEST_RIGHT);
#line 307 "../src/game-window.vala"
			result = TRUE;
#line 307 "../src/game-window.vala"
			_g_object_unref0 (_this);
#line 307 "../src/game-window.vala"
			return result;
#line 1580 "game-window.c"
		}
		default:
#line 302 "../src/game-window.vala"
		break;
#line 1585 "game-window.c"
	}
#line 309 "../src/game-window.vala"
	result = FALSE;
#line 309 "../src/game-window.vala"
	_g_object_unref0 (_this);
#line 309 "../src/game-window.vala"
	return result;
#line 1593 "game-window.c"
}

static inline guint
_game_window_upper_key (guint keyval)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 314 "../src/game-window.vala"
	if (keyval > ((guint) 255)) {
#line 314 "../src/game-window.vala"
		_tmp0_ = keyval;
#line 1605 "game-window.c"
	} else {
#line 314 "../src/game-window.vala"
		_tmp0_ = (guint) g_ascii_toupper ((gchar) keyval);
#line 1609 "game-window.c"
	}
#line 314 "../src/game-window.vala"
	result = _tmp0_;
#line 314 "../src/game-window.vala"
	return result;
#line 1615 "game-window.c"
}

static void
__game_window_on_swipe_gtk_gesture_swipe_swipe (GtkGestureSwipe* _sender,
                                                gdouble velocity_x,
                                                gdouble velocity_y,
                                                gpointer self)
{
#line 327 "../src/game-window.vala"
	_game_window_on_swipe ((GameWindow*) self, _sender, velocity_x, velocity_y);
#line 1626 "game-window.c"
}

static inline void
_game_window_init_gestures (GameWindow* self)
{
	GtkClutterEmbed* _tmp0_;
	GtkGestureSwipe* _tmp1_;
	GtkGestureSwipe* _tmp2_;
	GtkGestureSwipe* _tmp3_;
	GtkGestureSwipe* _tmp4_;
#line 322 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/game-window.vala"
	_tmp0_ = self->priv->_embed;
#line 324 "../src/game-window.vala"
	_tmp1_ = (GtkGestureSwipe*) gtk_gesture_swipe_new ((GtkWidget*) _tmp0_);
#line 324 "../src/game-window.vala"
	_g_object_unref0 (self->priv->gesture);
#line 324 "../src/game-window.vala"
	self->priv->gesture = _tmp1_;
#line 325 "../src/game-window.vala"
	_tmp2_ = self->priv->gesture;
#line 325 "../src/game-window.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp2_, GTK_PHASE_CAPTURE);
#line 326 "../src/game-window.vala"
	_tmp3_ = self->priv->gesture;
#line 326 "../src/game-window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp3_, (guint) 0);
#line 327 "../src/game-window.vala"
	_tmp4_ = self->priv->gesture;
#line 327 "../src/game-window.vala"
	g_signal_connect_object (_tmp4_, "swipe", (GCallback) __game_window_on_swipe_gtk_gesture_swipe_swipe, self, 0);
#line 1659 "game-window.c"
}

static inline void
_game_window_on_swipe (GameWindow* self,
                       GtkGestureSwipe* gesture,
                       gdouble velocity_x,
                       gdouble velocity_y)
{
	Game* _tmp0_;
	gdouble abs_x = 0.0;
	gdouble abs_y = 0.0;
	gboolean left_or_right = FALSE;
	gboolean up_or_down = FALSE;
#line 330 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/game-window.vala"
	g_return_if_fail (gesture != NULL);
#line 332 "../src/game-window.vala"
	_tmp0_ = self->priv->_game;
#line 332 "../src/game-window.vala"
	if (game_cannot_move (_tmp0_)) {
#line 333 "../src/game-window.vala"
		return;
#line 1683 "game-window.c"
	}
#line 335 "../src/game-window.vala"
	abs_x = fabs (velocity_x);
#line 336 "../src/game-window.vala"
	abs_y = fabs (velocity_y);
#line 337 "../src/game-window.vala"
	if (((abs_x * abs_x) + (abs_y * abs_y)) < 400.0) {
#line 338 "../src/game-window.vala"
		return;
#line 1693 "game-window.c"
	}
#line 339 "../src/game-window.vala"
	left_or_right = (abs_y * 4.0) < abs_x;
#line 340 "../src/game-window.vala"
	up_or_down = (abs_x * 4.0) < abs_y;
#line 341 "../src/game-window.vala"
	if (left_or_right) {
#line 343 "../src/game-window.vala"
		if (velocity_x < (-10.0)) {
#line 1703 "game-window.c"
			Game* _tmp1_;
#line 344 "../src/game-window.vala"
			_tmp1_ = self->priv->_game;
#line 344 "../src/game-window.vala"
			game_move (_tmp1_, MOVE_REQUEST_LEFT);
#line 1709 "game-window.c"
		} else {
#line 345 "../src/game-window.vala"
			if (velocity_x > 10.0) {
#line 1713 "game-window.c"
				Game* _tmp2_;
#line 346 "../src/game-window.vala"
				_tmp2_ = self->priv->_game;
#line 346 "../src/game-window.vala"
				game_move (_tmp2_, MOVE_REQUEST_RIGHT);
#line 1719 "game-window.c"
			}
		}
	} else {
#line 348 "../src/game-window.vala"
		if (up_or_down) {
#line 350 "../src/game-window.vala"
			if (velocity_y < (-10.0)) {
#line 1727 "game-window.c"
				Game* _tmp3_;
#line 351 "../src/game-window.vala"
				_tmp3_ = self->priv->_game;
#line 351 "../src/game-window.vala"
				game_move (_tmp3_, MOVE_REQUEST_UP);
#line 1733 "game-window.c"
			} else {
#line 352 "../src/game-window.vala"
				if (velocity_y > 10.0) {
#line 1737 "game-window.c"
					Game* _tmp4_;
#line 353 "../src/game-window.vala"
					_tmp4_ = self->priv->_game;
#line 353 "../src/game-window.vala"
					game_move (_tmp4_, MOVE_REQUEST_DOWN);
#line 1743 "game-window.c"
				}
			}
		} else {
#line 356 "../src/game-window.vala"
			return;
#line 1749 "game-window.c"
		}
	}
}

static void
__lambda6_ (GameWindow* self,
            gint response_id)
{
	GtkMessageDialog* _tmp0_;
#line 374 "../src/game-window.vala"
	if (response_id == 0) {
#line 375 "../src/game-window.vala"
		game_window_new_game_cb (self);
#line 1763 "game-window.c"
	}
#line 376 "../src/game-window.vala"
	_tmp0_ = self->priv->_congrats_dialog;
#line 376 "../src/game-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 1769 "game-window.c"
}

static void
___lambda6__gtk_dialog_response (GtkDialog* _sender,
                                 gint response_id,
                                 gpointer self)
{
#line 373 "../src/game-window.vala"
	__lambda6_ ((GameWindow*) self, response_id);
#line 1779 "game-window.c"
}

static gboolean
__lambda7_ (GameWindow* self,
            GdkEventAny* response_id)
{
	gboolean result = FALSE;
	GtkMessageDialog* _tmp0_;
#line 378 "../src/game-window.vala"
	g_return_val_if_fail (response_id != NULL, FALSE);
#line 379 "../src/game-window.vala"
	_tmp0_ = self->priv->_congrats_dialog;
#line 379 "../src/game-window.vala"
	result = gtk_widget_hide_on_delete ((GtkWidget*) _tmp0_);
#line 379 "../src/game-window.vala"
	return result;
#line 1796 "game-window.c"
}

static gboolean
___lambda7__gtk_widget_delete_event (GtkWidget* _sender,
                                     GdkEventAny* event,
                                     gpointer self)
{
	gboolean result;
	result = __lambda7_ ((GameWindow*) self, event);
#line 378 "../src/game-window.vala"
	return result;
#line 1808 "game-window.c"
}

static inline void
_game_window_create_congrats_dialog (GameWindow* self)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GObject* _tmp1_;
	GtkMessageDialog* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
#line 366 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/game-window.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/org/gnome/TwentyFortyEight/ui/congrats.ui");
#line 368 "../src/game-window.vala"
	builder = _tmp0_;
#line 370 "../src/game-window.vala"
	_tmp1_ = gtk_builder_get_object (builder, "congratsdialog");
#line 370 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_message_dialog_get_type (), GtkMessageDialog));
#line 370 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_congrats_dialog);
#line 370 "../src/game-window.vala"
	self->priv->_congrats_dialog = _tmp2_;
#line 371 "../src/game-window.vala"
	_tmp3_ = self->priv->_congrats_dialog;
#line 371 "../src/game-window.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, (GtkWindow*) self);
#line 373 "../src/game-window.vala"
	_tmp4_ = self->priv->_congrats_dialog;
#line 373 "../src/game-window.vala"
	g_signal_connect_object ((GtkDialog*) _tmp4_, "response", (GCallback) ___lambda6__gtk_dialog_response, self, 0);
#line 378 "../src/game-window.vala"
	_tmp5_ = self->priv->_congrats_dialog;
#line 378 "../src/game-window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "delete-event", (GCallback) ___lambda7__gtk_widget_delete_event, self, 0);
#line 366 "../src/game-window.vala"
	_g_object_unref0 (builder);
#line 1849 "game-window.c"
}

static inline void
game_window_target_value_reached_cb (GameWindow* self,
                                     guint target_value)
{
	GSettings* _tmp0_;
#line 383 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 385 "../src/game-window.vala"
	_tmp0_ = self->priv->_settings;
#line 385 "../src/game-window.vala"
	if (g_settings_get_boolean (_tmp0_, "do-congrat")) {
#line 1863 "game-window.c"
		GtkMessageDialog* _tmp1_;
		GtkMessageDialog* _tmp2_;
		GSettings* _tmp3_;
#line 387 "../src/game-window.vala"
		if (self->priv->_should_create_congrats_dialog) {
#line 389 "../src/game-window.vala"
			_game_window_create_congrats_dialog (self);
#line 390 "../src/game-window.vala"
			self->priv->_should_create_congrats_dialog = FALSE;
#line 1873 "game-window.c"
		}
#line 394 "../src/game-window.vala"
		_tmp1_ = self->priv->_congrats_dialog;
#line 394 "../src/game-window.vala"
		gtk_message_dialog_format_secondary_text (_tmp1_, _ ("You have obtained the %u tile for the first time!"), target_value);
#line 395 "../src/game-window.vala"
		_tmp2_ = self->priv->_congrats_dialog;
#line 395 "../src/game-window.vala"
		gtk_window_present ((GtkWindow*) _tmp2_);
#line 396 "../src/game-window.vala"
		_tmp3_ = self->priv->_settings;
#line 396 "../src/game-window.vala"
		g_settings_set_boolean (_tmp3_, "do-congrat", FALSE);
#line 1887 "game-window.c"
	}
#line 398 "../src/game-window.vala"
	g_debug ("game-window.vala:398: target value reached");
#line 1891 "game-window.c"
}

static GamesScoresCategory*
_game_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                          gpointer self)
{
	GamesScoresCategory* result;
	result = game_window_category_request ((GameWindow*) self, category_key);
#line 422 "../src/game-window.vala"
	return result;
#line 1902 "game-window.c"
}

static inline void
_game_window_create_scores_dialog (GameWindow* self)
{
	GamesScoresCategory* _tmp0_;
	GamesScoresCategory* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GamesScoresContext* _tmp3_;
#line 410 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/game-window.vala"
	_tmp0_ = games_scores_category_new ("grid3", _ ("Grid 3 × 3"));
#line 413 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid3_cat);
#line 413 "../src/game-window.vala"
	self->priv->_grid3_cat = _tmp0_;
#line 416 "../src/game-window.vala"
	_tmp1_ = games_scores_category_new ("grid4", _ ("Grid 4 × 4"));
#line 416 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid4_cat);
#line 416 "../src/game-window.vala"
	self->priv->_grid4_cat = _tmp1_;
#line 419 "../src/game-window.vala"
	_tmp2_ = games_scores_category_new ("grid5", _ ("Grid 5 × 5"));
#line 419 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid5_cat);
#line 419 "../src/game-window.vala"
	self->priv->_grid5_cat = _tmp2_;
#line 422 "../src/game-window.vala"
	_tmp3_ = games_scores_context_new ("gnome-2048", _ ("Grid Size:"), (GtkWindow*) self, _game_window_category_request_games_scores_context_category_request_func, self, GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER);
#line 422 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_scores_ctx);
#line 422 "../src/game-window.vala"
	self->priv->_scores_ctx = _tmp3_;
#line 1938 "game-window.c"
}

static inline GamesScoresCategory*
game_window_category_request (GameWindow* self,
                              const gchar* key)
{
	GamesScoresCategory* result = NULL;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 426 "../src/game-window.vala"
	static GQuark _tmp1_label0 = 0;
#line 426 "../src/game-window.vala"
	static GQuark _tmp1_label1 = 0;
#line 426 "../src/game-window.vala"
	static GQuark _tmp1_label2 = 0;
#line 424 "../src/game-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 424 "../src/game-window.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 426 "../src/game-window.vala"
	_tmp0_ = key;
#line 426 "../src/game-window.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 426 "../src/game-window.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("grid4")))) {
#line 426 "../src/game-window.vala"
		switch (0) {
#line 1966 "game-window.c"
			default:
			{
				GamesScoresCategory* _tmp3_;
				GamesScoresCategory* _tmp4_;
#line 428 "../src/game-window.vala"
				_tmp3_ = self->priv->_grid4_cat;
#line 428 "../src/game-window.vala"
				_tmp4_ = _g_object_ref0 (_tmp3_);
#line 428 "../src/game-window.vala"
				result = _tmp4_;
#line 428 "../src/game-window.vala"
				return result;
#line 1979 "game-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("grid3")))) {
#line 426 "../src/game-window.vala"
		switch (0) {
#line 1985 "game-window.c"
			default:
			{
				GamesScoresCategory* _tmp5_;
				GamesScoresCategory* _tmp6_;
#line 429 "../src/game-window.vala"
				_tmp5_ = self->priv->_grid3_cat;
#line 429 "../src/game-window.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 429 "../src/game-window.vala"
				result = _tmp6_;
#line 429 "../src/game-window.vala"
				return result;
#line 1998 "game-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("grid5")))) {
#line 426 "../src/game-window.vala"
		switch (0) {
#line 2004 "game-window.c"
			default:
			{
				GamesScoresCategory* _tmp7_;
				GamesScoresCategory* _tmp8_;
#line 430 "../src/game-window.vala"
				_tmp7_ = self->priv->_grid5_cat;
#line 430 "../src/game-window.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 430 "../src/game-window.vala"
				result = _tmp8_;
#line 430 "../src/game-window.vala"
				return result;
#line 2017 "game-window.c"
			}
		}
	} else {
#line 426 "../src/game-window.vala"
		switch (0) {
#line 2023 "game-window.c"
			default:
			{
#line 431 "../src/game-window.vala"
				g_assert_not_reached ();
#line 2028 "game-window.c"
			}
		}
	}
}

static inline void
game_window_scores_cb (GameWindow* self)
{
	GamesScoresContext* _tmp0_;
#line 435 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 437 "../src/game-window.vala"
	_tmp0_ = self->priv->_scores_ctx;
#line 437 "../src/game-window.vala"
	games_scores_context_run_dialog (_tmp0_);
#line 2044 "game-window.c"
}

static void
__lambda5_ (GameWindow* self,
            GObject* object,
            GAsyncResult* _result_)
{
	GamesScoresContext* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 454 "../src/game-window.vala"
	g_return_if_fail (_result_ != NULL);
#line 2056 "game-window.c"
	{
		GamesScoresContext* _tmp0_;
#line 456 "../src/game-window.vala"
		_tmp0_ = self->priv->_scores_ctx;
#line 456 "../src/game-window.vala"
		games_scores_context_add_score_finish (_tmp0_, _result_, &_inner_error0_);
#line 456 "../src/game-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2065 "game-window.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 455 "../src/game-window.vala"
		e = _inner_error0_;
#line 455 "../src/game-window.vala"
		_inner_error0_ = NULL;
#line 458 "../src/game-window.vala"
		_tmp1_ = stderr;
#line 458 "../src/game-window.vala"
		_tmp2_ = e;
#line 458 "../src/game-window.vala"
		_tmp3_ = _tmp2_->message;
#line 458 "../src/game-window.vala"
		fprintf (_tmp1_, "%s\n", _tmp3_);
#line 455 "../src/game-window.vala"
		_g_error_free0 (e);
#line 2090 "game-window.c"
	}
	__finally4:
#line 455 "../src/game-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "../src/game-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 455 "../src/game-window.vala"
		g_clear_error (&_inner_error0_);
#line 455 "../src/game-window.vala"
		return;
#line 2101 "game-window.c"
	}
#line 460 "../src/game-window.vala"
	_tmp4_ = self->priv->_scores_ctx;
#line 460 "../src/game-window.vala"
	games_scores_context_run_dialog (_tmp4_);
#line 461 "../src/game-window.vala"
	g_debug ("game-window.vala:461: score added");
#line 2109 "game-window.c"
}

static void
___lambda5__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 454 "../src/game-window.vala"
	__lambda5_ ((GameWindow*) self, source_object, res);
#line 454 "../src/game-window.vala"
	g_object_unref (self);
#line 2121 "game-window.c"
}

static inline void
_game_window_show_best_scores (GameWindow* self)
{
	gint rows = 0;
	GSettings* _tmp0_;
	gint cols = 0;
	GSettings* _tmp1_;
	GamesScoresCategory* cat = NULL;
	GamesScoresContext* _tmp8_;
	Game* _tmp9_;
	glong _tmp10_;
	glong _tmp11_;
	GamesScoresCategory* _tmp12_;
#line 440 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/game-window.vala"
	_tmp0_ = self->priv->_settings;
#line 442 "../src/game-window.vala"
	rows = g_settings_get_int (_tmp0_, "rows");
#line 443 "../src/game-window.vala"
	_tmp1_ = self->priv->_settings;
#line 443 "../src/game-window.vala"
	cols = g_settings_get_int (_tmp1_, "cols");
#line 444 "../src/game-window.vala"
	if (rows != cols) {
#line 445 "../src/game-window.vala"
		return;
#line 2151 "game-window.c"
	}
#line 447 "../src/game-window.vala"
	switch (rows) {
#line 447 "../src/game-window.vala"
		case 4:
#line 2157 "game-window.c"
		{
			GamesScoresCategory* _tmp2_;
			GamesScoresCategory* _tmp3_;
#line 449 "../src/game-window.vala"
			_tmp2_ = self->priv->_grid4_cat;
#line 449 "../src/game-window.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 449 "../src/game-window.vala"
			_g_object_unref0 (cat);
#line 449 "../src/game-window.vala"
			cat = _tmp3_;
#line 449 "../src/game-window.vala"
			break;
#line 2171 "game-window.c"
		}
#line 447 "../src/game-window.vala"
		case 3:
#line 2175 "game-window.c"
		{
			GamesScoresCategory* _tmp4_;
			GamesScoresCategory* _tmp5_;
#line 450 "../src/game-window.vala"
			_tmp4_ = self->priv->_grid3_cat;
#line 450 "../src/game-window.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 450 "../src/game-window.vala"
			_g_object_unref0 (cat);
#line 450 "../src/game-window.vala"
			cat = _tmp5_;
#line 450 "../src/game-window.vala"
			break;
#line 2189 "game-window.c"
		}
#line 447 "../src/game-window.vala"
		case 5:
#line 2193 "game-window.c"
		{
			GamesScoresCategory* _tmp6_;
			GamesScoresCategory* _tmp7_;
#line 451 "../src/game-window.vala"
			_tmp6_ = self->priv->_grid5_cat;
#line 451 "../src/game-window.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 451 "../src/game-window.vala"
			_g_object_unref0 (cat);
#line 451 "../src/game-window.vala"
			cat = _tmp7_;
#line 451 "../src/game-window.vala"
			break;
#line 2207 "game-window.c"
		}
		default:
		{
#line 452 "../src/game-window.vala"
			_g_object_unref0 (cat);
#line 452 "../src/game-window.vala"
			return;
#line 2215 "game-window.c"
		}
	}
#line 454 "../src/game-window.vala"
	_tmp8_ = self->priv->_scores_ctx;
#line 454 "../src/game-window.vala"
	_tmp9_ = self->priv->_game;
#line 454 "../src/game-window.vala"
	_tmp10_ = game_get_score (_tmp9_);
#line 454 "../src/game-window.vala"
	_tmp11_ = _tmp10_;
#line 454 "../src/game-window.vala"
	_tmp12_ = cat;
#line 454 "../src/game-window.vala"
	games_scores_context_add_score (_tmp8_, _tmp11_, _tmp12_, NULL, ___lambda5__gasync_ready_callback, g_object_ref (self));
#line 440 "../src/game-window.vala"
	_g_object_unref0 (cat);
#line 2232 "game-window.c"
}

static void
game_window_about_cb (GameWindow* self)
{
	gchar** authors = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint authors_length1;
	gint _authors_size_;
#line 469 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 471 "../src/game-window.vala"
	_tmp0_ = g_strdup ("Juan R. García Blanco");
#line 471 "../src/game-window.vala"
	_tmp1_ = g_strdup ("Arnaud Bonatti");
#line 471 "../src/game-window.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 471 "../src/game-window.vala"
	_tmp2_[0] = _tmp0_;
#line 471 "../src/game-window.vala"
	_tmp2_[1] = _tmp1_;
#line 471 "../src/game-window.vala"
	authors = _tmp2_;
#line 471 "../src/game-window.vala"
	authors_length1 = 2;
#line 471 "../src/game-window.vala"
	_authors_size_ = authors_length1;
#line 472 "../src/game-window.vala"
	gtk_show_about_dialog ((GtkWindow*) self, "program-name", _ ("2048"), "version", VERSION, "comments", _ ("A clone of 2048 for GNOME"), "license-type", GTK_LICENSE_GPL_3_0, "copyright", _ ("Copyright \xc2\xa9 2014-2015 – Juan R. García Blanco\n" \
"Copyright \xc2\xa9 2016-2019 – Arnaud Bonatti"), "wrap-license", TRUE, "authors", authors, "translator-credits", _ ("translator-credits"), "logo-icon-name", "org.gnome.TwentyFortyEight", "website", "https://wiki.gnome.org/Apps/2048", "website-label", _ ("Page on GNOME wiki"), NULL, NULL);
#line 469 "../src/game-window.vala"
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
#line 2266 "game-window.c"
}

GameWindow*
game_window_construct (GType object_type)
{
	GameWindow * self = NULL;
#line 24 "../src/game-window.vala"
	self = (GameWindow*) g_object_new (object_type, NULL);
#line 24 "../src/game-window.vala"
	return self;
#line 2277 "game-window.c"
}

GameWindow*
game_window_new (void)
{
#line 24 "../src/game-window.vala"
	return game_window_construct (TYPE_GAME_WINDOW);
#line 2285 "game-window.c"
}

static void
_game_window___lambda12_ (GameWindow* self)
{
	GtkClutterEmbed* _tmp0_;
#line 46 "../src/game-window.vala"
	_tmp0_ = self->priv->_embed;
#line 46 "../src/game-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 2296 "game-window.c"
}

static void
__game_window___lambda12__g_object_notify (GObject* _sender,
                                           GParamSpec* pspec,
                                           gpointer self)
{
#line 46 "../src/game-window.vala"
	_game_window___lambda12_ ((GameWindow*) self);
#line 2306 "game-window.c"
}

static GObject *
game_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameWindow * self;
	GSettings* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
#line 35 "../src/game-window.vala"
	parent_class = G_OBJECT_CLASS (game_window_parent_class);
#line 35 "../src/game-window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 37 "../src/game-window.vala"
	_tmp0_ = g_settings_new ("org.gnome.TwentyFortyEight");
#line 37 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 37 "../src/game-window.vala"
	self->priv->_settings = _tmp0_;
#line 39 "../src/game-window.vala"
	_game_window_install_ui_action_entries (self);
#line 41 "../src/game-window.vala"
	_game_window_init_game (self);
#line 43 "../src/game-window.vala"
	_game_window_init_window (self);
#line 44 "../src/game-window.vala"
	_game_window_create_scores_dialog (self);
#line 46 "../src/game-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::has-toplevel-focus", (GCallback) __game_window___lambda12__g_object_notify, self, 0);
#line 47 "../src/game-window.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 49 "../src/game-window.vala"
	_tmp1_ = self->priv->_game;
#line 49 "../src/game-window.vala"
	_tmp2_ = game_restore_game (_tmp1_, &self->priv->_settings);
#line 49 "../src/game-window.vala"
	if (!_tmp2_) {
#line 50 "../src/game-window.vala"
		game_window_new_game_cb (self);
#line 2352 "game-window.c"
	}
#line 53 "../src/game-window.vala"
	_game_window_init_keyboard (self);
#line 54 "../src/game-window.vala"
	_game_window_init_gestures (self);
#line 35 "../src/game-window.vala"
	return obj;
#line 2360 "game-window.c"
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/game-window.vala"
	game_window_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/game-window.vala"
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
#line 24 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->constructor = game_window_constructor;
#line 24 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
#line 24 "../src/game-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/TwentyFortyEight/ui/game-window.ui");
#line 24 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_header_bar", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, _header_bar));
#line 24 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_embed", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, _embed));
#line 24 "../src/game-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_unfullscreen_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, _unfullscreen_button));
#line 24 "../src/game-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_destroy", G_CALLBACK(_game_window_on_destroy_gtk_widget_destroy));
#line 2385 "game-window.c"
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
#line 24 "../src/game-window.vala"
	self->priv = game_window_get_instance_private (self);
#line 365 "../src/game-window.vala"
	self->priv->_should_create_congrats_dialog = TRUE;
#line 24 "../src/game-window.vala"
	g_type_ensure (TYPE_GAME_HEADER_BAR);
#line 24 "../src/game-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2400 "game-window.c"
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
#line 24 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 26 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 28 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_header_bar);
#line 29 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_embed);
#line 31 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_unfullscreen_button);
#line 33 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_game);
#line 205 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 321 "../src/game-window.vala"
	_g_object_unref0 (self->priv->gesture);
#line 363 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_congrats_dialog);
#line 405 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_scores_ctx);
#line 406 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid4_cat);
#line 407 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid3_cat);
#line 408 "../src/game-window.vala"
	_g_object_unref0 (self->priv->_grid5_cat);
#line 24 "../src/game-window.vala"
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
#line 2435 "game-window.c"
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
		GType game_window_type_id;
		game_window_type_id = g_type_register_static (gtk_application_window_get_type (), "GameWindow", &g_define_type_info, 0);
		GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
		g_once_init_leave (&game_window_type_id__volatile, game_window_type_id);
	}
	return game_window_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

