/* game.c generated by valac 0.44.3, the Vala compiler
 * generated from game.vala, do not modify */

/* Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
 * Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of GNOME 2048.
 *
 * GNOME 2048 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME 2048 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME 2048; if not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;

#define TYPE_ROUNDED_RECTANGLE (rounded_rectangle_get_type ())
#define ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangle))
#define ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))
#define IS_ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROUNDED_RECTANGLE))
#define IS_ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROUNDED_RECTANGLE))
#define ROUNDED_RECTANGLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))

typedef struct _RoundedRectangle RoundedRectangle;
typedef struct _RoundedRectangleClass RoundedRectangleClass;

#define TYPE_TILE_VIEW (tile_view_get_type ())
#define TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE_VIEW, TileView))
#define TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE_VIEW, TileViewClass))
#define IS_TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE_VIEW))
#define IS_TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE_VIEW))
#define TILE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE_VIEW, TileViewClass))

typedef struct _TileView TileView;
typedef struct _TileViewClass TileViewClass;

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())
typedef struct _TileMovement TileMovement;

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;
typedef enum  {
	GAME_GAME_STATE_STOPPED,
	GAME_GAME_STATE_IDLE,
	GAME_GAME_STATE_MOVING,
	GAME_GAME_STATE_SHOWING_FIRST_TILE,
	GAME_GAME_STATE_SHOWING_NEW_TILE,
	GAME_GAME_STATE_RESTORING_TILES
} GameGameState;

#define GAME_TYPE_GAME_STATE (game_game_state_get_type ())
enum  {
	GAME_0_PROPERTY,
	GAME_VIEW_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())
#define _tile_movement_free0(var) ((var == NULL) ? NULL : (var = (tile_movement_free (var), NULL)))
#define _tile_free0(var) ((var == NULL) ? NULL : (var = (tile_free (var), NULL)))
enum  {
	GAME_FINISHED_SIGNAL,
	GAME_TARGET_VALUE_REACHED_SIGNAL,
	GAME_UNDO_ENABLED_SIGNAL,
	GAME_UNDO_DISABLED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GridPosition {
	gint row;
	gint col;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

struct _Tile {
	GridPosition pos;
	guint8 val;
};

struct _GamePrivate {
	gint BLANK_COL_WIDTH;
	gint BLANK_ROW_HEIGHT;
	Grid* _grid;
	RoundedRectangle** _background;
	gint _background_length1;
	gint _background_length2;
	gboolean _background_init_done;
	TileView** _foreground_cur;
	gint _foreground_cur_length1;
	gint _foreground_cur_length2;
	TileView** _foreground_nxt;
	gint _foreground_nxt_length1;
	gint _foreground_nxt_length2;
	GeeLinkedList* _to_move;
	GeeLinkedList* _to_hide;
	GeeLinkedList* _to_show;
	GameGameState _state;
	ClutterTransitionGroup* _show_hide_trans;
	ClutterTransitionGroup* _move_trans;
	gint _animations_duration;
	gchar* _saved_path;
	guint _resize_view_id;
	ClutterActor* _view;
	ClutterActor* _view_background;
	ClutterActor* _view_foreground;
	gboolean _just_restored;
	glong _score;
	guint _finish_move_id;
	gboolean _update_handled;
	gboolean _allow_undo;
	guint _undo_stack_max_size;
	GeeLinkedList* _undo_stack;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType game_get_type (void) G_GNUC_CONST;
GType grid_get_type (void) G_GNUC_CONST;
GType rounded_rectangle_get_type (void) G_GNUC_CONST;
GType tile_view_get_type (void) G_GNUC_CONST;
GType tile_movement_get_type (void) G_GNUC_CONST;
GType grid_position_get_type (void) G_GNUC_CONST;
GridPosition* grid_position_dup (const GridPosition* self);
void grid_position_free (GridPosition* self);
TileMovement* tile_movement_dup (const TileMovement* self);
void tile_movement_free (TileMovement* self);
GType tile_get_type (void) G_GNUC_CONST;
Tile* tile_dup (const Tile* self);
void tile_free (Tile* self);
static GType game_game_state_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* game_game_state_to_string (GameGameState state);
Game* game_new (GSettings* * settings);
Game* game_construct (GType object_type,
                      GSettings* * settings);
static void _game_init_grid (gint rows,
                      gint cols,
                      Grid* * grid,
                      GSettings* * settings);
Grid* grid_new (gint rows,
                gint cols);
Grid* grid_construct (GType object_type,
                      gint rows,
                      gint cols);
static void _game_on_allocation_changed (Game* self,
                                  ClutterActorBox* box,
                                  ClutterAllocationFlags flags);
static void _game_resize_view (Game* self);
static void _game_init_background (Game* self);
void game_new_game (Game* self,
                    GSettings* * settings);
static inline void _game_clean_finish_move_animation (Game* self);
void grid_clear (Grid* self);
static void _game_clear_history (Game* self);
gint grid_get_rows (Grid* self);
gint grid_get_cols (Grid* self);
static void _game_clear_foreground (Game* self);
static void _game_clear_background (Game* self);
static void game_set_score (Game* self,
                     glong value);
static void _game_create_random_tile (Game* self);
void game_save_game (Game* self);
gchar* grid_save (Grid* self);
gboolean game_restore_game (Game* self,
                            GSettings* * settings);
gboolean grid_load (Grid* self,
                    gchar* * content);
glong grid_get_score (Grid* self);
static void _game_restore_foreground (Game* self,
                               gboolean animate);
gboolean game_cannot_move (Game* self);
void game_load_settings (Game* self,
                         GSettings* * settings);
static void _game_load_undo_settings (Game* self,
                               GSettings* * settings);
RoundedRectangle* rounded_rectangle_new (gfloat x,
                                         gfloat y,
                                         gfloat width,
                                         gfloat height);
RoundedRectangle* rounded_rectangle_construct (GType object_type,
                                               gfloat x,
                                               gfloat y,
                                               gfloat width,
                                               gfloat height);
ClutterActor* rounded_rectangle_get_actor (RoundedRectangle* self);
ClutterCanvas* rounded_rectangle_get_canvas (RoundedRectangle* self);
void rounded_rectangle_resize (RoundedRectangle* self,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height);
static gboolean _game_idle_resize_view (Game* self);
static gboolean __game_idle_resize_view_gsource_func (gpointer self);
void rounded_rectangle_idle_resize (RoundedRectangle* self);
void grid_new_tile (Grid* self,
                    Tile* tile);
static void _game_create_show_hide_transition (Game* self,
                                        gboolean animate);
static void _game_create_tile (Game* self,
                        Tile* tile);
static void _game_show_tile (Game* self,
                      GridPosition* pos);
TileView* tile_view_new (gfloat x,
                         gfloat y,
                         gfloat width,
                         gfloat height,
                         guint8 val);
TileView* tile_view_construct (GType object_type,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height,
                               guint8 val);
gchar* grid_position_to_string (GridPosition *self);
static void _game_move_tile (Game* self,
                      GridPosition* from,
                      GridPosition* to);
static void _game_prepare_move_tile (Game* self,
                              GridPosition* from,
                              GridPosition* to);
static void _game_dim_tile (Game* self,
                     GridPosition* pos);
guint8 rounded_rectangle_get_color (RoundedRectangle* self);
guint8 grid_get (Grid* self,
                 gint row,
                 gint col);
GType move_request_get_type (void) G_GNUC_CONST;
void game_move (Game* self,
                MoveRequest request);
static void _game_apply_move (Game* self);
gchar* move_request_debug_string (MoveRequest request);
Grid* grid_clone (Grid* self);
static void _game_on_move_trans_stopped (Game* self,
                                  ClutterTimeline* trans,
                                  gboolean is_finished);
static void __game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                            gboolean is_finished,
                                                            gpointer self);
void grid_move (Grid* self,
                MoveRequest request,
                GeeLinkedList* * to_move,
                GeeLinkedList* * to_hide,
                GeeLinkedList* * to_show);
static void _game_store_movement (Game* self,
                           Grid* clone);
gchar* grid_to_string (Grid* self);
glong game_get_score (Game* self);
static void _game_on_show_hide_trans_stopped (Game* self,
                                       ClutterTimeline* trans,
                                       gboolean is_finished);
static void __game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                                 gboolean is_finished,
                                                                 gpointer self);
gboolean grid_get_target_value_reached (Grid* self);
guint grid_get_target_value (Grid* self);
void grid_set_target_value_reached (Grid* self,
                                    gboolean value);
static gboolean _game_finish_move (Game* self);
static gboolean __game_finish_move_gsource_func (gpointer self);
gboolean grid_is_finished (Grid* self);
void game_undo (Game* self);
ClutterActor* game_get_view (Game* self);
void game_set_view (Game* self,
                    ClutterActor* value);
static void __game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                                    ClutterActorBox* box,
                                                                    ClutterAllocationFlags flags,
                                                                    gpointer self);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

static gchar*
game_game_state_to_string (GameGameState state)
{
	gchar* result = NULL;
#line 32 "../src/game.vala"
	switch (state) {
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_STOPPED:
#line 370 "game.c"
		{
			gchar* _tmp0_;
#line 34 "../src/game.vala"
			_tmp0_ = g_strdup ("stopped");
#line 34 "../src/game.vala"
			result = _tmp0_;
#line 34 "../src/game.vala"
			return result;
#line 379 "game.c"
		}
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_IDLE:
#line 383 "game.c"
		{
			gchar* _tmp1_;
#line 35 "../src/game.vala"
			_tmp1_ = g_strdup ("idle");
#line 35 "../src/game.vala"
			result = _tmp1_;
#line 35 "../src/game.vala"
			return result;
#line 392 "game.c"
		}
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_MOVING:
#line 396 "game.c"
		{
			gchar* _tmp2_;
#line 36 "../src/game.vala"
			_tmp2_ = g_strdup ("moving");
#line 36 "../src/game.vala"
			result = _tmp2_;
#line 36 "../src/game.vala"
			return result;
#line 405 "game.c"
		}
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_SHOWING_FIRST_TILE:
#line 409 "game.c"
		{
			gchar* _tmp3_;
#line 37 "../src/game.vala"
			_tmp3_ = g_strdup ("showing first tile");
#line 37 "../src/game.vala"
			result = _tmp3_;
#line 37 "../src/game.vala"
			return result;
#line 418 "game.c"
		}
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_SHOWING_NEW_TILE:
#line 422 "game.c"
		{
			gchar* _tmp4_;
#line 38 "../src/game.vala"
			_tmp4_ = g_strdup ("showing new tile");
#line 38 "../src/game.vala"
			result = _tmp4_;
#line 38 "../src/game.vala"
			return result;
#line 431 "game.c"
		}
#line 32 "../src/game.vala"
		case GAME_GAME_STATE_RESTORING_TILES:
#line 435 "game.c"
		{
			gchar* _tmp5_;
#line 39 "../src/game.vala"
			_tmp5_ = g_strdup ("restoring tiles");
#line 39 "../src/game.vala"
			result = _tmp5_;
#line 39 "../src/game.vala"
			return result;
#line 444 "game.c"
		}
		default:
		{
#line 40 "../src/game.vala"
			g_assert_not_reached ();
#line 450 "game.c"
		}
	}
}

static GType
game_game_state_get_type (void)
{
	static volatile gsize game_game_state_type_id__volatile = 0;
	if (g_once_init_enter (&game_game_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_GAME_STATE_STOPPED, "GAME_GAME_STATE_STOPPED", "stopped"}, {GAME_GAME_STATE_IDLE, "GAME_GAME_STATE_IDLE", "idle"}, {GAME_GAME_STATE_MOVING, "GAME_GAME_STATE_MOVING", "moving"}, {GAME_GAME_STATE_SHOWING_FIRST_TILE, "GAME_GAME_STATE_SHOWING_FIRST_TILE", "showing-first-tile"}, {GAME_GAME_STATE_SHOWING_NEW_TILE, "GAME_GAME_STATE_SHOWING_NEW_TILE", "showing-new-tile"}, {GAME_GAME_STATE_RESTORING_TILES, "GAME_GAME_STATE_RESTORING_TILES", "restoring-tiles"}, {0, NULL, NULL}};
		GType game_game_state_type_id;
		game_game_state_type_id = g_enum_register_static ("GameGameState", values);
		g_once_init_leave (&game_game_state_type_id__volatile, game_game_state_type_id);
	}
	return game_game_state_type_id__volatile;
}

Game*
game_construct (GType object_type,
                GSettings* * settings)
{
	Game * self = NULL;
	gint rows = 0;
	gint cols = 0;
	Grid* _tmp0_ = NULL;
#line 68 "../src/game.vala"
	g_return_val_if_fail (*settings != NULL, NULL);
#line 68 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 70 "../src/game.vala"
	rows = g_settings_get_int (*settings, "rows");
#line 71 "../src/game.vala"
	cols = g_settings_get_int (*settings, "cols");
#line 72 "../src/game.vala"
	_game_init_grid (rows, cols, &_tmp0_, settings);
#line 72 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 72 "../src/game.vala"
	self->priv->_grid = _tmp0_;
#line 68 "../src/game.vala"
	return self;
#line 492 "game.c"
}

Game*
game_new (GSettings* * settings)
{
#line 68 "../src/game.vala"
	return game_construct (TYPE_GAME, settings);
#line 500 "game.c"
}

static void
_game_init_grid (gint rows,
                 gint cols,
                 Grid* * grid,
                 GSettings* * settings)
{
	Grid* _vala_grid = NULL;
	Grid* _tmp0_;
#line 75 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 77 "../src/game.vala"
	_tmp0_ = grid_new (rows, cols);
#line 77 "../src/game.vala"
	_g_object_unref0 (_vala_grid);
#line 77 "../src/game.vala"
	_vala_grid = _tmp0_;
#line 78 "../src/game.vala"
	g_settings_bind (*settings, "target-value", (GObject*) _vala_grid, "target-value", G_SETTINGS_BIND_DEFAULT | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 75 "../src/game.vala"
	if (grid) {
#line 75 "../src/game.vala"
		*grid = _vala_grid;
#line 525 "game.c"
	} else {
#line 75 "../src/game.vala"
		_g_object_unref0 (_vala_grid);
#line 529 "game.c"
	}
}

static void
_game_on_allocation_changed (Game* self,
                             ClutterActorBox* box,
                             ClutterAllocationFlags flags)
{
#line 104 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/game.vala"
	g_return_if_fail (box != NULL);
#line 106 "../src/game.vala"
	if (self->priv->_background_init_done) {
#line 107 "../src/game.vala"
		_game_resize_view (self);
#line 546 "game.c"
	} else {
#line 109 "../src/game.vala"
		_game_init_background (self);
#line 550 "game.c"
	}
}

void
game_new_game (Game* self,
               GSettings* * settings)
{
	gboolean _tmp0_ = FALSE;
	GameGameState _tmp1_;
	Grid* _tmp3_;
	gint rows = 0;
	gint cols = 0;
	gboolean _tmp4_ = FALSE;
	Grid* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 120 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 122 "../src/game.vala"
	_tmp1_ = self->priv->_state;
#line 122 "../src/game.vala"
	if (_tmp1_ != GAME_GAME_STATE_IDLE) {
#line 575 "game.c"
		GameGameState _tmp2_;
#line 122 "../src/game.vala"
		_tmp2_ = self->priv->_state;
#line 122 "../src/game.vala"
		_tmp0_ = _tmp2_ != GAME_GAME_STATE_STOPPED;
#line 581 "game.c"
	} else {
#line 122 "../src/game.vala"
		_tmp0_ = FALSE;
#line 585 "game.c"
	}
#line 122 "../src/game.vala"
	if (_tmp0_) {
#line 123 "../src/game.vala"
		return;
#line 591 "game.c"
	}
#line 125 "../src/game.vala"
	_game_clean_finish_move_animation (self);
#line 126 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 126 "../src/game.vala"
	grid_clear (_tmp3_);
#line 127 "../src/game.vala"
	_game_clear_history (self);
#line 129 "../src/game.vala"
	rows = g_settings_get_int (*settings, "rows");
#line 130 "../src/game.vala"
	cols = g_settings_get_int (*settings, "cols");
#line 132 "../src/game.vala"
	_tmp5_ = self->priv->_grid;
#line 132 "../src/game.vala"
	_tmp6_ = grid_get_rows (_tmp5_);
#line 132 "../src/game.vala"
	_tmp7_ = _tmp6_;
#line 132 "../src/game.vala"
	if (rows != _tmp7_) {
#line 132 "../src/game.vala"
		_tmp4_ = TRUE;
#line 615 "game.c"
	} else {
		Grid* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 132 "../src/game.vala"
		_tmp8_ = self->priv->_grid;
#line 132 "../src/game.vala"
		_tmp9_ = grid_get_cols (_tmp8_);
#line 132 "../src/game.vala"
		_tmp10_ = _tmp9_;
#line 132 "../src/game.vala"
		_tmp4_ = cols != _tmp10_;
#line 628 "game.c"
	}
#line 132 "../src/game.vala"
	if (_tmp4_) {
#line 632 "game.c"
		Grid* _tmp11_ = NULL;
#line 134 "../src/game.vala"
		_game_clear_foreground (self);
#line 135 "../src/game.vala"
		_game_clear_background (self);
#line 137 "../src/game.vala"
		_game_init_grid (rows, cols, &_tmp11_, settings);
#line 137 "../src/game.vala"
		_g_object_unref0 (self->priv->_grid);
#line 137 "../src/game.vala"
		self->priv->_grid = _tmp11_;
#line 139 "../src/game.vala"
		_game_init_background (self);
#line 646 "game.c"
	} else {
#line 141 "../src/game.vala"
		if (self->priv->_background_init_done) {
#line 142 "../src/game.vala"
			_game_clear_foreground (self);
#line 652 "game.c"
		} else {
#line 144 "../src/game.vala"
			_game_init_background (self);
#line 656 "game.c"
		}
	}
#line 146 "../src/game.vala"
	game_set_score (self, (glong) 0);
#line 147 "../src/game.vala"
	self->priv->_state = GAME_GAME_STATE_SHOWING_FIRST_TILE;
#line 148 "../src/game.vala"
	_game_create_random_tile (self);
#line 149 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 151 "../src/game.vala"
	self->priv->_just_restored = FALSE;
#line 669 "game.c"
}

void
game_save_game (Game* self)
{
	gchar* contents = NULL;
	Grid* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 154 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 156 "../src/game.vala"
	_tmp1_ = grid_save (_tmp0_);
#line 156 "../src/game.vala"
	contents = _tmp1_;
#line 687 "game.c"
	{
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 158 "../src/game.vala"
		_tmp2_ = self->priv->_saved_path;
#line 158 "../src/game.vala"
		_tmp3_ = g_path_get_dirname (_tmp2_);
#line 158 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 158 "../src/game.vala"
		g_mkdir_with_parents (_tmp4_, 0775);
#line 158 "../src/game.vala"
		_g_free0 (_tmp4_);
#line 159 "../src/game.vala"
		_tmp5_ = self->priv->_saved_path;
#line 159 "../src/game.vala"
		g_file_set_contents (_tmp5_, contents, (gssize) -1, &_inner_error0_);
#line 159 "../src/game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/game.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 711 "game.c"
				goto __catch2_g_file_error;
			}
#line 159 "../src/game.vala"
			_g_free0 (contents);
#line 159 "../src/game.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../src/game.vala"
			g_clear_error (&_inner_error0_);
#line 159 "../src/game.vala"
			return;
#line 722 "game.c"
		}
#line 160 "../src/game.vala"
		g_debug ("game.vala:160: game saved successfully");
#line 726 "game.c"
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 157 "../src/game.vala"
		e = _inner_error0_;
#line 157 "../src/game.vala"
		_inner_error0_ = NULL;
#line 162 "../src/game.vala"
		_tmp6_ = e;
#line 162 "../src/game.vala"
		_tmp7_ = _tmp6_->message;
#line 162 "../src/game.vala"
		g_warning ("game.vala:162: Failed to save game: %s", _tmp7_);
#line 157 "../src/game.vala"
		_g_error_free0 (e);
#line 746 "game.c"
	}
	__finally2:
#line 157 "../src/game.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/game.vala"
		_g_free0 (contents);
#line 157 "../src/game.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/game.vala"
		g_clear_error (&_inner_error0_);
#line 157 "../src/game.vala"
		return;
#line 759 "game.c"
	}
#line 154 "../src/game.vala"
	_g_free0 (contents);
#line 763 "game.c"
}

gboolean
game_restore_game (Game* self,
                   GSettings* * settings)
{
	gboolean result = FALSE;
	gchar* contents = NULL;
	Grid* _tmp4_;
	gboolean _tmp5_;
	Grid* _tmp6_;
	gint rows = 0;
	Grid* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint cols = 0;
	Grid* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 166 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 166 "../src/game.vala"
	g_return_val_if_fail (*settings != NULL, FALSE);
#line 792 "game.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
#line 170 "../src/game.vala"
		_tmp0_ = self->priv->_saved_path;
#line 170 "../src/game.vala"
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 170 "../src/game.vala"
		_g_free0 (contents);
#line 170 "../src/game.vala"
		contents = _tmp1_;
#line 170 "../src/game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 806 "game.c"
			gboolean _tmp2_ = FALSE;
#line 170 "../src/game.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 810 "game.c"
				goto __catch3_g_file_error;
			}
#line 170 "../src/game.vala"
			_g_free0 (contents);
#line 170 "../src/game.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/game.vala"
			g_clear_error (&_inner_error0_);
#line 170 "../src/game.vala"
			return _tmp2_;
#line 821 "game.c"
		}
	}
	goto __finally3;
	__catch3_g_file_error:
	{
		GError* e = NULL;
#line 169 "../src/game.vala"
		e = _inner_error0_;
#line 169 "../src/game.vala"
		_inner_error0_ = NULL;
#line 172 "../src/game.vala"
		result = FALSE;
#line 172 "../src/game.vala"
		_g_error_free0 (e);
#line 172 "../src/game.vala"
		_g_free0 (contents);
#line 172 "../src/game.vala"
		return result;
#line 840 "game.c"
	}
	__finally3:
#line 169 "../src/game.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 845 "game.c"
		gboolean _tmp3_ = FALSE;
#line 169 "../src/game.vala"
		_g_free0 (contents);
#line 169 "../src/game.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/game.vala"
		g_clear_error (&_inner_error0_);
#line 169 "../src/game.vala"
		return _tmp3_;
#line 855 "game.c"
	}
#line 175 "../src/game.vala"
	_tmp4_ = self->priv->_grid;
#line 175 "../src/game.vala"
	_tmp5_ = grid_load (_tmp4_, &contents);
#line 175 "../src/game.vala"
	if (!_tmp5_) {
#line 177 "../src/game.vala"
		g_warning ("game.vala:177: Failed to restore game from saved file");
#line 178 "../src/game.vala"
		result = FALSE;
#line 178 "../src/game.vala"
		_g_free0 (contents);
#line 178 "../src/game.vala"
		return result;
#line 871 "game.c"
	}
#line 181 "../src/game.vala"
	_tmp6_ = self->priv->_grid;
#line 181 "../src/game.vala"
	game_set_score (self, grid_get_score (_tmp6_));
#line 183 "../src/game.vala"
	if (self->priv->_background_init_done) {
#line 184 "../src/game.vala"
		_game_clear_background (self);
#line 881 "game.c"
	}
#line 185 "../src/game.vala"
	_game_init_background (self);
#line 186 "../src/game.vala"
	_game_restore_foreground (self, TRUE);
#line 188 "../src/game.vala"
	_tmp7_ = self->priv->_grid;
#line 188 "../src/game.vala"
	_tmp8_ = grid_get_rows (_tmp7_);
#line 188 "../src/game.vala"
	_tmp9_ = _tmp8_;
#line 188 "../src/game.vala"
	rows = _tmp9_;
#line 189 "../src/game.vala"
	_tmp10_ = self->priv->_grid;
#line 189 "../src/game.vala"
	_tmp11_ = grid_get_cols (_tmp10_);
#line 189 "../src/game.vala"
	_tmp12_ = _tmp11_;
#line 189 "../src/game.vala"
	cols = _tmp12_;
#line 190 "../src/game.vala"
	if (rows == 3) {
#line 190 "../src/game.vala"
		_tmp16_ = cols != 3;
#line 907 "game.c"
	} else {
#line 190 "../src/game.vala"
		_tmp16_ = FALSE;
#line 911 "game.c"
	}
#line 190 "../src/game.vala"
	if (_tmp16_) {
#line 190 "../src/game.vala"
		_tmp15_ = TRUE;
#line 917 "game.c"
	} else {
		gboolean _tmp17_ = FALSE;
#line 191 "../src/game.vala"
		if (rows == 4) {
#line 191 "../src/game.vala"
			_tmp17_ = cols != 4;
#line 924 "game.c"
		} else {
#line 191 "../src/game.vala"
			_tmp17_ = FALSE;
#line 928 "game.c"
		}
#line 191 "../src/game.vala"
		_tmp15_ = _tmp17_;
#line 932 "game.c"
	}
#line 190 "../src/game.vala"
	if (_tmp15_) {
#line 190 "../src/game.vala"
		_tmp14_ = TRUE;
#line 938 "game.c"
	} else {
		gboolean _tmp18_ = FALSE;
#line 192 "../src/game.vala"
		if (rows == 5) {
#line 192 "../src/game.vala"
			_tmp18_ = cols != 5;
#line 945 "game.c"
		} else {
#line 192 "../src/game.vala"
			_tmp18_ = FALSE;
#line 949 "game.c"
		}
#line 192 "../src/game.vala"
		_tmp14_ = _tmp18_;
#line 953 "game.c"
	}
#line 190 "../src/game.vala"
	if (_tmp14_) {
#line 190 "../src/game.vala"
		_tmp13_ = TRUE;
#line 959 "game.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 193 "../src/game.vala"
		if (rows != 3) {
#line 193 "../src/game.vala"
			_tmp20_ = rows != 4;
#line 967 "game.c"
		} else {
#line 193 "../src/game.vala"
			_tmp20_ = FALSE;
#line 971 "game.c"
		}
#line 193 "../src/game.vala"
		if (_tmp20_) {
#line 193 "../src/game.vala"
			_tmp19_ = rows != 5;
#line 977 "game.c"
		} else {
#line 193 "../src/game.vala"
			_tmp19_ = FALSE;
#line 981 "game.c"
		}
#line 193 "../src/game.vala"
		_tmp13_ = _tmp19_;
#line 985 "game.c"
	}
#line 190 "../src/game.vala"
	if (_tmp13_) {
#line 195 "../src/game.vala"
		g_settings_delay (*settings);
#line 196 "../src/game.vala"
		g_settings_set_int (*settings, "rows", rows);
#line 197 "../src/game.vala"
		g_settings_set_int (*settings, "cols", cols);
#line 198 "../src/game.vala"
		g_settings_apply (*settings);
#line 997 "game.c"
	}
#line 201 "../src/game.vala"
	self->priv->_just_restored = TRUE;
#line 203 "../src/game.vala"
	g_debug ("game.vala:203: game restored successfully");
#line 204 "../src/game.vala"
	result = TRUE;
#line 204 "../src/game.vala"
	_g_free0 (contents);
#line 204 "../src/game.vala"
	return result;
#line 1009 "game.c"
}

gboolean
game_cannot_move (Game* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GameGameState _tmp1_;
#line 207 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 209 "../src/game.vala"
	_tmp1_ = self->priv->_state;
#line 209 "../src/game.vala"
	if (_tmp1_ != GAME_GAME_STATE_IDLE) {
#line 1024 "game.c"
		GameGameState _tmp2_;
#line 210 "../src/game.vala"
		_tmp2_ = self->priv->_state;
#line 210 "../src/game.vala"
		_tmp0_ = _tmp2_ != GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 1030 "game.c"
	} else {
#line 209 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1034 "game.c"
	}
#line 209 "../src/game.vala"
	result = _tmp0_;
#line 209 "../src/game.vala"
	return result;
#line 1040 "game.c"
}

void
game_load_settings (Game* self,
                    GSettings* * settings)
{
#line 213 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 215 "../src/game.vala"
	self->priv->_animations_duration = (gint) g_settings_get_double (*settings, "animations-speed");
#line 216 "../src/game.vala"
	_game_load_undo_settings (self, settings);
#line 1055 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 252 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 1063 "game.c"
}

static void
_game_init_background (Game* self)
{
	gint rows = 0;
	Grid* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint cols = 0;
	Grid* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	ClutterColor background_color = {0};
	ClutterActor* _tmp6_;
	ClutterColor _tmp7_;
	RoundedRectangle** _tmp8_;
	TileView** _tmp9_;
	TileView** _tmp10_;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	gfloat tile_width = 0.0F;
	gfloat tile_height = 0.0F;
#line 219 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 221 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 221 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 221 "../src/game.vala"
	rows = _tmp2_;
#line 222 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 222 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 222 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 222 "../src/game.vala"
	cols = _tmp5_;
#line 223 "../src/game.vala"
	clutter_color_from_string (&background_color, "#babdb6");
#line 224 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 224 "../src/game.vala"
	_tmp7_ = background_color;
#line 224 "../src/game.vala"
	clutter_actor_set_background_color (_tmp6_, &_tmp7_);
#line 226 "../src/game.vala"
	_tmp8_ = g_new0 (RoundedRectangle*, (rows * cols) + 1);
#line 226 "../src/game.vala"
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
#line 226 "../src/game.vala"
	self->priv->_background = _tmp8_;
#line 226 "../src/game.vala"
	self->priv->_background_length1 = rows;
#line 226 "../src/game.vala"
	self->priv->_background_length2 = cols;
#line 227 "../src/game.vala"
	_tmp9_ = g_new0 (TileView*, (rows * cols) + 1);
#line 227 "../src/game.vala"
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
#line 227 "../src/game.vala"
	self->priv->_foreground_cur = _tmp9_;
#line 227 "../src/game.vala"
	self->priv->_foreground_cur_length1 = rows;
#line 227 "../src/game.vala"
	self->priv->_foreground_cur_length2 = cols;
#line 228 "../src/game.vala"
	_tmp10_ = g_new0 (TileView*, (rows * cols) + 1);
#line 228 "../src/game.vala"
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
#line 228 "../src/game.vala"
	self->priv->_foreground_nxt = _tmp10_;
#line 228 "../src/game.vala"
	self->priv->_foreground_nxt_length1 = rows;
#line 228 "../src/game.vala"
	self->priv->_foreground_nxt_length2 = cols;
#line 230 "../src/game.vala"
	_tmp11_ = self->priv->_view;
#line 230 "../src/game.vala"
	_tmp12_ = clutter_actor_get_width (_tmp11_);
#line 230 "../src/game.vala"
	_tmp13_ = _tmp12_;
#line 230 "../src/game.vala"
	canvas_width = _tmp13_;
#line 231 "../src/game.vala"
	_tmp14_ = self->priv->_view;
#line 231 "../src/game.vala"
	_tmp15_ = clutter_actor_get_height (_tmp14_);
#line 231 "../src/game.vala"
	_tmp16_ = _tmp15_;
#line 231 "../src/game.vala"
	canvas_height = _tmp16_;
#line 233 "../src/game.vala"
	canvas_width = canvas_width - ((cols + 1) * self->priv->BLANK_COL_WIDTH);
#line 234 "../src/game.vala"
	canvas_height = canvas_height - ((rows + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 236 "../src/game.vala"
	tile_width = canvas_width / cols;
#line 237 "../src/game.vala"
	tile_height = canvas_height / rows;
#line 1173 "game.c"
	{
		gint i = 0;
#line 239 "../src/game.vala"
		i = 0;
#line 1178 "game.c"
		{
			gboolean _tmp17_ = FALSE;
#line 239 "../src/game.vala"
			_tmp17_ = TRUE;
#line 239 "../src/game.vala"
			while (TRUE) {
#line 239 "../src/game.vala"
				if (!_tmp17_) {
#line 1187 "game.c"
					gint _tmp18_;
#line 239 "../src/game.vala"
					_tmp18_ = i;
#line 239 "../src/game.vala"
					i = _tmp18_ + 1;
#line 1193 "game.c"
				}
#line 239 "../src/game.vala"
				_tmp17_ = FALSE;
#line 239 "../src/game.vala"
				if (!(i < rows)) {
#line 239 "../src/game.vala"
					break;
#line 1201 "game.c"
				}
				{
					gint j = 0;
#line 241 "../src/game.vala"
					j = 0;
#line 1207 "game.c"
					{
						gboolean _tmp19_ = FALSE;
#line 241 "../src/game.vala"
						_tmp19_ = TRUE;
#line 241 "../src/game.vala"
						while (TRUE) {
#line 1214 "game.c"
							gfloat x = 0.0F;
							gfloat y = 0.0F;
							RoundedRectangle* rect = NULL;
							RoundedRectangle* _tmp21_;
							ClutterActor* _tmp22_;
							RoundedRectangle* _tmp23_;
							ClutterActor* _tmp24_;
							ClutterActor* _tmp25_;
							RoundedRectangle* _tmp26_;
							ClutterCanvas* _tmp27_;
							ClutterCanvas* _tmp28_;
							RoundedRectangle* _tmp29_;
							ClutterActor* _tmp30_;
							ClutterActor* _tmp31_;
							RoundedRectangle** _tmp32_;
							gint _tmp32__length1;
							gint _tmp32__length2;
							RoundedRectangle* _tmp33_;
							RoundedRectangle* _tmp34_;
							TileView** _tmp35_;
							gint _tmp35__length1;
							gint _tmp35__length2;
							TileView** _tmp36_;
							gint _tmp36__length1;
							gint _tmp36__length2;
#line 241 "../src/game.vala"
							if (!_tmp19_) {
#line 1242 "game.c"
								gint _tmp20_;
#line 241 "../src/game.vala"
								_tmp20_ = j;
#line 241 "../src/game.vala"
								j = _tmp20_ + 1;
#line 1248 "game.c"
							}
#line 241 "../src/game.vala"
							_tmp19_ = FALSE;
#line 241 "../src/game.vala"
							if (!(j < cols)) {
#line 241 "../src/game.vala"
								break;
#line 1256 "game.c"
							}
#line 243 "../src/game.vala"
							x = (j * tile_width) + ((j + 1) * self->priv->BLANK_COL_WIDTH);
#line 244 "../src/game.vala"
							y = (i * tile_height) + ((i + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 246 "../src/game.vala"
							_tmp21_ = rounded_rectangle_new (x, y, tile_width, tile_height);
#line 246 "../src/game.vala"
							rect = _tmp21_;
#line 248 "../src/game.vala"
							_tmp22_ = self->priv->_view_background;
#line 248 "../src/game.vala"
							_tmp23_ = rect;
#line 248 "../src/game.vala"
							_tmp24_ = rounded_rectangle_get_actor (_tmp23_);
#line 248 "../src/game.vala"
							_tmp25_ = _tmp24_;
#line 248 "../src/game.vala"
							clutter_actor_add_child (_tmp22_, _tmp25_);
#line 249 "../src/game.vala"
							_tmp26_ = rect;
#line 249 "../src/game.vala"
							_tmp27_ = rounded_rectangle_get_canvas (_tmp26_);
#line 249 "../src/game.vala"
							_tmp28_ = _tmp27_;
#line 249 "../src/game.vala"
							clutter_content_invalidate ((ClutterContent*) _tmp28_);
#line 250 "../src/game.vala"
							_tmp29_ = rect;
#line 250 "../src/game.vala"
							_tmp30_ = rounded_rectangle_get_actor (_tmp29_);
#line 250 "../src/game.vala"
							_tmp31_ = _tmp30_;
#line 250 "../src/game.vala"
							clutter_actor_show (_tmp31_);
#line 252 "../src/game.vala"
							_tmp32_ = self->priv->_background;
#line 252 "../src/game.vala"
							_tmp32__length1 = self->priv->_background_length1;
#line 252 "../src/game.vala"
							_tmp32__length2 = self->priv->_background_length2;
#line 252 "../src/game.vala"
							_tmp33_ = rect;
#line 252 "../src/game.vala"
							_tmp34_ = _g_object_ref0 (_tmp33_);
#line 252 "../src/game.vala"
							_g_object_unref0 (_tmp32_[(i * _tmp32__length2) + j]);
#line 252 "../src/game.vala"
							_tmp32_[(i * _tmp32__length2) + j] = _tmp34_;
#line 253 "../src/game.vala"
							_tmp35_ = self->priv->_foreground_cur;
#line 253 "../src/game.vala"
							_tmp35__length1 = self->priv->_foreground_cur_length1;
#line 253 "../src/game.vala"
							_tmp35__length2 = self->priv->_foreground_cur_length2;
#line 253 "../src/game.vala"
							_g_object_unref0 (_tmp35_[(i * _tmp35__length2) + j]);
#line 253 "../src/game.vala"
							_tmp35_[(i * _tmp35__length2) + j] = NULL;
#line 254 "../src/game.vala"
							_tmp36_ = self->priv->_foreground_nxt;
#line 254 "../src/game.vala"
							_tmp36__length1 = self->priv->_foreground_nxt_length1;
#line 254 "../src/game.vala"
							_tmp36__length2 = self->priv->_foreground_nxt_length2;
#line 254 "../src/game.vala"
							_g_object_unref0 (_tmp36_[(i * _tmp36__length2) + j]);
#line 254 "../src/game.vala"
							_tmp36_[(i * _tmp36__length2) + j] = NULL;
#line 241 "../src/game.vala"
							_g_object_unref0 (rect);
#line 1328 "game.c"
						}
					}
				}
			}
		}
	}
#line 257 "../src/game.vala"
	self->priv->_background_init_done = TRUE;
#line 1337 "game.c"
}

static gboolean
__game_idle_resize_view_gsource_func (gpointer self)
{
	gboolean result;
	result = _game_idle_resize_view ((Game*) self);
#line 291 "../src/game.vala"
	return result;
#line 1347 "game.c"
}

static void
_game_resize_view (Game* self)
{
	gint rows = 0;
	Grid* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint cols = 0;
	Grid* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat tile_width = 0.0F;
	gfloat tile_height = 0.0F;
#line 260 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 262 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 262 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 262 "../src/game.vala"
	rows = _tmp2_;
#line 263 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 263 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 263 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 263 "../src/game.vala"
	cols = _tmp5_;
#line 264 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 264 "../src/game.vala"
	_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 264 "../src/game.vala"
	_tmp8_ = _tmp7_;
#line 264 "../src/game.vala"
	canvas_width = _tmp8_;
#line 265 "../src/game.vala"
	_tmp9_ = self->priv->_view;
#line 265 "../src/game.vala"
	_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 265 "../src/game.vala"
	_tmp11_ = _tmp10_;
#line 265 "../src/game.vala"
	canvas_height = _tmp11_;
#line 267 "../src/game.vala"
	canvas_width = canvas_width - ((cols + 1) * self->priv->BLANK_COL_WIDTH);
#line 268 "../src/game.vala"
	canvas_height = canvas_height - ((rows + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 270 "../src/game.vala"
	tile_width = canvas_width / cols;
#line 271 "../src/game.vala"
	tile_height = canvas_height / rows;
#line 1413 "game.c"
	{
		gint i = 0;
#line 273 "../src/game.vala"
		i = 0;
#line 1418 "game.c"
		{
			gboolean _tmp12_ = FALSE;
#line 273 "../src/game.vala"
			_tmp12_ = TRUE;
#line 273 "../src/game.vala"
			while (TRUE) {
#line 273 "../src/game.vala"
				if (!_tmp12_) {
#line 1427 "game.c"
					gint _tmp13_;
#line 273 "../src/game.vala"
					_tmp13_ = i;
#line 273 "../src/game.vala"
					i = _tmp13_ + 1;
#line 1433 "game.c"
				}
#line 273 "../src/game.vala"
				_tmp12_ = FALSE;
#line 273 "../src/game.vala"
				if (!(i < rows)) {
#line 273 "../src/game.vala"
					break;
#line 1441 "game.c"
				}
				{
					gint j = 0;
#line 275 "../src/game.vala"
					j = 0;
#line 1447 "game.c"
					{
						gboolean _tmp14_ = FALSE;
#line 275 "../src/game.vala"
						_tmp14_ = TRUE;
#line 275 "../src/game.vala"
						while (TRUE) {
#line 1454 "game.c"
							gfloat x = 0.0F;
							gfloat y = 0.0F;
							RoundedRectangle** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							RoundedRectangle* _tmp17_;
							TileView** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							TileView* _tmp19_;
							TileView** _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							TileView* _tmp23_;
#line 275 "../src/game.vala"
							if (!_tmp14_) {
#line 1471 "game.c"
								gint _tmp15_;
#line 275 "../src/game.vala"
								_tmp15_ = j;
#line 275 "../src/game.vala"
								j = _tmp15_ + 1;
#line 1477 "game.c"
							}
#line 275 "../src/game.vala"
							_tmp14_ = FALSE;
#line 275 "../src/game.vala"
							if (!(j < cols)) {
#line 275 "../src/game.vala"
								break;
#line 1485 "game.c"
							}
#line 277 "../src/game.vala"
							x = (j * tile_width) + ((j + 1) * self->priv->BLANK_COL_WIDTH);
#line 278 "../src/game.vala"
							y = (i * tile_height) + ((i + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 280 "../src/game.vala"
							_tmp16_ = self->priv->_background;
#line 280 "../src/game.vala"
							_tmp16__length1 = self->priv->_background_length1;
#line 280 "../src/game.vala"
							_tmp16__length2 = self->priv->_background_length2;
#line 280 "../src/game.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 280 "../src/game.vala"
							rounded_rectangle_resize (_tmp17_, x, y, tile_width, tile_height);
#line 282 "../src/game.vala"
							_tmp18_ = self->priv->_foreground_cur;
#line 282 "../src/game.vala"
							_tmp18__length1 = self->priv->_foreground_cur_length1;
#line 282 "../src/game.vala"
							_tmp18__length2 = self->priv->_foreground_cur_length2;
#line 282 "../src/game.vala"
							_tmp19_ = _tmp18_[(i * _tmp18__length2) + j];
#line 282 "../src/game.vala"
							if (_tmp19_ != NULL) {
#line 1511 "game.c"
								TileView** _tmp20_;
								gint _tmp20__length1;
								gint _tmp20__length2;
								TileView* _tmp21_;
#line 283 "../src/game.vala"
								_tmp20_ = self->priv->_foreground_cur;
#line 283 "../src/game.vala"
								_tmp20__length1 = self->priv->_foreground_cur_length1;
#line 283 "../src/game.vala"
								_tmp20__length2 = self->priv->_foreground_cur_length2;
#line 283 "../src/game.vala"
								_tmp21_ = _tmp20_[(i * _tmp20__length2) + j];
#line 283 "../src/game.vala"
								rounded_rectangle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_TILE_VIEW, TileView), x, y, tile_width, tile_height);
#line 1526 "game.c"
							}
#line 285 "../src/game.vala"
							_tmp22_ = self->priv->_foreground_nxt;
#line 285 "../src/game.vala"
							_tmp22__length1 = self->priv->_foreground_nxt_length1;
#line 285 "../src/game.vala"
							_tmp22__length2 = self->priv->_foreground_nxt_length2;
#line 285 "../src/game.vala"
							_tmp23_ = _tmp22_[(i * _tmp22__length2) + j];
#line 285 "../src/game.vala"
							if (_tmp23_ != NULL) {
#line 1538 "game.c"
								TileView** _tmp24_;
								gint _tmp24__length1;
								gint _tmp24__length2;
								TileView* _tmp25_;
#line 286 "../src/game.vala"
								_tmp24_ = self->priv->_foreground_nxt;
#line 286 "../src/game.vala"
								_tmp24__length1 = self->priv->_foreground_nxt_length1;
#line 286 "../src/game.vala"
								_tmp24__length2 = self->priv->_foreground_nxt_length2;
#line 286 "../src/game.vala"
								_tmp25_ = _tmp24_[(i * _tmp24__length2) + j];
#line 286 "../src/game.vala"
								rounded_rectangle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_TILE_VIEW, TileView), x, y, tile_width, tile_height);
#line 1553 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 290 "../src/game.vala"
	if (self->priv->_resize_view_id == ((guint) 0)) {
#line 291 "../src/game.vala"
		self->priv->_resize_view_id = clutter_threads_add_timeout ((guint) 1000, __game_idle_resize_view_gsource_func, self);
#line 1565 "game.c"
	}
}

static gboolean
_game_idle_resize_view (Game* self)
{
	gboolean result = FALSE;
	gint rows = 0;
	Grid* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint cols = 0;
	Grid* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 294 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 296 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 296 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 296 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 296 "../src/game.vala"
	rows = _tmp2_;
#line 297 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 297 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 297 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 297 "../src/game.vala"
	cols = _tmp5_;
#line 1599 "game.c"
	{
		gint i = 0;
#line 298 "../src/game.vala"
		i = 0;
#line 1604 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 298 "../src/game.vala"
			_tmp6_ = TRUE;
#line 298 "../src/game.vala"
			while (TRUE) {
#line 298 "../src/game.vala"
				if (!_tmp6_) {
#line 1613 "game.c"
					gint _tmp7_;
#line 298 "../src/game.vala"
					_tmp7_ = i;
#line 298 "../src/game.vala"
					i = _tmp7_ + 1;
#line 1619 "game.c"
				}
#line 298 "../src/game.vala"
				_tmp6_ = FALSE;
#line 298 "../src/game.vala"
				if (!(i < rows)) {
#line 298 "../src/game.vala"
					break;
#line 1627 "game.c"
				}
				{
					gint j = 0;
#line 300 "../src/game.vala"
					j = 0;
#line 1633 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 300 "../src/game.vala"
						_tmp8_ = TRUE;
#line 300 "../src/game.vala"
						while (TRUE) {
#line 1640 "game.c"
							RoundedRectangle** _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							RoundedRectangle* _tmp11_;
							TileView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							TileView* _tmp13_;
#line 300 "../src/game.vala"
							if (!_tmp8_) {
#line 1651 "game.c"
								gint _tmp9_;
#line 300 "../src/game.vala"
								_tmp9_ = j;
#line 300 "../src/game.vala"
								j = _tmp9_ + 1;
#line 1657 "game.c"
							}
#line 300 "../src/game.vala"
							_tmp8_ = FALSE;
#line 300 "../src/game.vala"
							if (!(j < cols)) {
#line 300 "../src/game.vala"
								break;
#line 1665 "game.c"
							}
#line 302 "../src/game.vala"
							_tmp10_ = self->priv->_background;
#line 302 "../src/game.vala"
							_tmp10__length1 = self->priv->_background_length1;
#line 302 "../src/game.vala"
							_tmp10__length2 = self->priv->_background_length2;
#line 302 "../src/game.vala"
							_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 302 "../src/game.vala"
							rounded_rectangle_idle_resize (_tmp11_);
#line 304 "../src/game.vala"
							_tmp12_ = self->priv->_foreground_cur;
#line 304 "../src/game.vala"
							_tmp12__length1 = self->priv->_foreground_cur_length1;
#line 304 "../src/game.vala"
							_tmp12__length2 = self->priv->_foreground_cur_length2;
#line 304 "../src/game.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 304 "../src/game.vala"
							if (_tmp13_ != NULL) {
#line 1687 "game.c"
								TileView** _tmp14_;
								gint _tmp14__length1;
								gint _tmp14__length2;
								TileView* _tmp15_;
#line 305 "../src/game.vala"
								_tmp14_ = self->priv->_foreground_cur;
#line 305 "../src/game.vala"
								_tmp14__length1 = self->priv->_foreground_cur_length1;
#line 305 "../src/game.vala"
								_tmp14__length2 = self->priv->_foreground_cur_length2;
#line 305 "../src/game.vala"
								_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 305 "../src/game.vala"
								rounded_rectangle_idle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_TILE_VIEW, TileView));
#line 1702 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 309 "../src/game.vala"
	self->priv->_resize_view_id = (guint) 0;
#line 310 "../src/game.vala"
	result = FALSE;
#line 310 "../src/game.vala"
	return result;
#line 1716 "game.c"
}

static void
_game_create_random_tile (Game* self)
{
	Tile tile = {0};
	Grid* _tmp0_;
	Tile _tmp1_ = {0};
	GameGameState _tmp2_;
	Tile _tmp3_;
	GeeLinkedList* _tmp4_;
	Tile _tmp5_;
	Tile _tmp6_;
	GridPosition _tmp7_;
	ClutterTransitionGroup* _tmp8_;
#line 313 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 316 "../src/game.vala"
	grid_new_tile (_tmp0_, &_tmp1_);
#line 316 "../src/game.vala"
	tile = _tmp1_;
#line 318 "../src/game.vala"
	_tmp2_ = self->priv->_state;
#line 318 "../src/game.vala"
	if (_tmp2_ == GAME_GAME_STATE_SHOWING_FIRST_TILE) {
#line 319 "../src/game.vala"
		self->priv->_update_handled = TRUE;
#line 1746 "game.c"
	} else {
#line 322 "../src/game.vala"
		self->priv->_update_handled = FALSE;
#line 323 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 1752 "game.c"
	}
#line 325 "../src/game.vala"
	_game_create_show_hide_transition (self, TRUE);
#line 327 "../src/game.vala"
	_tmp3_ = tile;
#line 327 "../src/game.vala"
	_game_create_tile (self, &_tmp3_);
#line 328 "../src/game.vala"
	_tmp4_ = self->priv->_to_show;
#line 328 "../src/game.vala"
	_tmp5_ = tile;
#line 328 "../src/game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, &_tmp5_);
#line 329 "../src/game.vala"
	_tmp6_ = tile;
#line 329 "../src/game.vala"
	_tmp7_ = _tmp6_.pos;
#line 329 "../src/game.vala"
	_game_show_tile (self, &_tmp7_);
#line 330 "../src/game.vala"
	_tmp8_ = self->priv->_show_hide_trans;
#line 330 "../src/game.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp8_);
#line 1776 "game.c"
}

static void
_game_create_tile (Game* self,
                   Tile* tile)
{
	GridPosition pos = {0};
	Tile _tmp0_;
	GridPosition _tmp1_;
	TileView** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	GridPosition _tmp3_;
	GridPosition _tmp4_;
	TileView* _tmp5_;
	ClutterActor* actor = NULL;
	RoundedRectangle** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GridPosition _tmp7_;
	GridPosition _tmp8_;
	RoundedRectangle* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	TileView** _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	GridPosition _tmp14_;
	GridPosition _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	Tile _tmp24_;
	TileView* _tmp25_;
#line 333 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/game.vala"
	g_return_if_fail (tile != NULL);
#line 335 "../src/game.vala"
	_tmp0_ = *tile;
#line 335 "../src/game.vala"
	_tmp1_ = _tmp0_.pos;
#line 335 "../src/game.vala"
	pos = _tmp1_;
#line 336 "../src/game.vala"
	_tmp2_ = self->priv->_foreground_nxt;
#line 336 "../src/game.vala"
	_tmp2__length1 = self->priv->_foreground_nxt_length1;
#line 336 "../src/game.vala"
	_tmp2__length2 = self->priv->_foreground_nxt_length2;
#line 336 "../src/game.vala"
	_tmp3_ = pos;
#line 336 "../src/game.vala"
	_tmp4_ = pos;
#line 336 "../src/game.vala"
	_tmp5_ = _tmp2_[(_tmp3_.row * _tmp2__length2) + _tmp4_.col];
#line 336 "../src/game.vala"
	_vala_assert (_tmp5_ == NULL, "_foreground_nxt [pos.row, pos.col] == null");
#line 338 "../src/game.vala"
	_tmp6_ = self->priv->_background;
#line 338 "../src/game.vala"
	_tmp6__length1 = self->priv->_background_length1;
#line 338 "../src/game.vala"
	_tmp6__length2 = self->priv->_background_length2;
#line 338 "../src/game.vala"
	_tmp7_ = pos;
#line 338 "../src/game.vala"
	_tmp8_ = pos;
#line 338 "../src/game.vala"
	_tmp9_ = _tmp6_[(_tmp7_.row * _tmp6__length2) + _tmp8_.col];
#line 338 "../src/game.vala"
	_tmp10_ = rounded_rectangle_get_actor (_tmp9_);
#line 338 "../src/game.vala"
	_tmp11_ = _tmp10_;
#line 338 "../src/game.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 338 "../src/game.vala"
	actor = _tmp12_;
#line 339 "../src/game.vala"
	_tmp13_ = self->priv->_foreground_nxt;
#line 339 "../src/game.vala"
	_tmp13__length1 = self->priv->_foreground_nxt_length1;
#line 339 "../src/game.vala"
	_tmp13__length2 = self->priv->_foreground_nxt_length2;
#line 339 "../src/game.vala"
	_tmp14_ = pos;
#line 339 "../src/game.vala"
	_tmp15_ = pos;
#line 339 "../src/game.vala"
	_tmp16_ = clutter_actor_get_x (actor);
#line 339 "../src/game.vala"
	_tmp17_ = _tmp16_;
#line 339 "../src/game.vala"
	_tmp18_ = clutter_actor_get_y (actor);
#line 339 "../src/game.vala"
	_tmp19_ = _tmp18_;
#line 339 "../src/game.vala"
	_tmp20_ = clutter_actor_get_width (actor);
#line 339 "../src/game.vala"
	_tmp21_ = _tmp20_;
#line 339 "../src/game.vala"
	_tmp22_ = clutter_actor_get_height (actor);
#line 339 "../src/game.vala"
	_tmp23_ = _tmp22_;
#line 339 "../src/game.vala"
	_tmp24_ = *tile;
#line 339 "../src/game.vala"
	_tmp25_ = tile_view_new (_tmp17_, _tmp19_, _tmp21_, _tmp23_, _tmp24_.val);
#line 339 "../src/game.vala"
	_g_object_unref0 (_tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col]);
#line 339 "../src/game.vala"
	_tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col] = _tmp25_;
#line 333 "../src/game.vala"
	_g_object_unref0 (actor);
#line 1897 "game.c"
}

static void
_game_show_tile (Game* self,
                 GridPosition* pos)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ClutterPropertyTransition* trans = NULL;
	TileView* tile_view = NULL;
	TileView** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GridPosition _tmp5_;
	GridPosition _tmp6_;
	TileView* _tmp7_;
	TileView* _tmp8_;
	ClutterActor* actor = NULL;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterCanvas* _tmp12_;
	ClutterCanvas* _tmp13_;
	ClutterActor* _tmp14_;
	ClutterPropertyTransition* _tmp15_;
	ClutterPropertyTransition* _tmp16_;
	GValue _tmp17_ = {0};
	ClutterPropertyTransition* _tmp18_;
	GValue _tmp19_ = {0};
	ClutterPropertyTransition* _tmp20_;
	ClutterPropertyTransition* _tmp21_;
	ClutterTransitionGroup* _tmp22_;
	ClutterPropertyTransition* _tmp23_;
	ClutterPropertyTransition* _tmp24_;
	ClutterPropertyTransition* _tmp25_;
	GValue _tmp26_ = {0};
	ClutterPropertyTransition* _tmp27_;
	GValue _tmp28_ = {0};
	ClutterPropertyTransition* _tmp29_;
	ClutterPropertyTransition* _tmp30_;
	ClutterTransitionGroup* _tmp31_;
	ClutterPropertyTransition* _tmp32_;
	ClutterPropertyTransition* _tmp33_;
	ClutterPropertyTransition* _tmp34_;
	GValue _tmp35_ = {0};
	ClutterPropertyTransition* _tmp36_;
	GValue _tmp37_ = {0};
	ClutterPropertyTransition* _tmp38_;
	ClutterPropertyTransition* _tmp39_;
	ClutterPropertyTransition* _tmp40_;
#line 346 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 346 "../src/game.vala"
	g_return_if_fail (pos != NULL);
#line 348 "../src/game.vala"
	_tmp0_ = grid_position_to_string (pos);
#line 348 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 348 "../src/game.vala"
	_tmp2_ = g_strconcat ("show tile pos ", _tmp1_, NULL);
#line 348 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 348 "../src/game.vala"
	g_debug ("game.vala:348: %s", _tmp3_);
#line 348 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 348 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 352 "../src/game.vala"
	_tmp4_ = self->priv->_foreground_nxt;
#line 352 "../src/game.vala"
	_tmp4__length1 = self->priv->_foreground_nxt_length1;
#line 352 "../src/game.vala"
	_tmp4__length2 = self->priv->_foreground_nxt_length2;
#line 352 "../src/game.vala"
	_tmp5_ = *pos;
#line 352 "../src/game.vala"
	_tmp6_ = *pos;
#line 352 "../src/game.vala"
	_tmp7_ = _tmp4_[(_tmp5_.row * _tmp4__length2) + _tmp6_.col];
#line 352 "../src/game.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 352 "../src/game.vala"
	tile_view = _tmp8_;
#line 353 "../src/game.vala"
	if (tile_view == NULL) {
#line 354 "../src/game.vala"
		g_assert_not_reached ();
#line 1988 "game.c"
	}
#line 355 "../src/game.vala"
	_tmp9_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 355 "../src/game.vala"
	_tmp10_ = _tmp9_;
#line 355 "../src/game.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 355 "../src/game.vala"
	actor = _tmp11_;
#line 357 "../src/game.vala"
	_tmp12_ = rounded_rectangle_get_canvas ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 357 "../src/game.vala"
	_tmp13_ = _tmp12_;
#line 357 "../src/game.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp13_);
#line 358 "../src/game.vala"
	clutter_actor_set_opacity (actor, (guint8) 0);
#line 359 "../src/game.vala"
	clutter_actor_show (actor);
#line 360 "../src/game.vala"
	_tmp14_ = self->priv->_view_foreground;
#line 360 "../src/game.vala"
	clutter_actor_add_child (_tmp14_, actor);
#line 362 "../src/game.vala"
	_tmp15_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-x");
#line 362 "../src/game.vala"
	_g_object_unref0 (trans);
#line 362 "../src/game.vala"
	trans = _tmp15_;
#line 363 "../src/game.vala"
	_tmp16_ = trans;
#line 363 "../src/game.vala"
	g_value_init (&_tmp17_, G_TYPE_DOUBLE);
#line 363 "../src/game.vala"
	g_value_set_double (&_tmp17_, 1.0);
#line 363 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp16_, &_tmp17_);
#line 363 "../src/game.vala"
	G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
#line 364 "../src/game.vala"
	_tmp18_ = trans;
#line 364 "../src/game.vala"
	g_value_init (&_tmp19_, G_TYPE_DOUBLE);
#line 364 "../src/game.vala"
	g_value_set_double (&_tmp19_, 1.1);
#line 364 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp18_, &_tmp19_);
#line 364 "../src/game.vala"
	G_IS_VALUE (&_tmp19_) ? (g_value_unset (&_tmp19_), NULL) : NULL;
#line 365 "../src/game.vala"
	_tmp20_ = trans;
#line 365 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp20_, (guint) self->priv->_animations_duration);
#line 366 "../src/game.vala"
	_tmp21_ = trans;
#line 366 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp21_, (ClutterAnimatable*) actor);
#line 367 "../src/game.vala"
	_tmp22_ = self->priv->_show_hide_trans;
#line 367 "../src/game.vala"
	_tmp23_ = trans;
#line 367 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp22_, (ClutterTransition*) _tmp23_);
#line 369 "../src/game.vala"
	_tmp24_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-y");
#line 369 "../src/game.vala"
	_g_object_unref0 (trans);
#line 369 "../src/game.vala"
	trans = _tmp24_;
#line 370 "../src/game.vala"
	_tmp25_ = trans;
#line 370 "../src/game.vala"
	g_value_init (&_tmp26_, G_TYPE_DOUBLE);
#line 370 "../src/game.vala"
	g_value_set_double (&_tmp26_, 1.0);
#line 370 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp25_, &_tmp26_);
#line 370 "../src/game.vala"
	G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
#line 371 "../src/game.vala"
	_tmp27_ = trans;
#line 371 "../src/game.vala"
	g_value_init (&_tmp28_, G_TYPE_DOUBLE);
#line 371 "../src/game.vala"
	g_value_set_double (&_tmp28_, 1.1);
#line 371 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp27_, &_tmp28_);
#line 371 "../src/game.vala"
	G_IS_VALUE (&_tmp28_) ? (g_value_unset (&_tmp28_), NULL) : NULL;
#line 372 "../src/game.vala"
	_tmp29_ = trans;
#line 372 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp29_, (guint) self->priv->_animations_duration);
#line 373 "../src/game.vala"
	_tmp30_ = trans;
#line 373 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp30_, (ClutterAnimatable*) actor);
#line 374 "../src/game.vala"
	_tmp31_ = self->priv->_show_hide_trans;
#line 374 "../src/game.vala"
	_tmp32_ = trans;
#line 374 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp31_, (ClutterTransition*) _tmp32_);
#line 376 "../src/game.vala"
	_tmp33_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 376 "../src/game.vala"
	_g_object_unref0 (trans);
#line 376 "../src/game.vala"
	trans = _tmp33_;
#line 377 "../src/game.vala"
	_tmp34_ = trans;
#line 377 "../src/game.vala"
	g_value_init (&_tmp35_, G_TYPE_INT);
#line 377 "../src/game.vala"
	g_value_set_int (&_tmp35_, 0);
#line 377 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp34_, &_tmp35_);
#line 377 "../src/game.vala"
	G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
#line 378 "../src/game.vala"
	_tmp36_ = trans;
#line 378 "../src/game.vala"
	g_value_init (&_tmp37_, G_TYPE_INT);
#line 378 "../src/game.vala"
	g_value_set_int (&_tmp37_, 255);
#line 378 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp36_, &_tmp37_);
#line 378 "../src/game.vala"
	G_IS_VALUE (&_tmp37_) ? (g_value_unset (&_tmp37_), NULL) : NULL;
#line 379 "../src/game.vala"
	_tmp38_ = trans;
#line 379 "../src/game.vala"
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp38_, TRUE);
#line 380 "../src/game.vala"
	_tmp39_ = trans;
#line 380 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp39_, (guint) (self->priv->_animations_duration / 2));
#line 381 "../src/game.vala"
	_tmp40_ = trans;
#line 381 "../src/game.vala"
	clutter_actor_add_transition (actor, "show", (ClutterTransition*) _tmp40_);
#line 346 "../src/game.vala"
	_g_object_unref0 (actor);
#line 346 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 346 "../src/game.vala"
	_g_object_unref0 (trans);
#line 2136 "game.c"
}

static void
_game_move_tile (Game* self,
                 GridPosition* from,
                 GridPosition* to)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	TileView** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GridPosition _tmp9_;
	GridPosition _tmp10_;
	TileView** _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
	TileView* _tmp14_;
	TileView* _tmp15_;
	TileView** _tmp16_;
	gint _tmp16__length1;
	gint _tmp16__length2;
	GridPosition _tmp17_;
	GridPosition _tmp18_;
#line 384 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 384 "../src/game.vala"
	g_return_if_fail (from != NULL);
#line 384 "../src/game.vala"
	g_return_if_fail (to != NULL);
#line 386 "../src/game.vala"
	_tmp0_ = grid_position_to_string (from);
#line 386 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 386 "../src/game.vala"
	_tmp2_ = grid_position_to_string (to);
#line 386 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 386 "../src/game.vala"
	_tmp4_ = g_strconcat ("move tile from ", _tmp1_, " to ", _tmp3_, NULL);
#line 386 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 386 "../src/game.vala"
	g_debug ("game.vala:386: %s", _tmp5_);
#line 386 "../src/game.vala"
	_g_free0 (_tmp5_);
#line 386 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 386 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 388 "../src/game.vala"
	_tmp6_ = *from;
#line 388 "../src/game.vala"
	_tmp7_ = *to;
#line 388 "../src/game.vala"
	_game_prepare_move_tile (self, &_tmp6_, &_tmp7_);
#line 390 "../src/game.vala"
	_tmp8_ = self->priv->_foreground_nxt;
#line 390 "../src/game.vala"
	_tmp8__length1 = self->priv->_foreground_nxt_length1;
#line 390 "../src/game.vala"
	_tmp8__length2 = self->priv->_foreground_nxt_length2;
#line 390 "../src/game.vala"
	_tmp9_ = *to;
#line 390 "../src/game.vala"
	_tmp10_ = *to;
#line 390 "../src/game.vala"
	_tmp11_ = self->priv->_foreground_cur;
#line 390 "../src/game.vala"
	_tmp11__length1 = self->priv->_foreground_cur_length1;
#line 390 "../src/game.vala"
	_tmp11__length2 = self->priv->_foreground_cur_length2;
#line 390 "../src/game.vala"
	_tmp12_ = *from;
#line 390 "../src/game.vala"
	_tmp13_ = *from;
#line 390 "../src/game.vala"
	_tmp14_ = _tmp11_[(_tmp12_.row * _tmp11__length2) + _tmp13_.col];
#line 390 "../src/game.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 390 "../src/game.vala"
	_g_object_unref0 (_tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col]);
#line 390 "../src/game.vala"
	_tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col] = _tmp15_;
#line 391 "../src/game.vala"
	_tmp16_ = self->priv->_foreground_cur;
#line 391 "../src/game.vala"
	_tmp16__length1 = self->priv->_foreground_cur_length1;
#line 391 "../src/game.vala"
	_tmp16__length2 = self->priv->_foreground_cur_length2;
#line 391 "../src/game.vala"
	_tmp17_ = *from;
#line 391 "../src/game.vala"
	_tmp18_ = *from;
#line 391 "../src/game.vala"
	_g_object_unref0 (_tmp16_[(_tmp17_.row * _tmp16__length2) + _tmp18_.col]);
#line 391 "../src/game.vala"
	_tmp16_[(_tmp17_.row * _tmp16__length2) + _tmp18_.col] = NULL;
#line 2243 "game.c"
}

static void
_game_prepare_move_tile (Game* self,
                         GridPosition* from,
                         GridPosition* to)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean row_move = FALSE;
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	RoundedRectangle* rect_from = NULL;
	RoundedRectangle** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GridPosition _tmp9_;
	GridPosition _tmp10_;
	RoundedRectangle* _tmp11_;
	RoundedRectangle* _tmp12_;
	RoundedRectangle* rect_to = NULL;
	RoundedRectangle** _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	GridPosition _tmp14_;
	GridPosition _tmp15_;
	RoundedRectangle* _tmp16_;
	RoundedRectangle* _tmp17_;
	TileView* tile_view = NULL;
	TileView** _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	GridPosition _tmp19_;
	GridPosition _tmp20_;
	TileView* _tmp21_;
	TileView* _tmp22_;
	const gchar* _tmp23_ = NULL;
	ClutterPropertyTransition* trans = NULL;
	ClutterPropertyTransition* _tmp24_;
	gfloat _tmp25_ = 0.0F;
	ClutterPropertyTransition* _tmp34_;
	GValue _tmp35_ = {0};
	gfloat _tmp36_ = 0.0F;
	ClutterPropertyTransition* _tmp45_;
	GValue _tmp46_ = {0};
	ClutterPropertyTransition* _tmp47_;
	ClutterPropertyTransition* _tmp48_;
	ClutterActor* _tmp49_;
	ClutterActor* _tmp50_;
	ClutterTransitionGroup* _tmp51_;
	ClutterPropertyTransition* _tmp52_;
#line 394 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/game.vala"
	g_return_if_fail (from != NULL);
#line 394 "../src/game.vala"
	g_return_if_fail (to != NULL);
#line 396 "../src/game.vala"
	_tmp0_ = grid_position_to_string (from);
#line 396 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 396 "../src/game.vala"
	_tmp2_ = grid_position_to_string (to);
#line 396 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 396 "../src/game.vala"
	_tmp4_ = g_strconcat ("prepare move tile from ", _tmp1_, " to ", _tmp3_, NULL);
#line 396 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 396 "../src/game.vala"
	g_debug ("game.vala:396: %s", _tmp5_);
#line 396 "../src/game.vala"
	_g_free0 (_tmp5_);
#line 396 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 396 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 398 "../src/game.vala"
	_tmp6_ = *from;
#line 398 "../src/game.vala"
	_tmp7_ = *to;
#line 398 "../src/game.vala"
	row_move = _tmp6_.col == _tmp7_.col;
#line 400 "../src/game.vala"
	_tmp8_ = self->priv->_background;
#line 400 "../src/game.vala"
	_tmp8__length1 = self->priv->_background_length1;
#line 400 "../src/game.vala"
	_tmp8__length2 = self->priv->_background_length2;
#line 400 "../src/game.vala"
	_tmp9_ = *from;
#line 400 "../src/game.vala"
	_tmp10_ = *from;
#line 400 "../src/game.vala"
	_tmp11_ = _tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col];
#line 400 "../src/game.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 400 "../src/game.vala"
	rect_from = _tmp12_;
#line 401 "../src/game.vala"
	_tmp13_ = self->priv->_background;
#line 401 "../src/game.vala"
	_tmp13__length1 = self->priv->_background_length1;
#line 401 "../src/game.vala"
	_tmp13__length2 = self->priv->_background_length2;
#line 401 "../src/game.vala"
	_tmp14_ = *to;
#line 401 "../src/game.vala"
	_tmp15_ = *to;
#line 401 "../src/game.vala"
	_tmp16_ = _tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col];
#line 401 "../src/game.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 401 "../src/game.vala"
	rect_to = _tmp17_;
#line 403 "../src/game.vala"
	_tmp18_ = self->priv->_foreground_cur;
#line 403 "../src/game.vala"
	_tmp18__length1 = self->priv->_foreground_cur_length1;
#line 403 "../src/game.vala"
	_tmp18__length2 = self->priv->_foreground_cur_length2;
#line 403 "../src/game.vala"
	_tmp19_ = *from;
#line 403 "../src/game.vala"
	_tmp20_ = *from;
#line 403 "../src/game.vala"
	_tmp21_ = _tmp18_[(_tmp19_.row * _tmp18__length2) + _tmp20_.col];
#line 403 "../src/game.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 403 "../src/game.vala"
	tile_view = _tmp22_;
#line 404 "../src/game.vala"
	if (tile_view == NULL) {
#line 405 "../src/game.vala"
		g_assert_not_reached ();
#line 2383 "game.c"
	}
#line 407 "../src/game.vala"
	if (row_move) {
#line 407 "../src/game.vala"
		_tmp23_ = "y";
#line 2389 "game.c"
	} else {
#line 407 "../src/game.vala"
		_tmp23_ = "x";
#line 2393 "game.c"
	}
#line 407 "../src/game.vala"
	_tmp24_ = (ClutterPropertyTransition*) clutter_property_transition_new (_tmp23_);
#line 407 "../src/game.vala"
	trans = _tmp24_;
#line 408 "../src/game.vala"
	if (row_move) {
#line 2401 "game.c"
		ClutterActor* _tmp26_;
		ClutterActor* _tmp27_;
		gfloat _tmp28_;
		gfloat _tmp29_;
#line 408 "../src/game.vala"
		_tmp26_ = rounded_rectangle_get_actor (rect_from);
#line 408 "../src/game.vala"
		_tmp27_ = _tmp26_;
#line 408 "../src/game.vala"
		_tmp28_ = clutter_actor_get_y (_tmp27_);
#line 408 "../src/game.vala"
		_tmp29_ = _tmp28_;
#line 408 "../src/game.vala"
		_tmp25_ = _tmp29_;
#line 2416 "game.c"
	} else {
		ClutterActor* _tmp30_;
		ClutterActor* _tmp31_;
		gfloat _tmp32_;
		gfloat _tmp33_;
#line 408 "../src/game.vala"
		_tmp30_ = rounded_rectangle_get_actor (rect_from);
#line 408 "../src/game.vala"
		_tmp31_ = _tmp30_;
#line 408 "../src/game.vala"
		_tmp32_ = clutter_actor_get_x (_tmp31_);
#line 408 "../src/game.vala"
		_tmp33_ = _tmp32_;
#line 408 "../src/game.vala"
		_tmp25_ = _tmp33_;
#line 2432 "game.c"
	}
#line 408 "../src/game.vala"
	_tmp34_ = trans;
#line 408 "../src/game.vala"
	g_value_init (&_tmp35_, G_TYPE_FLOAT);
#line 408 "../src/game.vala"
	g_value_set_float (&_tmp35_, _tmp25_);
#line 408 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp34_, &_tmp35_);
#line 408 "../src/game.vala"
	G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
#line 409 "../src/game.vala"
	if (row_move) {
#line 2446 "game.c"
		ClutterActor* _tmp37_;
		ClutterActor* _tmp38_;
		gfloat _tmp39_;
		gfloat _tmp40_;
#line 409 "../src/game.vala"
		_tmp37_ = rounded_rectangle_get_actor (rect_to);
#line 409 "../src/game.vala"
		_tmp38_ = _tmp37_;
#line 409 "../src/game.vala"
		_tmp39_ = clutter_actor_get_y (_tmp38_);
#line 409 "../src/game.vala"
		_tmp40_ = _tmp39_;
#line 409 "../src/game.vala"
		_tmp36_ = _tmp40_;
#line 2461 "game.c"
	} else {
		ClutterActor* _tmp41_;
		ClutterActor* _tmp42_;
		gfloat _tmp43_;
		gfloat _tmp44_;
#line 409 "../src/game.vala"
		_tmp41_ = rounded_rectangle_get_actor (rect_to);
#line 409 "../src/game.vala"
		_tmp42_ = _tmp41_;
#line 409 "../src/game.vala"
		_tmp43_ = clutter_actor_get_x (_tmp42_);
#line 409 "../src/game.vala"
		_tmp44_ = _tmp43_;
#line 409 "../src/game.vala"
		_tmp36_ = _tmp44_;
#line 2477 "game.c"
	}
#line 409 "../src/game.vala"
	_tmp45_ = trans;
#line 409 "../src/game.vala"
	g_value_init (&_tmp46_, G_TYPE_FLOAT);
#line 409 "../src/game.vala"
	g_value_set_float (&_tmp46_, _tmp36_);
#line 409 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp45_, &_tmp46_);
#line 409 "../src/game.vala"
	G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
#line 410 "../src/game.vala"
	_tmp47_ = trans;
#line 410 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp47_, (guint) self->priv->_animations_duration);
#line 411 "../src/game.vala"
	_tmp48_ = trans;
#line 411 "../src/game.vala"
	_tmp49_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 411 "../src/game.vala"
	_tmp50_ = _tmp49_;
#line 411 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp48_, (ClutterAnimatable*) _tmp50_);
#line 412 "../src/game.vala"
	_tmp51_ = self->priv->_move_trans;
#line 412 "../src/game.vala"
	_tmp52_ = trans;
#line 412 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp51_, (ClutterTransition*) _tmp52_);
#line 394 "../src/game.vala"
	_g_object_unref0 (trans);
#line 394 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 394 "../src/game.vala"
	_g_object_unref0 (rect_to);
#line 394 "../src/game.vala"
	_g_object_unref0 (rect_from);
#line 2515 "game.c"
}

static void
_game_dim_tile (Game* self,
                GridPosition* pos)
{
	TileView* tile_view = NULL;
	TileView** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GridPosition _tmp1_;
	GridPosition _tmp2_;
	TileView* _tmp3_;
	TileView* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	ClutterActor* actor = NULL;
	ClutterPropertyTransition* trans = NULL;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	ClutterActor* _tmp17_;
	ClutterPropertyTransition* _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	GValue _tmp21_ = {0};
	GValue _tmp22_ = {0};
	ClutterTransitionGroup* _tmp23_;
#line 415 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/game.vala"
	g_return_if_fail (pos != NULL);
#line 417 "../src/game.vala"
	_tmp0_ = self->priv->_foreground_cur;
#line 417 "../src/game.vala"
	_tmp0__length1 = self->priv->_foreground_cur_length1;
#line 417 "../src/game.vala"
	_tmp0__length2 = self->priv->_foreground_cur_length2;
#line 417 "../src/game.vala"
	_tmp1_ = *pos;
#line 417 "../src/game.vala"
	_tmp2_ = *pos;
#line 417 "../src/game.vala"
	_tmp3_ = _tmp0_[(_tmp1_.row * _tmp0__length2) + _tmp2_.col];
#line 417 "../src/game.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 417 "../src/game.vala"
	tile_view = _tmp4_;
#line 418 "../src/game.vala"
	if (tile_view == NULL) {
#line 419 "../src/game.vala"
		g_assert_not_reached ();
#line 2575 "game.c"
	}
#line 420 "../src/game.vala"
	_tmp5_ = grid_position_to_string (pos);
#line 420 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 420 "../src/game.vala"
	_tmp7_ = g_strconcat ("diming tile at ", _tmp6_, " ", NULL);
#line 420 "../src/game.vala"
	_tmp8_ = _tmp7_;
#line 420 "../src/game.vala"
	_tmp9_ = rounded_rectangle_get_color ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 420 "../src/game.vala"
	_tmp10_ = _tmp9_;
#line 420 "../src/game.vala"
	_tmp11_ = g_strdup_printf ("%hhu", _tmp10_);
#line 420 "../src/game.vala"
	_tmp12_ = _tmp11_;
#line 420 "../src/game.vala"
	_tmp13_ = g_strconcat (_tmp8_, _tmp12_, NULL);
#line 420 "../src/game.vala"
	_tmp14_ = _tmp13_;
#line 420 "../src/game.vala"
	g_debug ("game.vala:420: %s", _tmp14_);
#line 420 "../src/game.vala"
	_g_free0 (_tmp14_);
#line 420 "../src/game.vala"
	_g_free0 (_tmp12_);
#line 420 "../src/game.vala"
	_g_free0 (_tmp8_);
#line 420 "../src/game.vala"
	_g_free0 (_tmp6_);
#line 425 "../src/game.vala"
	_tmp15_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 425 "../src/game.vala"
	_tmp16_ = _tmp15_;
#line 425 "../src/game.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 425 "../src/game.vala"
	_g_object_unref0 (actor);
#line 425 "../src/game.vala"
	actor = _tmp17_;
#line 427 "../src/game.vala"
	_tmp18_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 427 "../src/game.vala"
	_g_object_unref0 (trans);
#line 427 "../src/game.vala"
	trans = _tmp18_;
#line 428 "../src/game.vala"
	_tmp19_ = clutter_actor_get_opacity (actor);
#line 428 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 428 "../src/game.vala"
	g_value_init (&_tmp21_, G_TYPE_UINT);
#line 428 "../src/game.vala"
	g_value_set_uint (&_tmp21_, _tmp20_);
#line 428 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) trans, &_tmp21_);
#line 428 "../src/game.vala"
	G_IS_VALUE (&_tmp21_) ? (g_value_unset (&_tmp21_), NULL) : NULL;
#line 429 "../src/game.vala"
	g_value_init (&_tmp22_, G_TYPE_INT);
#line 429 "../src/game.vala"
	g_value_set_int (&_tmp22_, 0);
#line 429 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) trans, &_tmp22_);
#line 429 "../src/game.vala"
	G_IS_VALUE (&_tmp22_) ? (g_value_unset (&_tmp22_), NULL) : NULL;
#line 430 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) trans, (guint) self->priv->_animations_duration);
#line 431 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) trans, (ClutterAnimatable*) actor);
#line 433 "../src/game.vala"
	_tmp23_ = self->priv->_show_hide_trans;
#line 433 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp23_, (ClutterTransition*) trans);
#line 415 "../src/game.vala"
	_g_object_unref0 (trans);
#line 415 "../src/game.vala"
	_g_object_unref0 (actor);
#line 415 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 2657 "game.c"
}

static void
_game_clear_background (Game* self)
{
	ClutterActor* _tmp0_;
#line 436 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/game.vala"
	_tmp0_ = self->priv->_view_background;
#line 438 "../src/game.vala"
	clutter_actor_remove_all_children (_tmp0_);
#line 2670 "game.c"
}

static void
_game_clear_foreground (Game* self)
{
	gint rows = 0;
	Grid* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint cols = 0;
	Grid* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	ClutterActor* _tmp6_;
#line 441 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 443 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 443 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 443 "../src/game.vala"
	rows = _tmp2_;
#line 444 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 444 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 444 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 444 "../src/game.vala"
	cols = _tmp5_;
#line 445 "../src/game.vala"
	_tmp6_ = self->priv->_view_foreground;
#line 445 "../src/game.vala"
	clutter_actor_remove_all_children (_tmp6_);
#line 2707 "game.c"
	{
		gint i = 0;
#line 446 "../src/game.vala"
		i = 0;
#line 2712 "game.c"
		{
			gboolean _tmp7_ = FALSE;
#line 446 "../src/game.vala"
			_tmp7_ = TRUE;
#line 446 "../src/game.vala"
			while (TRUE) {
#line 446 "../src/game.vala"
				if (!_tmp7_) {
#line 2721 "game.c"
					gint _tmp8_;
#line 446 "../src/game.vala"
					_tmp8_ = i;
#line 446 "../src/game.vala"
					i = _tmp8_ + 1;
#line 2727 "game.c"
				}
#line 446 "../src/game.vala"
				_tmp7_ = FALSE;
#line 446 "../src/game.vala"
				if (!(i < rows)) {
#line 446 "../src/game.vala"
					break;
#line 2735 "game.c"
				}
				{
					gint j = 0;
#line 448 "../src/game.vala"
					j = 0;
#line 2741 "game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 448 "../src/game.vala"
						_tmp9_ = TRUE;
#line 448 "../src/game.vala"
						while (TRUE) {
#line 2748 "game.c"
							TileView** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							TileView* _tmp12_;
							TileView** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							TileView* _tmp15_;
#line 448 "../src/game.vala"
							if (!_tmp9_) {
#line 2759 "game.c"
								gint _tmp10_;
#line 448 "../src/game.vala"
								_tmp10_ = j;
#line 448 "../src/game.vala"
								j = _tmp10_ + 1;
#line 2765 "game.c"
							}
#line 448 "../src/game.vala"
							_tmp9_ = FALSE;
#line 448 "../src/game.vala"
							if (!(j < cols)) {
#line 448 "../src/game.vala"
								break;
#line 2773 "game.c"
							}
#line 450 "../src/game.vala"
							_tmp11_ = self->priv->_foreground_cur;
#line 450 "../src/game.vala"
							_tmp11__length1 = self->priv->_foreground_cur_length1;
#line 450 "../src/game.vala"
							_tmp11__length2 = self->priv->_foreground_cur_length2;
#line 450 "../src/game.vala"
							_tmp12_ = _tmp11_[(i * _tmp11__length2) + j];
#line 450 "../src/game.vala"
							if (_tmp12_ != NULL) {
#line 2785 "game.c"
								TileView** _tmp13_;
								gint _tmp13__length1;
								gint _tmp13__length2;
#line 451 "../src/game.vala"
								_tmp13_ = self->priv->_foreground_cur;
#line 451 "../src/game.vala"
								_tmp13__length1 = self->priv->_foreground_cur_length1;
#line 451 "../src/game.vala"
								_tmp13__length2 = self->priv->_foreground_cur_length2;
#line 451 "../src/game.vala"
								_g_object_unref0 (_tmp13_[(i * _tmp13__length2) + j]);
#line 451 "../src/game.vala"
								_tmp13_[(i * _tmp13__length2) + j] = NULL;
#line 2799 "game.c"
							}
#line 452 "../src/game.vala"
							_tmp14_ = self->priv->_foreground_nxt;
#line 452 "../src/game.vala"
							_tmp14__length1 = self->priv->_foreground_nxt_length1;
#line 452 "../src/game.vala"
							_tmp14__length2 = self->priv->_foreground_nxt_length2;
#line 452 "../src/game.vala"
							_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 452 "../src/game.vala"
							if (_tmp15_ != NULL) {
#line 2811 "game.c"
								TileView** _tmp16_;
								gint _tmp16__length1;
								gint _tmp16__length2;
#line 453 "../src/game.vala"
								_tmp16_ = self->priv->_foreground_nxt;
#line 453 "../src/game.vala"
								_tmp16__length1 = self->priv->_foreground_nxt_length1;
#line 453 "../src/game.vala"
								_tmp16__length2 = self->priv->_foreground_nxt_length2;
#line 453 "../src/game.vala"
								_g_object_unref0 (_tmp16_[(i * _tmp16__length2) + j]);
#line 453 "../src/game.vala"
								_tmp16_[(i * _tmp16__length2) + j] = NULL;
#line 2825 "game.c"
							}
						}
					}
				}
			}
		}
	}
}

static void
_game_restore_foreground (Game* self,
                          gboolean animate)
{
	gint rows = 0;
	Grid* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint cols = 0;
	Grid* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeLinkedList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 458 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 460 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 460 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 460 "../src/game.vala"
	rows = _tmp2_;
#line 461 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 461 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 461 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 461 "../src/game.vala"
	cols = _tmp5_;
#line 463 "../src/game.vala"
	_game_create_show_hide_transition (self, animate);
#line 2870 "game.c"
	{
		gint i = 0;
#line 465 "../src/game.vala"
		i = 0;
#line 2875 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 465 "../src/game.vala"
			_tmp6_ = TRUE;
#line 465 "../src/game.vala"
			while (TRUE) {
#line 465 "../src/game.vala"
				if (!_tmp6_) {
#line 2884 "game.c"
					gint _tmp7_;
#line 465 "../src/game.vala"
					_tmp7_ = i;
#line 465 "../src/game.vala"
					i = _tmp7_ + 1;
#line 2890 "game.c"
				}
#line 465 "../src/game.vala"
				_tmp6_ = FALSE;
#line 465 "../src/game.vala"
				if (!(i < rows)) {
#line 465 "../src/game.vala"
					break;
#line 2898 "game.c"
				}
				{
					gint j = 0;
#line 467 "../src/game.vala"
					j = 0;
#line 2904 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 467 "../src/game.vala"
						_tmp8_ = TRUE;
#line 467 "../src/game.vala"
						while (TRUE) {
#line 2911 "game.c"
							guint8 val = 0U;
							Grid* _tmp10_;
#line 467 "../src/game.vala"
							if (!_tmp8_) {
#line 2916 "game.c"
								gint _tmp9_;
#line 467 "../src/game.vala"
								_tmp9_ = j;
#line 467 "../src/game.vala"
								j = _tmp9_ + 1;
#line 2922 "game.c"
							}
#line 467 "../src/game.vala"
							_tmp8_ = FALSE;
#line 467 "../src/game.vala"
							if (!(j < cols)) {
#line 467 "../src/game.vala"
								break;
#line 2930 "game.c"
							}
#line 469 "../src/game.vala"
							_tmp10_ = self->priv->_grid;
#line 469 "../src/game.vala"
							val = grid_get (_tmp10_, i, j);
#line 470 "../src/game.vala"
							if (((gint) val) != 0) {
#line 2938 "game.c"
								GridPosition pos = {0};
								GridPosition _tmp11_ = {0};
								Tile tile = {0};
								GridPosition _tmp12_;
								Tile _tmp13_ = {0};
								Tile _tmp14_;
								GeeLinkedList* _tmp15_;
								Tile _tmp16_;
								GridPosition _tmp17_;
#line 472 "../src/game.vala"
								_tmp11_.row = i;
#line 472 "../src/game.vala"
								_tmp11_.col = j;
#line 472 "../src/game.vala"
								pos = _tmp11_;
#line 473 "../src/game.vala"
								_tmp12_ = pos;
#line 473 "../src/game.vala"
								_tmp13_.pos = _tmp12_;
#line 473 "../src/game.vala"
								_tmp13_.val = val;
#line 473 "../src/game.vala"
								tile = _tmp13_;
#line 474 "../src/game.vala"
								_tmp14_ = tile;
#line 474 "../src/game.vala"
								_game_create_tile (self, &_tmp14_);
#line 475 "../src/game.vala"
								_tmp15_ = self->priv->_to_show;
#line 475 "../src/game.vala"
								_tmp16_ = tile;
#line 475 "../src/game.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp16_);
#line 476 "../src/game.vala"
								_tmp17_ = pos;
#line 476 "../src/game.vala"
								_game_show_tile (self, &_tmp17_);
#line 2976 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 481 "../src/game.vala"
	_tmp18_ = self->priv->_to_show;
#line 481 "../src/game.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 481 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 481 "../src/game.vala"
	if (_tmp20_ > 0) {
#line 2992 "game.c"
		ClutterTransitionGroup* _tmp21_;
#line 483 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_RESTORING_TILES;
#line 484 "../src/game.vala"
		_tmp21_ = self->priv->_show_hide_trans;
#line 484 "../src/game.vala"
		clutter_timeline_start ((ClutterTimeline*) _tmp21_);
#line 3000 "game.c"
	}
}

static void
__game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                       gboolean is_finished,
                                                       gpointer self)
{
#line 504 "../src/game.vala"
	_game_on_move_trans_stopped ((Game*) self, _sender, is_finished);
#line 3011 "game.c"
}

void
game_move (Game* self,
           MoveRequest request)
{
	GameGameState _tmp0_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Grid* clone = NULL;
	Grid* _tmp4_;
	Grid* _tmp5_;
	ClutterTransitionGroup* _tmp6_;
	ClutterTransitionGroup* _tmp7_;
	ClutterTransitionGroup* _tmp8_;
	Grid* _tmp9_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GeeLinkedList* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
#line 492 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 494 "../src/game.vala"
	_tmp0_ = self->priv->_state;
#line 494 "../src/game.vala"
	if (_tmp0_ == GAME_GAME_STATE_SHOWING_NEW_TILE) {
#line 495 "../src/game.vala"
		_game_apply_move (self);
#line 3041 "game.c"
	} else {
		GameGameState _tmp1_;
#line 496 "../src/game.vala"
		_tmp1_ = self->priv->_state;
#line 496 "../src/game.vala"
		if (_tmp1_ != GAME_GAME_STATE_IDLE) {
#line 497 "../src/game.vala"
			g_assert_not_reached ();
#line 3050 "game.c"
		}
	}
#line 499 "../src/game.vala"
	_tmp2_ = move_request_debug_string (request);
#line 499 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 499 "../src/game.vala"
	g_debug ("game.vala:499: %s", _tmp3_);
#line 499 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 501 "../src/game.vala"
	_tmp4_ = self->priv->_grid;
#line 501 "../src/game.vala"
	_tmp5_ = grid_clone (_tmp4_);
#line 501 "../src/game.vala"
	clone = _tmp5_;
#line 503 "../src/game.vala"
	_tmp6_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 503 "../src/game.vala"
	_g_object_unref0 (self->priv->_move_trans);
#line 503 "../src/game.vala"
	self->priv->_move_trans = _tmp6_;
#line 504 "../src/game.vala"
	_tmp7_ = self->priv->_move_trans;
#line 504 "../src/game.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp7_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
#line 505 "../src/game.vala"
	_tmp8_ = self->priv->_move_trans;
#line 505 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp8_, (guint) self->priv->_animations_duration);
#line 507 "../src/game.vala"
	_tmp9_ = self->priv->_grid;
#line 507 "../src/game.vala"
	grid_move (_tmp9_, request, &self->priv->_to_move, &self->priv->_to_hide, &self->priv->_to_show);
#line 3085 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp10_;
		GeeLinkedList* _tmp11_;
		gint _e_size = 0;
		GeeLinkedList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _e_index = 0;
#line 509 "../src/game.vala"
		_tmp10_ = self->priv->_to_move;
#line 509 "../src/game.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 509 "../src/game.vala"
		_e_list = _tmp11_;
#line 509 "../src/game.vala"
		_tmp12_ = _e_list;
#line 509 "../src/game.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 509 "../src/game.vala"
		_tmp14_ = _tmp13_;
#line 509 "../src/game.vala"
		_e_size = _tmp14_;
#line 509 "../src/game.vala"
		_e_index = -1;
#line 509 "../src/game.vala"
		while (TRUE) {
#line 3113 "game.c"
			TileMovement* e = NULL;
			GeeLinkedList* _tmp15_;
			gpointer _tmp16_;
			TileMovement* _tmp17_;
			TileMovement* _tmp18_;
			GridPosition _tmp19_;
			TileMovement* _tmp20_;
			GridPosition _tmp21_;
#line 509 "../src/game.vala"
			_e_index = _e_index + 1;
#line 509 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 509 "../src/game.vala"
				break;
#line 3128 "game.c"
			}
#line 509 "../src/game.vala"
			_tmp15_ = _e_list;
#line 509 "../src/game.vala"
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _e_index);
#line 509 "../src/game.vala"
			e = (TileMovement*) _tmp16_;
#line 511 "../src/game.vala"
			_tmp17_ = e;
#line 511 "../src/game.vala"
			if (_tmp17_ == NULL) {
#line 512 "../src/game.vala"
				g_assert_not_reached ();
#line 3142 "game.c"
			}
#line 513 "../src/game.vala"
			_tmp18_ = e;
#line 513 "../src/game.vala"
			_tmp19_ = ((TileMovement) (*_tmp18_)).from;
#line 513 "../src/game.vala"
			_tmp20_ = e;
#line 513 "../src/game.vala"
			_tmp21_ = ((TileMovement) (*_tmp20_)).to;
#line 513 "../src/game.vala"
			_game_move_tile (self, &_tmp19_, &_tmp21_);
#line 509 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3156 "game.c"
		}
#line 509 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3160 "game.c"
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp22_;
		GeeLinkedList* _tmp23_;
		gint _e_size = 0;
		GeeLinkedList* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _e_index = 0;
#line 515 "../src/game.vala"
		_tmp22_ = self->priv->_to_hide;
#line 515 "../src/game.vala"
		_tmp23_ = _g_object_ref0 (_tmp22_);
#line 515 "../src/game.vala"
		_e_list = _tmp23_;
#line 515 "../src/game.vala"
		_tmp24_ = _e_list;
#line 515 "../src/game.vala"
		_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 515 "../src/game.vala"
		_tmp26_ = _tmp25_;
#line 515 "../src/game.vala"
		_e_size = _tmp26_;
#line 515 "../src/game.vala"
		_e_index = -1;
#line 515 "../src/game.vala"
		while (TRUE) {
#line 3189 "game.c"
			TileMovement* e = NULL;
			GeeLinkedList* _tmp27_;
			gpointer _tmp28_;
			TileMovement* _tmp29_;
			TileMovement* _tmp30_;
			GridPosition _tmp31_;
			TileMovement* _tmp32_;
			GridPosition _tmp33_;
#line 515 "../src/game.vala"
			_e_index = _e_index + 1;
#line 515 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 515 "../src/game.vala"
				break;
#line 3204 "game.c"
			}
#line 515 "../src/game.vala"
			_tmp27_ = _e_list;
#line 515 "../src/game.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _e_index);
#line 515 "../src/game.vala"
			e = (TileMovement*) _tmp28_;
#line 517 "../src/game.vala"
			_tmp29_ = e;
#line 517 "../src/game.vala"
			if (_tmp29_ == NULL) {
#line 518 "../src/game.vala"
				g_assert_not_reached ();
#line 3218 "game.c"
			}
#line 519 "../src/game.vala"
			_tmp30_ = e;
#line 519 "../src/game.vala"
			_tmp31_ = ((TileMovement) (*_tmp30_)).from;
#line 519 "../src/game.vala"
			_tmp32_ = e;
#line 519 "../src/game.vala"
			_tmp33_ = ((TileMovement) (*_tmp32_)).to;
#line 519 "../src/game.vala"
			_game_prepare_move_tile (self, &_tmp31_, &_tmp33_);
#line 515 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3232 "game.c"
		}
#line 515 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3236 "game.c"
	}
#line 522 "../src/game.vala"
	_tmp36_ = self->priv->_to_move;
#line 522 "../src/game.vala"
	_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 522 "../src/game.vala"
	_tmp38_ = _tmp37_;
#line 522 "../src/game.vala"
	if (_tmp38_ > 0) {
#line 522 "../src/game.vala"
		_tmp35_ = TRUE;
#line 3248 "game.c"
	} else {
		GeeLinkedList* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
#line 522 "../src/game.vala"
		_tmp39_ = self->priv->_to_hide;
#line 522 "../src/game.vala"
		_tmp40_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp39_);
#line 522 "../src/game.vala"
		_tmp41_ = _tmp40_;
#line 522 "../src/game.vala"
		_tmp35_ = _tmp41_ > 0;
#line 3261 "game.c"
	}
#line 522 "../src/game.vala"
	if (_tmp35_) {
#line 522 "../src/game.vala"
		_tmp34_ = TRUE;
#line 3267 "game.c"
	} else {
		GeeLinkedList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
#line 522 "../src/game.vala"
		_tmp42_ = self->priv->_to_show;
#line 522 "../src/game.vala"
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 522 "../src/game.vala"
		_tmp44_ = _tmp43_;
#line 522 "../src/game.vala"
		_tmp34_ = _tmp44_ > 0;
#line 3280 "game.c"
	}
#line 522 "../src/game.vala"
	if (_tmp34_) {
#line 3284 "game.c"
		ClutterTransitionGroup* _tmp45_;
		Grid* _tmp46_;
#line 524 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_MOVING;
#line 525 "../src/game.vala"
		_tmp45_ = self->priv->_move_trans;
#line 525 "../src/game.vala"
		clutter_timeline_start ((ClutterTimeline*) _tmp45_);
#line 526 "../src/game.vala"
		_tmp46_ = clone;
#line 526 "../src/game.vala"
		_game_store_movement (self, _tmp46_);
#line 3297 "game.c"
	}
#line 529 "../src/game.vala"
	self->priv->_just_restored = FALSE;
#line 492 "../src/game.vala"
	_g_object_unref0 (clone);
#line 3303 "game.c"
}

static void
_game_on_move_trans_stopped (Game* self,
                             ClutterTimeline* trans,
                             gboolean is_finished)
{
	Grid* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	glong delta_score = 0L;
	glong _tmp28_;
#line 532 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/game.vala"
	g_return_if_fail (trans != NULL);
#line 534 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 534 "../src/game.vala"
	_tmp1_ = grid_to_string (_tmp0_);
#line 534 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 534 "../src/game.vala"
	_tmp3_ = g_strconcat ("move animation stopped\n", _tmp2_, NULL);
#line 534 "../src/game.vala"
	_tmp4_ = _tmp3_;
#line 534 "../src/game.vala"
	g_debug ("game.vala:534: %s", _tmp4_);
#line 534 "../src/game.vala"
	_g_free0 (_tmp4_);
#line 534 "../src/game.vala"
	_g_free0 (_tmp2_);
#line 536 "../src/game.vala"
	clutter_transition_group_remove_all (G_TYPE_CHECK_INSTANCE_CAST (trans, clutter_transition_group_get_type (), ClutterTransitionGroup));
#line 3340 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp5_;
		GeeLinkedList* _tmp6_;
		gint _e_size = 0;
		GeeLinkedList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _e_index = 0;
#line 538 "../src/game.vala"
		_tmp5_ = self->priv->_to_hide;
#line 538 "../src/game.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 538 "../src/game.vala"
		_e_list = _tmp6_;
#line 538 "../src/game.vala"
		_tmp7_ = _e_list;
#line 538 "../src/game.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 538 "../src/game.vala"
		_tmp9_ = _tmp8_;
#line 538 "../src/game.vala"
		_e_size = _tmp9_;
#line 538 "../src/game.vala"
		_e_index = -1;
#line 538 "../src/game.vala"
		while (TRUE) {
#line 3368 "game.c"
			TileMovement* e = NULL;
			GeeLinkedList* _tmp10_;
			gpointer _tmp11_;
			TileMovement* _tmp12_;
			TileMovement* _tmp13_;
			GridPosition _tmp14_;
#line 538 "../src/game.vala"
			_e_index = _e_index + 1;
#line 538 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 538 "../src/game.vala"
				break;
#line 3381 "game.c"
			}
#line 538 "../src/game.vala"
			_tmp10_ = _e_list;
#line 538 "../src/game.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _e_index);
#line 538 "../src/game.vala"
			e = (TileMovement*) _tmp11_;
#line 540 "../src/game.vala"
			_tmp12_ = e;
#line 540 "../src/game.vala"
			if (_tmp12_ == NULL) {
#line 541 "../src/game.vala"
				g_assert_not_reached ();
#line 3395 "game.c"
			}
#line 542 "../src/game.vala"
			_tmp13_ = e;
#line 542 "../src/game.vala"
			_tmp14_ = ((TileMovement) (*_tmp13_)).from;
#line 542 "../src/game.vala"
			_game_dim_tile (self, &_tmp14_);
#line 538 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3405 "game.c"
		}
#line 538 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3409 "game.c"
	}
#line 545 "../src/game.vala"
	delta_score = (glong) 0;
#line 3413 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp15_;
		GeeLinkedList* _tmp16_;
		gint _e_size = 0;
		GeeLinkedList* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _e_index = 0;
#line 546 "../src/game.vala"
		_tmp15_ = self->priv->_to_show;
#line 546 "../src/game.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 546 "../src/game.vala"
		_e_list = _tmp16_;
#line 546 "../src/game.vala"
		_tmp17_ = _e_list;
#line 546 "../src/game.vala"
		_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 546 "../src/game.vala"
		_tmp19_ = _tmp18_;
#line 546 "../src/game.vala"
		_e_size = _tmp19_;
#line 546 "../src/game.vala"
		_e_index = -1;
#line 546 "../src/game.vala"
		while (TRUE) {
#line 3441 "game.c"
			Tile* e = NULL;
			GeeLinkedList* _tmp20_;
			gpointer _tmp21_;
			Tile* _tmp22_;
			Tile* _tmp23_;
			Tile _tmp24_;
			Tile* _tmp25_;
			GridPosition _tmp26_;
			Tile* _tmp27_;
#line 546 "../src/game.vala"
			_e_index = _e_index + 1;
#line 546 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 546 "../src/game.vala"
				break;
#line 3457 "game.c"
			}
#line 546 "../src/game.vala"
			_tmp20_ = _e_list;
#line 546 "../src/game.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _e_index);
#line 546 "../src/game.vala"
			e = (Tile*) _tmp21_;
#line 548 "../src/game.vala"
			_tmp22_ = e;
#line 548 "../src/game.vala"
			if (_tmp22_ == NULL) {
#line 549 "../src/game.vala"
				g_assert_not_reached ();
#line 3471 "game.c"
			}
#line 550 "../src/game.vala"
			_tmp23_ = e;
#line 550 "../src/game.vala"
			_tmp24_ = (Tile) (*_tmp23_);
#line 550 "../src/game.vala"
			_game_create_tile (self, &_tmp24_);
#line 551 "../src/game.vala"
			_tmp25_ = e;
#line 551 "../src/game.vala"
			_tmp26_ = ((Tile) (*_tmp25_)).pos;
#line 551 "../src/game.vala"
			_game_show_tile (self, &_tmp26_);
#line 552 "../src/game.vala"
			_tmp27_ = e;
#line 552 "../src/game.vala"
			delta_score = delta_score + ((glong) pow ((gdouble) 2, (gdouble) ((Tile) (*_tmp27_)).val));
#line 546 "../src/game.vala"
			_tile_free0 (e);
#line 3491 "game.c"
		}
#line 546 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3495 "game.c"
	}
#line 554 "../src/game.vala"
	_tmp28_ = self->priv->_score;
#line 554 "../src/game.vala"
	game_set_score (self, _tmp28_ + delta_score);
#line 556 "../src/game.vala"
	_game_create_random_tile (self);
#line 3503 "game.c"
}

static void
__game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                            gboolean is_finished,
                                                            gpointer self)
{
#line 572 "../src/game.vala"
	_game_on_show_hide_trans_stopped ((Game*) self, _sender, is_finished);
#line 3513 "game.c"
}

static void
_game_create_show_hide_transition (Game* self,
                                   gboolean animate)
{
	ClutterTransitionGroup* _tmp0_;
	ClutterTransitionGroup* _tmp1_;
	gint _tmp2_ = 0;
	ClutterTransitionGroup* _tmp3_;
#line 569 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/game.vala"
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 571 "../src/game.vala"
	_g_object_unref0 (self->priv->_show_hide_trans);
#line 571 "../src/game.vala"
	self->priv->_show_hide_trans = _tmp0_;
#line 572 "../src/game.vala"
	_tmp1_ = self->priv->_show_hide_trans;
#line 572 "../src/game.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_show_hide_trans_stopped_clutter_timeline_stopped, self, 0);
#line 575 "../src/game.vala"
	if (animate) {
#line 575 "../src/game.vala"
		_tmp2_ = self->priv->_animations_duration / 3;
#line 3540 "game.c"
	} else {
#line 575 "../src/game.vala"
		_tmp2_ = 10;
#line 3544 "game.c"
	}
#line 575 "../src/game.vala"
	_tmp3_ = self->priv->_show_hide_trans;
#line 575 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp3_, (guint) _tmp2_);
#line 3550 "game.c"
}

static void
_game_on_show_hide_trans_stopped (Game* self,
                                  ClutterTimeline* trans,
                                  gboolean is_finished)
{
	ClutterTimelineDirection _tmp0_;
	ClutterTimelineDirection _tmp1_;
#line 578 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/game.vala"
	g_return_if_fail (trans != NULL);
#line 580 "../src/game.vala"
	g_debug ("game.vala:580: show/hide animation stopped");
#line 582 "../src/game.vala"
	_tmp0_ = clutter_timeline_get_direction (trans);
#line 582 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 582 "../src/game.vala"
	if (_tmp1_ == CLUTTER_TIMELINE_FORWARD) {
#line 584 "../src/game.vala"
		clutter_timeline_set_direction (trans, CLUTTER_TIMELINE_BACKWARD);
#line 585 "../src/game.vala"
		clutter_timeline_start (trans);
#line 586 "../src/game.vala"
		return;
#line 3578 "game.c"
	}
#line 589 "../src/game.vala"
	clutter_transition_group_remove_all (G_TYPE_CHECK_INSTANCE_CAST (trans, clutter_transition_group_get_type (), ClutterTransitionGroup));
#line 590 "../src/game.vala"
	_game_apply_move (self);
#line 3584 "game.c"
}

static gboolean
__game_finish_move_gsource_func (gpointer self)
{
	gboolean result;
	result = _game_finish_move ((Game*) self);
#line 658 "../src/game.vala"
	return result;
#line 3594 "game.c"
}

static void
_game_apply_move (Game* self)
{
	Grid* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GameGameState _tmp38_;
	GeeLinkedList* _tmp82_;
	GeeLinkedList* _tmp83_;
	GeeLinkedList* _tmp84_;
	Grid* _tmp85_;
	gboolean _tmp86_;
	gboolean _tmp87_;
#line 593 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 595 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 595 "../src/game.vala"
	_tmp1_ = grid_to_string (_tmp0_);
#line 595 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 595 "../src/game.vala"
	g_debug ("game.vala:595: %s", _tmp2_);
#line 595 "../src/game.vala"
	_g_free0 (_tmp2_);
#line 597 "../src/game.vala"
	if (self->priv->_update_handled) {
#line 3625 "game.c"
		GameGameState _tmp4_;
#line 597 "../src/game.vala"
		_tmp4_ = self->priv->_state;
#line 597 "../src/game.vala"
		_tmp3_ = _tmp4_ != GAME_GAME_STATE_SHOWING_FIRST_TILE;
#line 3631 "game.c"
	} else {
#line 597 "../src/game.vala"
		_tmp3_ = FALSE;
#line 3635 "game.c"
	}
#line 597 "../src/game.vala"
	if (_tmp3_) {
#line 598 "../src/game.vala"
		return;
#line 3641 "game.c"
	}
#line 599 "../src/game.vala"
	self->priv->_update_handled = TRUE;
#line 3645 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp5_;
		GeeLinkedList* _tmp6_;
		gint _e_size = 0;
		GeeLinkedList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _e_index = 0;
#line 601 "../src/game.vala"
		_tmp5_ = self->priv->_to_hide;
#line 601 "../src/game.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 601 "../src/game.vala"
		_e_list = _tmp6_;
#line 601 "../src/game.vala"
		_tmp7_ = _e_list;
#line 601 "../src/game.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 601 "../src/game.vala"
		_tmp9_ = _tmp8_;
#line 601 "../src/game.vala"
		_e_size = _tmp9_;
#line 601 "../src/game.vala"
		_e_index = -1;
#line 601 "../src/game.vala"
		while (TRUE) {
#line 3673 "game.c"
			TileMovement* e = NULL;
			GeeLinkedList* _tmp10_;
			gpointer _tmp11_;
			TileMovement* _tmp12_;
			GridPosition pos = {0};
			TileMovement* _tmp13_;
			GridPosition _tmp14_;
			TileView* tile_view = NULL;
			TileView** _tmp15_;
			gint _tmp15__length1;
			gint _tmp15__length2;
			GridPosition _tmp16_;
			GridPosition _tmp17_;
			TileView* _tmp18_;
			TileView* _tmp19_;
			TileView* _tmp20_;
			TileView* _tmp21_;
			ClutterActor* _tmp22_;
			ClutterActor* _tmp23_;
			TileView* _tmp24_;
			guint8 _tmp25_;
			guint8 _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			ClutterActor* _tmp31_;
			TileView* _tmp32_;
			ClutterActor* _tmp33_;
			ClutterActor* _tmp34_;
			TileView** _tmp35_;
			gint _tmp35__length1;
			gint _tmp35__length2;
			GridPosition _tmp36_;
			GridPosition _tmp37_;
#line 601 "../src/game.vala"
			_e_index = _e_index + 1;
#line 601 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 601 "../src/game.vala"
				break;
#line 3715 "game.c"
			}
#line 601 "../src/game.vala"
			_tmp10_ = _e_list;
#line 601 "../src/game.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _e_index);
#line 601 "../src/game.vala"
			e = (TileMovement*) _tmp11_;
#line 603 "../src/game.vala"
			_tmp12_ = e;
#line 603 "../src/game.vala"
			if (_tmp12_ == NULL) {
#line 604 "../src/game.vala"
				g_assert_not_reached ();
#line 3729 "game.c"
			}
#line 605 "../src/game.vala"
			_tmp13_ = e;
#line 605 "../src/game.vala"
			_tmp14_ = ((TileMovement) (*_tmp13_)).from;
#line 605 "../src/game.vala"
			pos = _tmp14_;
#line 606 "../src/game.vala"
			_tmp15_ = self->priv->_foreground_cur;
#line 606 "../src/game.vala"
			_tmp15__length1 = self->priv->_foreground_cur_length1;
#line 606 "../src/game.vala"
			_tmp15__length2 = self->priv->_foreground_cur_length2;
#line 606 "../src/game.vala"
			_tmp16_ = pos;
#line 606 "../src/game.vala"
			_tmp17_ = pos;
#line 606 "../src/game.vala"
			_tmp18_ = _tmp15_[(_tmp16_.row * _tmp15__length2) + _tmp17_.col];
#line 606 "../src/game.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 606 "../src/game.vala"
			tile_view = _tmp19_;
#line 607 "../src/game.vala"
			_tmp20_ = tile_view;
#line 607 "../src/game.vala"
			if (_tmp20_ == NULL) {
#line 608 "../src/game.vala"
				g_assert_not_reached ();
#line 3759 "game.c"
			}
#line 609 "../src/game.vala"
			_tmp21_ = tile_view;
#line 609 "../src/game.vala"
			_tmp22_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_TILE_VIEW, TileView));
#line 609 "../src/game.vala"
			_tmp23_ = _tmp22_;
#line 609 "../src/game.vala"
			clutter_actor_hide (_tmp23_);
#line 610 "../src/game.vala"
			_tmp24_ = tile_view;
#line 610 "../src/game.vala"
			_tmp25_ = rounded_rectangle_get_color ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_TILE_VIEW, TileView));
#line 610 "../src/game.vala"
			_tmp26_ = _tmp25_;
#line 610 "../src/game.vala"
			_tmp27_ = g_strdup_printf ("%hhu", _tmp26_);
#line 610 "../src/game.vala"
			_tmp28_ = _tmp27_;
#line 610 "../src/game.vala"
			_tmp29_ = g_strconcat ("remove child ", _tmp28_, NULL);
#line 610 "../src/game.vala"
			_tmp30_ = _tmp29_;
#line 610 "../src/game.vala"
			g_debug ("game.vala:610: %s", _tmp30_);
#line 610 "../src/game.vala"
			_g_free0 (_tmp30_);
#line 610 "../src/game.vala"
			_g_free0 (_tmp28_);
#line 611 "../src/game.vala"
			_tmp31_ = self->priv->_view_foreground;
#line 611 "../src/game.vala"
			_tmp32_ = tile_view;
#line 611 "../src/game.vala"
			_tmp33_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_TILE_VIEW, TileView));
#line 611 "../src/game.vala"
			_tmp34_ = _tmp33_;
#line 611 "../src/game.vala"
			clutter_actor_remove_child (_tmp31_, _tmp34_);
#line 613 "../src/game.vala"
			_tmp35_ = self->priv->_foreground_cur;
#line 613 "../src/game.vala"
			_tmp35__length1 = self->priv->_foreground_cur_length1;
#line 613 "../src/game.vala"
			_tmp35__length2 = self->priv->_foreground_cur_length2;
#line 613 "../src/game.vala"
			_tmp36_ = pos;
#line 613 "../src/game.vala"
			_tmp37_ = pos;
#line 613 "../src/game.vala"
			_g_object_unref0 (_tmp35_[(_tmp36_.row * _tmp35__length2) + _tmp37_.col]);
#line 613 "../src/game.vala"
			_tmp35_[(_tmp36_.row * _tmp35__length2) + _tmp37_.col] = NULL;
#line 601 "../src/game.vala"
			_g_object_unref0 (tile_view);
#line 601 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3817 "game.c"
		}
#line 601 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3821 "game.c"
	}
#line 616 "../src/game.vala"
	_tmp38_ = self->priv->_state;
#line 616 "../src/game.vala"
	if (_tmp38_ == GAME_GAME_STATE_SHOWING_FIRST_TILE) {
#line 618 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 619 "../src/game.vala"
		g_debug ("game.vala:619: state show second tile");
#line 620 "../src/game.vala"
		_game_create_random_tile (self);
#line 3833 "game.c"
	} else {
		GameGameState _tmp39_;
#line 622 "../src/game.vala"
		_tmp39_ = self->priv->_state;
#line 622 "../src/game.vala"
		if (_tmp39_ != GAME_GAME_STATE_IDLE) {
#line 624 "../src/game.vala"
			self->priv->_state = GAME_GAME_STATE_IDLE;
#line 625 "../src/game.vala"
			g_debug ("game.vala:625: state idle");
#line 3844 "game.c"
		}
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp40_;
		GeeLinkedList* _tmp41_;
		gint _e_size = 0;
		GeeLinkedList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _e_index = 0;
#line 628 "../src/game.vala"
		_tmp40_ = self->priv->_to_move;
#line 628 "../src/game.vala"
		_tmp41_ = _g_object_ref0 (_tmp40_);
#line 628 "../src/game.vala"
		_e_list = _tmp41_;
#line 628 "../src/game.vala"
		_tmp42_ = _e_list;
#line 628 "../src/game.vala"
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 628 "../src/game.vala"
		_tmp44_ = _tmp43_;
#line 628 "../src/game.vala"
		_e_size = _tmp44_;
#line 628 "../src/game.vala"
		_e_index = -1;
#line 628 "../src/game.vala"
		while (TRUE) {
#line 3874 "game.c"
			TileMovement* e = NULL;
			GeeLinkedList* _tmp45_;
			gpointer _tmp46_;
			TileMovement* _tmp47_;
			GridPosition to = {0};
			TileMovement* _tmp48_;
			GridPosition _tmp49_;
			TileView** _tmp50_;
			gint _tmp50__length1;
			gint _tmp50__length2;
			GridPosition _tmp51_;
			GridPosition _tmp52_;
			TileView** _tmp53_;
			gint _tmp53__length1;
			gint _tmp53__length2;
			GridPosition _tmp54_;
			GridPosition _tmp55_;
			TileView* _tmp56_;
			TileView* _tmp57_;
			TileView** _tmp58_;
			gint _tmp58__length1;
			gint _tmp58__length2;
			GridPosition _tmp59_;
			GridPosition _tmp60_;
#line 628 "../src/game.vala"
			_e_index = _e_index + 1;
#line 628 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 628 "../src/game.vala"
				break;
#line 3905 "game.c"
			}
#line 628 "../src/game.vala"
			_tmp45_ = _e_list;
#line 628 "../src/game.vala"
			_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, _e_index);
#line 628 "../src/game.vala"
			e = (TileMovement*) _tmp46_;
#line 630 "../src/game.vala"
			_tmp47_ = e;
#line 630 "../src/game.vala"
			if (_tmp47_ == NULL) {
#line 631 "../src/game.vala"
				g_assert_not_reached ();
#line 3919 "game.c"
			}
#line 632 "../src/game.vala"
			_tmp48_ = e;
#line 632 "../src/game.vala"
			_tmp49_ = ((TileMovement) (*_tmp48_)).to;
#line 632 "../src/game.vala"
			to = _tmp49_;
#line 633 "../src/game.vala"
			_tmp50_ = self->priv->_foreground_cur;
#line 633 "../src/game.vala"
			_tmp50__length1 = self->priv->_foreground_cur_length1;
#line 633 "../src/game.vala"
			_tmp50__length2 = self->priv->_foreground_cur_length2;
#line 633 "../src/game.vala"
			_tmp51_ = to;
#line 633 "../src/game.vala"
			_tmp52_ = to;
#line 633 "../src/game.vala"
			_tmp53_ = self->priv->_foreground_nxt;
#line 633 "../src/game.vala"
			_tmp53__length1 = self->priv->_foreground_nxt_length1;
#line 633 "../src/game.vala"
			_tmp53__length2 = self->priv->_foreground_nxt_length2;
#line 633 "../src/game.vala"
			_tmp54_ = to;
#line 633 "../src/game.vala"
			_tmp55_ = to;
#line 633 "../src/game.vala"
			_tmp56_ = _tmp53_[(_tmp54_.row * _tmp53__length2) + _tmp55_.col];
#line 633 "../src/game.vala"
			_tmp57_ = _g_object_ref0 (_tmp56_);
#line 633 "../src/game.vala"
			_g_object_unref0 (_tmp50_[(_tmp51_.row * _tmp50__length2) + _tmp52_.col]);
#line 633 "../src/game.vala"
			_tmp50_[(_tmp51_.row * _tmp50__length2) + _tmp52_.col] = _tmp57_;
#line 634 "../src/game.vala"
			_tmp58_ = self->priv->_foreground_nxt;
#line 634 "../src/game.vala"
			_tmp58__length1 = self->priv->_foreground_nxt_length1;
#line 634 "../src/game.vala"
			_tmp58__length2 = self->priv->_foreground_nxt_length2;
#line 634 "../src/game.vala"
			_tmp59_ = to;
#line 634 "../src/game.vala"
			_tmp60_ = to;
#line 634 "../src/game.vala"
			_g_object_unref0 (_tmp58_[(_tmp59_.row * _tmp58__length2) + _tmp60_.col]);
#line 634 "../src/game.vala"
			_tmp58_[(_tmp59_.row * _tmp58__length2) + _tmp60_.col] = NULL;
#line 628 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3971 "game.c"
		}
#line 628 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 3975 "game.c"
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp61_;
		GeeLinkedList* _tmp62_;
		gint _e_size = 0;
		GeeLinkedList* _tmp63_;
		gint _tmp64_;
		gint _tmp65_;
		gint _e_index = 0;
#line 636 "../src/game.vala"
		_tmp61_ = self->priv->_to_show;
#line 636 "../src/game.vala"
		_tmp62_ = _g_object_ref0 (_tmp61_);
#line 636 "../src/game.vala"
		_e_list = _tmp62_;
#line 636 "../src/game.vala"
		_tmp63_ = _e_list;
#line 636 "../src/game.vala"
		_tmp64_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp63_);
#line 636 "../src/game.vala"
		_tmp65_ = _tmp64_;
#line 636 "../src/game.vala"
		_e_size = _tmp65_;
#line 636 "../src/game.vala"
		_e_index = -1;
#line 636 "../src/game.vala"
		while (TRUE) {
#line 4004 "game.c"
			Tile* e = NULL;
			GeeLinkedList* _tmp66_;
			gpointer _tmp67_;
			Tile* _tmp68_;
			GridPosition pos = {0};
			Tile* _tmp69_;
			GridPosition _tmp70_;
			TileView** _tmp71_;
			gint _tmp71__length1;
			gint _tmp71__length2;
			GridPosition _tmp72_;
			GridPosition _tmp73_;
			TileView** _tmp74_;
			gint _tmp74__length1;
			gint _tmp74__length2;
			GridPosition _tmp75_;
			GridPosition _tmp76_;
			TileView* _tmp77_;
			TileView* _tmp78_;
			TileView** _tmp79_;
			gint _tmp79__length1;
			gint _tmp79__length2;
			GridPosition _tmp80_;
			GridPosition _tmp81_;
#line 636 "../src/game.vala"
			_e_index = _e_index + 1;
#line 636 "../src/game.vala"
			if (!(_e_index < _e_size)) {
#line 636 "../src/game.vala"
				break;
#line 4035 "game.c"
			}
#line 636 "../src/game.vala"
			_tmp66_ = _e_list;
#line 636 "../src/game.vala"
			_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _tmp66_, _e_index);
#line 636 "../src/game.vala"
			e = (Tile*) _tmp67_;
#line 638 "../src/game.vala"
			_tmp68_ = e;
#line 638 "../src/game.vala"
			if (_tmp68_ == NULL) {
#line 639 "../src/game.vala"
				g_assert_not_reached ();
#line 4049 "game.c"
			}
#line 640 "../src/game.vala"
			_tmp69_ = e;
#line 640 "../src/game.vala"
			_tmp70_ = ((Tile) (*_tmp69_)).pos;
#line 640 "../src/game.vala"
			pos = _tmp70_;
#line 641 "../src/game.vala"
			_tmp71_ = self->priv->_foreground_cur;
#line 641 "../src/game.vala"
			_tmp71__length1 = self->priv->_foreground_cur_length1;
#line 641 "../src/game.vala"
			_tmp71__length2 = self->priv->_foreground_cur_length2;
#line 641 "../src/game.vala"
			_tmp72_ = pos;
#line 641 "../src/game.vala"
			_tmp73_ = pos;
#line 641 "../src/game.vala"
			_tmp74_ = self->priv->_foreground_nxt;
#line 641 "../src/game.vala"
			_tmp74__length1 = self->priv->_foreground_nxt_length1;
#line 641 "../src/game.vala"
			_tmp74__length2 = self->priv->_foreground_nxt_length2;
#line 641 "../src/game.vala"
			_tmp75_ = pos;
#line 641 "../src/game.vala"
			_tmp76_ = pos;
#line 641 "../src/game.vala"
			_tmp77_ = _tmp74_[(_tmp75_.row * _tmp74__length2) + _tmp76_.col];
#line 641 "../src/game.vala"
			_tmp78_ = _g_object_ref0 (_tmp77_);
#line 641 "../src/game.vala"
			_g_object_unref0 (_tmp71_[(_tmp72_.row * _tmp71__length2) + _tmp73_.col]);
#line 641 "../src/game.vala"
			_tmp71_[(_tmp72_.row * _tmp71__length2) + _tmp73_.col] = _tmp78_;
#line 642 "../src/game.vala"
			_tmp79_ = self->priv->_foreground_nxt;
#line 642 "../src/game.vala"
			_tmp79__length1 = self->priv->_foreground_nxt_length1;
#line 642 "../src/game.vala"
			_tmp79__length2 = self->priv->_foreground_nxt_length2;
#line 642 "../src/game.vala"
			_tmp80_ = pos;
#line 642 "../src/game.vala"
			_tmp81_ = pos;
#line 642 "../src/game.vala"
			_g_object_unref0 (_tmp79_[(_tmp80_.row * _tmp79__length2) + _tmp81_.col]);
#line 642 "../src/game.vala"
			_tmp79_[(_tmp80_.row * _tmp79__length2) + _tmp81_.col] = NULL;
#line 636 "../src/game.vala"
			_tile_free0 (e);
#line 4101 "game.c"
		}
#line 636 "../src/game.vala"
		_g_object_unref0 (_e_list);
#line 4105 "game.c"
	}
#line 645 "../src/game.vala"
	_tmp82_ = self->priv->_to_hide;
#line 645 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp82_);
#line 646 "../src/game.vala"
	_tmp83_ = self->priv->_to_move;
#line 646 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp83_);
#line 647 "../src/game.vala"
	_tmp84_ = self->priv->_to_show;
#line 647 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp84_);
#line 649 "../src/game.vala"
	_tmp85_ = self->priv->_grid;
#line 649 "../src/game.vala"
	_tmp86_ = grid_get_target_value_reached (_tmp85_);
#line 649 "../src/game.vala"
	_tmp87_ = _tmp86_;
#line 649 "../src/game.vala"
	if (_tmp87_) {
#line 4127 "game.c"
		Grid* _tmp88_;
		guint _tmp89_;
		guint _tmp90_;
		Grid* _tmp91_;
#line 651 "../src/game.vala"
		_tmp88_ = self->priv->_grid;
#line 651 "../src/game.vala"
		_tmp89_ = grid_get_target_value (_tmp88_);
#line 651 "../src/game.vala"
		_tmp90_ = _tmp89_;
#line 651 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_TARGET_VALUE_REACHED_SIGNAL], 0, _tmp90_);
#line 652 "../src/game.vala"
		_tmp91_ = self->priv->_grid;
#line 652 "../src/game.vala"
		grid_set_target_value_reached (_tmp91_, FALSE);
#line 4144 "game.c"
	}
#line 655 "../src/game.vala"
	if (self->priv->_just_restored) {
#line 656 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_FINISHED_SIGNAL], 0, FALSE);
#line 4150 "game.c"
	} else {
#line 658 "../src/game.vala"
		self->priv->_finish_move_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, __game_finish_move_gsource_func, g_object_ref (self), g_object_unref);
#line 4154 "game.c"
	}
}

static gboolean
_game_finish_move (Game* self)
{
	gboolean result = FALSE;
	Grid* _tmp0_;
#line 661 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 663 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 663 "../src/game.vala"
	if (grid_is_finished (_tmp0_)) {
#line 664 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_FINISHED_SIGNAL], 0, TRUE);
#line 4171 "game.c"
	}
#line 666 "../src/game.vala"
	self->priv->_finish_move_id = (guint) 0;
#line 667 "../src/game.vala"
	result = FALSE;
#line 667 "../src/game.vala"
	return result;
#line 4179 "game.c"
}

static inline void
_game_clean_finish_move_animation (Game* self)
{
#line 670 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 672 "../src/game.vala"
	if (self->priv->_finish_move_id > ((guint) 0)) {
#line 673 "../src/game.vala"
		g_source_remove (self->priv->_finish_move_id);
#line 4191 "game.c"
	}
}

void
game_undo (Game* self)
{
	GameGameState _tmp0_;
	GeeLinkedList* _tmp1_;
	gpointer _tmp2_;
	Grid* _tmp3_;
	GeeLinkedList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 687 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/game.vala"
	_vala_return_if_fail (self->priv->_allow_undo == TRUE, "_allow_undo == true");
#line 690 "../src/game.vala"
	_tmp0_ = self->priv->_state;
#line 690 "../src/game.vala"
	if (_tmp0_ != GAME_GAME_STATE_IDLE) {
#line 691 "../src/game.vala"
		return;
#line 4215 "game.c"
	}
#line 693 "../src/game.vala"
	_game_clear_foreground (self);
#line 694 "../src/game.vala"
	_tmp1_ = self->priv->_undo_stack;
#line 694 "../src/game.vala"
	_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
#line 694 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 694 "../src/game.vala"
	self->priv->_grid = (Grid*) _tmp2_;
#line 695 "../src/game.vala"
	_game_restore_foreground (self, FALSE);
#line 696 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 696 "../src/game.vala"
	game_set_score (self, grid_get_score (_tmp3_));
#line 698 "../src/game.vala"
	_tmp4_ = self->priv->_undo_stack;
#line 698 "../src/game.vala"
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 698 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 698 "../src/game.vala"
	if (_tmp6_ == 0) {
#line 699 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 4243 "game.c"
	}
#line 700 "../src/game.vala"
	self->priv->_update_handled = FALSE;
#line 4247 "game.c"
}

static void
_game_load_undo_settings (Game* self,
                          GSettings* * settings)
{
	gboolean allow_undo = FALSE;
	gboolean _tmp0_ = FALSE;
#line 703 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 703 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 705 "../src/game.vala"
	allow_undo = g_settings_get_boolean (*settings, "allow-undo");
#line 706 "../src/game.vala"
	if (self->priv->_allow_undo) {
#line 706 "../src/game.vala"
		_tmp0_ = !allow_undo;
#line 4266 "game.c"
	} else {
#line 706 "../src/game.vala"
		_tmp0_ = FALSE;
#line 4270 "game.c"
	}
#line 706 "../src/game.vala"
	if (_tmp0_) {
#line 708 "../src/game.vala"
		_game_clear_history (self);
#line 709 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 4278 "game.c"
	}
#line 711 "../src/game.vala"
	self->priv->_allow_undo = allow_undo;
#line 712 "../src/game.vala"
	self->priv->_undo_stack_max_size = g_settings_get_uint (*settings, "allow-undo-max");
#line 4284 "game.c"
}

static void
_game_clear_history (Game* self)
{
	GeeLinkedList* _tmp0_;
#line 715 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 717 "../src/game.vala"
	_tmp0_ = self->priv->_undo_stack;
#line 717 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 4297 "game.c"
}

static void
_game_store_movement (Game* self,
                      Grid* clone)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 720 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 720 "../src/game.vala"
	g_return_if_fail (clone != NULL);
#line 722 "../src/game.vala"
	if (!self->priv->_allow_undo) {
#line 723 "../src/game.vala"
		return;
#line 4319 "game.c"
	}
#line 725 "../src/game.vala"
	_tmp0_ = self->priv->_undo_stack;
#line 725 "../src/game.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 725 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 725 "../src/game.vala"
	if (((guint) _tmp2_) >= self->priv->_undo_stack_max_size) {
#line 4329 "game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Grid* _tmp5_;
#line 726 "../src/game.vala"
		_tmp3_ = self->priv->_undo_stack;
#line 726 "../src/game.vala"
		_tmp4_ = gee_deque_poll_tail ((GeeDeque*) _tmp3_);
#line 726 "../src/game.vala"
		_tmp5_ = (Grid*) _tmp4_;
#line 726 "../src/game.vala"
		_g_object_unref0 (_tmp5_);
#line 4341 "game.c"
	}
#line 727 "../src/game.vala"
	_tmp6_ = self->priv->_undo_stack;
#line 727 "../src/game.vala"
	gee_deque_offer_head ((GeeDeque*) _tmp6_, clone);
#line 728 "../src/game.vala"
	_tmp7_ = self->priv->_undo_stack;
#line 728 "../src/game.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 728 "../src/game.vala"
	_tmp9_ = _tmp8_;
#line 728 "../src/game.vala"
	if (_tmp9_ == 1) {
#line 729 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_ENABLED_SIGNAL], 0);
#line 4357 "game.c"
	}
}

ClutterActor*
game_get_view (Game* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 90 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/game.vala"
	_tmp0_ = self->priv->_view;
#line 90 "../src/game.vala"
	result = _tmp0_;
#line 90 "../src/game.vala"
	return result;
#line 4374 "game.c"
}

static void
__game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                               ClutterActorBox* box,
                                                               ClutterAllocationFlags flags,
                                                               gpointer self)
{
#line 93 "../src/game.vala"
	_game_on_allocation_changed ((Game*) self, box, flags);
#line 4385 "game.c"
}

void
game_set_view (Game* self,
               ClutterActor* value)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
#line 91 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/game.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 92 "../src/game.vala"
	_g_object_unref0 (self->priv->_view);
#line 92 "../src/game.vala"
	self->priv->_view = _tmp0_;
#line 93 "../src/game.vala"
	_tmp1_ = self->priv->_view;
#line 93 "../src/game.vala"
	g_signal_connect_object (_tmp1_, "allocation-changed", (GCallback) __game_on_allocation_changed_clutter_actor_allocation_changed, self, 0);
#line 95 "../src/game.vala"
	_tmp2_ = clutter_actor_new ();
#line 95 "../src/game.vala"
	g_object_ref_sink (_tmp2_);
#line 95 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_background);
#line 95 "../src/game.vala"
	self->priv->_view_background = _tmp2_;
#line 96 "../src/game.vala"
	_tmp3_ = clutter_actor_new ();
#line 96 "../src/game.vala"
	g_object_ref_sink (_tmp3_);
#line 96 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_foreground);
#line 96 "../src/game.vala"
	self->priv->_view_foreground = _tmp3_;
#line 97 "../src/game.vala"
	_tmp4_ = self->priv->_view_background;
#line 97 "../src/game.vala"
	clutter_actor_show (_tmp4_);
#line 98 "../src/game.vala"
	_tmp5_ = self->priv->_view_foreground;
#line 98 "../src/game.vala"
	clutter_actor_show (_tmp5_);
#line 99 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 99 "../src/game.vala"
	_tmp7_ = self->priv->_view_background;
#line 99 "../src/game.vala"
	clutter_actor_add_child (_tmp6_, _tmp7_);
#line 100 "../src/game.vala"
	_tmp8_ = self->priv->_view;
#line 100 "../src/game.vala"
	_tmp9_ = self->priv->_view_foreground;
#line 100 "../src/game.vala"
	clutter_actor_add_child (_tmp8_, _tmp9_);
#line 4450 "game.c"
}

glong
game_get_score (Game* self)
{
	glong result;
#line 118 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 118 "../src/game.vala"
	result = self->priv->_score;
#line 118 "../src/game.vala"
	return result;
#line 4463 "game.c"
}

static void
game_set_score (Game* self,
                glong value)
{
#line 118 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/game.vala"
	if (game_get_score (self) != value) {
#line 118 "../src/game.vala"
		self->priv->_score = value;
#line 118 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
#line 4478 "game.c"
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 20 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 20 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 20 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 20 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 20 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_PROPERTY, game_properties[GAME_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_long ("score", "score", "score", G_MINLONG, G_MAXLONG, (glong) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/game.vala"
	game_signals[GAME_FINISHED_SIGNAL] = g_signal_new ("finished", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 20 "../src/game.vala"
	game_signals[GAME_TARGET_VALUE_REACHED_SIGNAL] = g_signal_new ("target-value-reached", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 20 "../src/game.vala"
	game_signals[GAME_UNDO_ENABLED_SIGNAL] = g_signal_new ("undo-enabled", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/game.vala"
	game_signals[GAME_UNDO_DISABLED_SIGNAL] = g_signal_new ("undo-disabled", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4508 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GeeLinkedList* _tmp5_;
#line 20 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 45 "../src/game.vala"
	self->priv->BLANK_COL_WIDTH = 10;
#line 46 "../src/game.vala"
	self->priv->BLANK_ROW_HEIGHT = 10;
#line 51 "../src/game.vala"
	self->priv->_background_init_done = FALSE;
#line 55 "../src/game.vala"
	_tmp0_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 55 "../src/game.vala"
	self->priv->_to_move = _tmp0_;
#line 56 "../src/game.vala"
	_tmp1_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 56 "../src/game.vala"
	self->priv->_to_hide = _tmp1_;
#line 57 "../src/game.vala"
	_tmp2_ = gee_linked_list_new (TYPE_TILE, (GBoxedCopyFunc) tile_dup, (GDestroyNotify) tile_free, NULL, NULL, NULL);
#line 57 "../src/game.vala"
	self->priv->_to_show = _tmp2_;
#line 59 "../src/game.vala"
	self->priv->_state = GAME_GAME_STATE_STOPPED;
#line 64 "../src/game.vala"
	_tmp3_ = g_get_user_data_dir ();
#line 64 "../src/game.vala"
	_tmp4_ = g_build_filename (_tmp3_, "gnome-2048", "saved", NULL);
#line 64 "../src/game.vala"
	self->priv->_saved_path = _tmp4_;
#line 116 "../src/game.vala"
	self->priv->_just_restored = TRUE;
#line 118 "../src/game.vala"
	self->priv->_score = (glong) 0;
#line 566 "../src/game.vala"
	self->priv->_finish_move_id = (guint) 0;
#line 567 "../src/game.vala"
	self->priv->_update_handled = FALSE;
#line 683 "../src/game.vala"
	self->priv->_allow_undo = FALSE;
#line 685 "../src/game.vala"
	_tmp5_ = gee_linked_list_new (TYPE_GRID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 685 "../src/game.vala"
	self->priv->_undo_stack = _tmp5_;
#line 4563 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 20 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 48 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 50 "../src/game.vala"
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
#line 52 "../src/game.vala"
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
#line 53 "../src/game.vala"
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
#line 55 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_move);
#line 56 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_hide);
#line 57 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_show);
#line 60 "../src/game.vala"
	_g_object_unref0 (self->priv->_show_hide_trans);
#line 61 "../src/game.vala"
	_g_object_unref0 (self->priv->_move_trans);
#line 64 "../src/game.vala"
	_g_free0 (self->priv->_saved_path);
#line 85 "../src/game.vala"
	_g_object_unref0 (self->priv->_view);
#line 86 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_background);
#line 87 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_foreground);
#line 685 "../src/game.vala"
	_g_object_unref0 (self->priv->_undo_stack);
#line 20 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 4602 "game.c"
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 20 "../src/game.vala"
	switch (property_id) {
#line 20 "../src/game.vala"
		case GAME_VIEW_PROPERTY:
#line 20 "../src/game.vala"
		g_value_set_object (value, game_get_view (self));
#line 20 "../src/game.vala"
		break;
#line 20 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 20 "../src/game.vala"
		g_value_set_long (value, game_get_score (self));
#line 20 "../src/game.vala"
		break;
#line 4641 "game.c"
		default:
#line 20 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/game.vala"
		break;
#line 4647 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 20 "../src/game.vala"
	switch (property_id) {
#line 20 "../src/game.vala"
		case GAME_VIEW_PROPERTY:
#line 20 "../src/game.vala"
		game_set_view (self, g_value_get_object (value));
#line 20 "../src/game.vala"
		break;
#line 20 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 20 "../src/game.vala"
		game_set_score (self, g_value_get_long (value));
#line 20 "../src/game.vala"
		break;
#line 4673 "game.c"
		default:
#line 20 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/game.vala"
		break;
#line 4679 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

