/* grid.c generated by valac 0.44.3, the Vala compiler
 * generated from grid.vala, do not modify */

/* Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
 * Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of GNOME 2048.
 *
 * GNOME 2048 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME 2048 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME 2048; if not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <math.h>
#include <float.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;
typedef struct _GridPrivate GridPrivate;
enum  {
	GRID_0_PROPERTY,
	GRID_ROWS_PROPERTY,
	GRID_COLS_PROPERTY,
	GRID_TARGET_VALUE_PROPERTY,
	GRID_TARGET_VALUE_REACHED_PROPERTY,
	GRID_NUM_PROPERTIES
};
static GParamSpec* grid_properties[GRID_NUM_PROPERTIES];

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())
typedef struct _TileMovement TileMovement;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Grid {
	GObject parent_instance;
	GridPrivate * priv;
	guint8* _grid;
	gint _grid_length1;
	gint _grid_length2;
};

struct _GridClass {
	GObjectClass parent_class;
};

struct _GridPrivate {
	gint _rows;
	gint _cols;
	guint _target_value;
	gboolean _target_value_reached;
};

struct _GridPosition {
	gint row;
	gint col;
};

struct _Tile {
	GridPosition pos;
	guint8 val;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

static gint Grid_private_offset;
static gpointer grid_parent_class = NULL;

GType grid_get_type (void) G_GNUC_CONST;
Grid* grid_new (gint rows,
                gint cols);
Grid* grid_construct (GType object_type,
                      gint rows,
                      gint cols);
GType tile_get_type (void) G_GNUC_CONST;
GType grid_position_get_type (void) G_GNUC_CONST;
GridPosition* grid_position_dup (const GridPosition* self);
void grid_position_free (GridPosition* self);
Tile* tile_dup (const Tile* self);
void tile_free (Tile* self);
void grid_new_tile (Grid* self,
                    Tile* tile);
gboolean _grid_grid_is_full (guint8** grid,
                             gint* grid_length1,
                             gint* grid_length2);
static inline void _grid_generate_random_position (gint rows,
                                     gint cols,
                                     GridPosition* pos);
gint grid_get_rows (Grid* self);
gint grid_get_cols (Grid* self);
GType move_request_get_type (void) G_GNUC_CONST;
GType tile_movement_get_type (void) G_GNUC_CONST;
TileMovement* tile_movement_dup (const TileMovement* self);
void tile_movement_free (TileMovement* self);
void grid_move (Grid* self,
                MoveRequest request,
                GeeLinkedList* * to_move,
                GeeLinkedList* * to_hide,
                GeeLinkedList* * to_show);
static void _grid_move_down (gint cols,
                      gint rows,
                      guint8* max_changed,
                      guint8** grid,
                      gint* grid_length1,
                      gint* grid_length2,
                      GeeLinkedList* * to_move,
                      GeeLinkedList* * to_hide,
                      GeeLinkedList* * to_show);
static void _grid_move_up (gint cols,
                    gint rows,
                    guint8* max_changed,
                    guint8** grid,
                    gint* grid_length1,
                    gint* grid_length2,
                    GeeLinkedList* * to_move,
                    GeeLinkedList* * to_hide,
                    GeeLinkedList* * to_show);
static void _grid_move_left (gint cols,
                      gint rows,
                      guint8* max_changed,
                      guint8** grid,
                      gint* grid_length1,
                      gint* grid_length2,
                      GeeLinkedList* * to_move,
                      GeeLinkedList* * to_hide,
                      GeeLinkedList* * to_show);
static void _grid_move_right (gint cols,
                       gint rows,
                       guint8* max_changed,
                       guint8** grid,
                       gint* grid_length1,
                       gint* grid_length2,
                       GeeLinkedList* * to_move,
                       GeeLinkedList* * to_hide,
                       GeeLinkedList* * to_show);
guint grid_get_target_value (Grid* self);
void grid_set_target_value_reached (Grid* self,
                                    gboolean value);
static void _grid_move_to_match (GeeLinkedList* * to_hide,
                          GeeLinkedList* * to_show,
                          GridPosition* cur,
                          GridPosition* free,
                          GridPosition* match,
                          guint8** grid,
                          gint* grid_length1,
                          gint* grid_length2,
                          guint8* val,
                          guint8* max_changed);
static void _grid_move_to_end (GeeLinkedList* * to_move,
                        GridPosition* cur,
                        GridPosition* free,
                        guint8** grid,
                        gint* grid_length1,
                        gint* grid_length2,
                        guint8* val);
gchar* grid_position_to_string (GridPosition *self);
gboolean grid_is_finished (Grid* self);
void grid_clear (Grid* self);
static void _grid_clear (guint8** grid,
                  gint* grid_length1,
                  gint* grid_length2);
glong grid_get_score (Grid* self);
static glong _grid_get_score (guint8** grid,
                       gint* grid_length1,
                       gint* grid_length2);
static inline glong _grid_calculate_score_value (guint8 tile_value);
Grid* grid_clone (Grid* self);
static guint8* _vala_array_dup1 (guint8* self,
                          int length);
guint8 grid_get (Grid* self,
                 gint row,
                 gint col);
gboolean grid_is_disallowed_grid_size (gint* rows,
                                       gint* cols);
gchar* grid_save (Grid* self);
static void _grid_convert_to_string (guint8** grid,
                              gint* grid_length1,
                              gint* grid_length2,
                              gchar* * ret_string);
gchar* grid_to_string (Grid* self);
gboolean grid_load (Grid* self,
                    gchar* * content);
static gboolean _grid_load_from_string (gchar* * content,
                                 guint8** grid,
                                 gint* grid_length1,
                                 gint* grid_length2);
static guint8* _vala_array_dup2 (guint8* self,
                          int length);
static inline void _grid_parse_line (const gchar* line,
                       gchar*** tokens,
                       gint* tokens_length1);
static inline gboolean _grid_convert_tile_number (guint64* number_64,
                                    guint8* number);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static gchar** _vala_array_dup3 (gchar** self,
                          int length);
static void grid_set_rows (Grid* self,
                    gint value);
static void grid_set_cols (Grid* self,
                    gint value);
void grid_set_target_value (Grid* self,
                            guint value);
gboolean grid_get_target_value_reached (Grid* self);
static GObject * grid_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void grid_finalize (GObject * obj);
static void _vala_grid_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_grid_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
gchar* move_request_debug_string (MoveRequest request);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
grid_get_instance_private (Grid* self)
{
	return G_STRUCT_MEMBER_P (self, Grid_private_offset);
}

Grid*
grid_construct (GType object_type,
                gint rows,
                gint cols)
{
	Grid * self = NULL;
#line 41 "../src/grid.vala"
	self = (Grid*) g_object_new (object_type, "rows", rows, "cols", cols, NULL);
#line 39 "../src/grid.vala"
	return self;
#line 287 "grid.c"
}

Grid*
grid_new (gint rows,
          gint cols)
{
#line 39 "../src/grid.vala"
	return grid_construct (TYPE_GRID, rows, cols);
#line 296 "grid.c"
}

void
grid_new_tile (Grid* self,
               Tile* tile)
{
	Tile _vala_tile = {0};
	gboolean _tmp0_;
	GridPosition pos = {0};
	GridPosition _tmp1_ = {0};
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	GridPosition _tmp11_;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
	Tile _tmp14_ = {0};
#line 48 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/grid.vala"
	_tmp0_ = _grid_grid_is_full (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 50 "../src/grid.vala"
	if (_tmp0_) {
#line 51 "../src/grid.vala"
		g_assert_not_reached ();
#line 322 "grid.c"
	}
#line 53 "../src/grid.vala"
	_tmp1_.row = 0;
#line 53 "../src/grid.vala"
	_tmp1_.col = 0;
#line 53 "../src/grid.vala"
	pos = _tmp1_;
#line 330 "grid.c"
	{
		gboolean _tmp2_ = FALSE;
#line 54 "../src/grid.vala"
		_tmp2_ = TRUE;
#line 54 "../src/grid.vala"
		while (TRUE) {
#line 337 "grid.c"
			gint _tmp7_;
			gint _tmp8_;
			GridPosition _tmp9_ = {0};
#line 54 "../src/grid.vala"
			if (!_tmp2_) {
#line 343 "grid.c"
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				GridPosition _tmp4_;
				GridPosition _tmp5_;
				guint8 _tmp6_;
#line 55 "../src/grid.vala"
				_tmp3_ = self->_grid;
#line 55 "../src/grid.vala"
				_tmp3__length1 = self->_grid_length1;
#line 55 "../src/grid.vala"
				_tmp3__length2 = self->_grid_length2;
#line 55 "../src/grid.vala"
				_tmp4_ = pos;
#line 55 "../src/grid.vala"
				_tmp5_ = pos;
#line 55 "../src/grid.vala"
				_tmp6_ = _tmp3_[(_tmp4_.row * _tmp3__length2) + _tmp5_.col];
#line 55 "../src/grid.vala"
				if (!(((gint) _tmp6_) != 0)) {
#line 55 "../src/grid.vala"
					break;
#line 366 "grid.c"
				}
			}
#line 54 "../src/grid.vala"
			_tmp2_ = FALSE;
#line 54 "../src/grid.vala"
			_tmp7_ = self->priv->_rows;
#line 54 "../src/grid.vala"
			_tmp8_ = self->priv->_cols;
#line 54 "../src/grid.vala"
			_grid_generate_random_position (_tmp7_, _tmp8_, &_tmp9_);
#line 54 "../src/grid.vala"
			pos = _tmp9_;
#line 379 "grid.c"
		}
	}
#line 57 "../src/grid.vala"
	_tmp10_ = self->_grid;
#line 57 "../src/grid.vala"
	_tmp10__length1 = self->_grid_length1;
#line 57 "../src/grid.vala"
	_tmp10__length2 = self->_grid_length2;
#line 57 "../src/grid.vala"
	_tmp11_ = pos;
#line 57 "../src/grid.vala"
	_tmp12_ = pos;
#line 57 "../src/grid.vala"
	_tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col] = (guint8) 1;
#line 58 "../src/grid.vala"
	_tmp13_ = pos;
#line 58 "../src/grid.vala"
	_tmp14_.pos = _tmp13_;
#line 58 "../src/grid.vala"
	_tmp14_.val = (guint8) 1;
#line 58 "../src/grid.vala"
	_vala_tile = _tmp14_;
#line 48 "../src/grid.vala"
	if (tile) {
#line 48 "../src/grid.vala"
		*tile = _vala_tile;
#line 406 "grid.c"
	}
}

static inline void
_grid_generate_random_position (gint rows,
                                gint cols,
                                GridPosition* pos)
{
	GridPosition _vala_pos = {0};
	GridPosition _tmp0_ = {0};
#line 61 "../src/grid.vala"
	_vala_return_if_fail (rows > 0, "rows > 0");
#line 61 "../src/grid.vala"
	_vala_return_if_fail (cols > 0, "cols > 0");
#line 65 "../src/grid.vala"
	_tmp0_.row = (gint) g_random_int_range ((gint32) 0, (gint32) rows);
#line 65 "../src/grid.vala"
	_tmp0_.col = (gint) g_random_int_range ((gint32) 0, (gint32) cols);
#line 65 "../src/grid.vala"
	_vala_pos = _tmp0_;
#line 61 "../src/grid.vala"
	if (pos) {
#line 61 "../src/grid.vala"
		*pos = _vala_pos;
#line 431 "grid.c"
	}
}

inline void
grid_move (Grid* self,
           MoveRequest request,
           GeeLinkedList* * to_move,
           GeeLinkedList* * to_hide,
           GeeLinkedList* * to_show)
{
	guint8 max_changed = 0U;
	guint _tmp0_;
#line 73 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 78 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_move));
#line 79 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_hide));
#line 80 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_show));
#line 82 "../src/grid.vala"
	max_changed = (guint8) 0;
#line 83 "../src/grid.vala"
	switch (request) {
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_DOWN:
#line 464 "grid.c"
		{
#line 86 "../src/grid.vala"
			_grid_move_down (self->priv->_cols, self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 86 "../src/grid.vala"
			break;
#line 470 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_UP:
#line 474 "grid.c"
		{
#line 88 "../src/grid.vala"
			_grid_move_up (self->priv->_cols, self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 88 "../src/grid.vala"
			break;
#line 480 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_LEFT:
#line 484 "grid.c"
		{
#line 90 "../src/grid.vala"
			_grid_move_left (self->priv->_cols, self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 90 "../src/grid.vala"
			break;
#line 490 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_RIGHT:
#line 494 "grid.c"
		{
#line 92 "../src/grid.vala"
			_grid_move_right (self->priv->_cols, self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 92 "../src/grid.vala"
			break;
#line 500 "grid.c"
		}
		default:
#line 83 "../src/grid.vala"
		break;
#line 505 "grid.c"
	}
#line 94 "../src/grid.vala"
	_tmp0_ = self->priv->_target_value;
#line 94 "../src/grid.vala"
	if (pow ((gdouble) 2, (gdouble) max_changed) >= ((gdouble) _tmp0_)) {
#line 95 "../src/grid.vala"
		grid_set_target_value_reached (self, TRUE);
#line 513 "grid.c"
	}
}

static void
_grid_move_down (gint cols,
                 gint rows,
                 guint8* max_changed,
                 guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2,
                 GeeLinkedList* * to_move,
                 GeeLinkedList* * to_hide,
                 GeeLinkedList* * to_show)
{
#line 98 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 98 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 98 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 534 "grid.c"
	{
		gint i = 0;
#line 106 "../src/grid.vala"
		i = 0;
#line 539 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 106 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 106 "../src/grid.vala"
			while (TRUE) {
#line 546 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 106 "../src/grid.vala"
				if (!_tmp0_) {
#line 551 "grid.c"
					gint _tmp1_;
#line 106 "../src/grid.vala"
					_tmp1_ = i;
#line 106 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 557 "grid.c"
				}
#line 106 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 106 "../src/grid.vala"
				if (!(i < cols)) {
#line 106 "../src/grid.vala"
					break;
#line 565 "grid.c"
				}
#line 108 "../src/grid.vala"
				_tmp2_.row = rows;
#line 108 "../src/grid.vala"
				_tmp2_.col = i;
#line 108 "../src/grid.vala"
				free = _tmp2_;
#line 573 "grid.c"
				{
					gint j = 0;
#line 110 "../src/grid.vala"
					j = 0;
#line 578 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 110 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 110 "../src/grid.vala"
						while (TRUE) {
#line 585 "grid.c"
							gint row = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 110 "../src/grid.vala"
							if (!_tmp3_) {
#line 598 "grid.c"
								gint _tmp4_;
#line 110 "../src/grid.vala"
								_tmp4_ = j;
#line 110 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 604 "grid.c"
							}
#line 110 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 110 "../src/grid.vala"
							if (!(j < rows)) {
#line 110 "../src/grid.vala"
								break;
#line 612 "grid.c"
							}
#line 112 "../src/grid.vala"
							row = (rows - j) - 1;
#line 113 "../src/grid.vala"
							_tmp5_.row = row;
#line 113 "../src/grid.vala"
							_tmp5_.col = i;
#line 113 "../src/grid.vala"
							cur = _tmp5_;
#line 114 "../src/grid.vala"
							_tmp6_ = cur;
#line 114 "../src/grid.vala"
							_tmp7_ = cur;
#line 114 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 114 "../src/grid.vala"
							val = _tmp8_;
#line 116 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 632 "grid.c"
								GridPosition _tmp9_;
#line 118 "../src/grid.vala"
								_tmp9_ = free;
#line 118 "../src/grid.vala"
								if (_tmp9_.row == rows) {
#line 119 "../src/grid.vala"
									free.row = row;
#line 640 "grid.c"
								}
#line 120 "../src/grid.vala"
								continue;
#line 644 "grid.c"
							}
#line 124 "../src/grid.vala"
							_tmp10_.row = 0;
#line 124 "../src/grid.vala"
							_tmp10_.col = 0;
#line 124 "../src/grid.vala"
							match = _tmp10_;
#line 125 "../src/grid.vala"
							has_match = FALSE;
#line 654 "grid.c"
							{
								gint k = 0;
#line 126 "../src/grid.vala"
								k = row - 1;
#line 659 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 126 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 126 "../src/grid.vala"
									while (TRUE) {
#line 666 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 126 "../src/grid.vala"
										if (!_tmp11_) {
#line 672 "grid.c"
											gint _tmp12_;
#line 126 "../src/grid.vala"
											_tmp12_ = k;
#line 126 "../src/grid.vala"
											k = _tmp12_ - 1;
#line 678 "grid.c"
										}
#line 126 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 126 "../src/grid.vala"
										if (!(k >= 0)) {
#line 126 "../src/grid.vala"
											break;
#line 686 "grid.c"
										}
#line 128 "../src/grid.vala"
										_tmp13_ = cur;
#line 128 "../src/grid.vala"
										_tmp14_ = (*grid)[(k * (*grid_length2)) + _tmp13_.col];
#line 128 "../src/grid.vala"
										k_val = _tmp14_;
#line 130 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 132 "../src/grid.vala"
											if (k_val == val) {
#line 698 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 134 "../src/grid.vala"
												has_match = TRUE;
#line 135 "../src/grid.vala"
												_tmp15_ = cur;
#line 135 "../src/grid.vala"
												_tmp16_.row = k;
#line 135 "../src/grid.vala"
												_tmp16_.col = _tmp15_.col;
#line 135 "../src/grid.vala"
												match = _tmp16_;
#line 711 "grid.c"
											}
#line 137 "../src/grid.vala"
											break;
#line 715 "grid.c"
										}
									}
								}
							}
#line 141 "../src/grid.vala"
							if (has_match) {
#line 722 "grid.c"
								GridPosition _tmp17_;
								gint _tmp18_;
#line 143 "../src/grid.vala"
								_tmp17_ = free;
#line 143 "../src/grid.vala"
								if (_tmp17_.row == rows) {
#line 144 "../src/grid.vala"
									free.row = row;
#line 731 "grid.c"
								}
#line 146 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 147 "../src/grid.vala"
								_tmp18_ = free.row;
#line 147 "../src/grid.vala"
								free.row = _tmp18_ - 1;
#line 739 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 149 "../src/grid.vala"
								_tmp19_ = free;
#line 149 "../src/grid.vala"
								if (_tmp19_.row != rows) {
#line 746 "grid.c"
									gint _tmp20_;
#line 151 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 152 "../src/grid.vala"
									_tmp20_ = free.row;
#line 152 "../src/grid.vala"
									free.row = _tmp20_ - 1;
#line 754 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_up (gint cols,
               gint rows,
               guint8* max_changed,
               guint8** grid,
               gint* grid_length1,
               gint* grid_length2,
               GeeLinkedList* * to_move,
               GeeLinkedList* * to_hide,
               GeeLinkedList* * to_show)
{
#line 158 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 158 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 158 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 782 "grid.c"
	{
		gint i = 0;
#line 166 "../src/grid.vala"
		i = 0;
#line 787 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 166 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 166 "../src/grid.vala"
			while (TRUE) {
#line 794 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 166 "../src/grid.vala"
				if (!_tmp0_) {
#line 799 "grid.c"
					gint _tmp1_;
#line 166 "../src/grid.vala"
					_tmp1_ = i;
#line 166 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 805 "grid.c"
				}
#line 166 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 166 "../src/grid.vala"
				if (!(i < cols)) {
#line 166 "../src/grid.vala"
					break;
#line 813 "grid.c"
				}
#line 168 "../src/grid.vala"
				_tmp2_.row = -1;
#line 168 "../src/grid.vala"
				_tmp2_.col = i;
#line 168 "../src/grid.vala"
				free = _tmp2_;
#line 821 "grid.c"
				{
					gint j = 0;
#line 170 "../src/grid.vala"
					j = 0;
#line 826 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 170 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 170 "../src/grid.vala"
						while (TRUE) {
#line 833 "grid.c"
							gint row = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 170 "../src/grid.vala"
							if (!_tmp3_) {
#line 846 "grid.c"
								gint _tmp4_;
#line 170 "../src/grid.vala"
								_tmp4_ = j;
#line 170 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 852 "grid.c"
							}
#line 170 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 170 "../src/grid.vala"
							if (!(j < rows)) {
#line 170 "../src/grid.vala"
								break;
#line 860 "grid.c"
							}
#line 172 "../src/grid.vala"
							row = j;
#line 173 "../src/grid.vala"
							_tmp5_.row = row;
#line 173 "../src/grid.vala"
							_tmp5_.col = i;
#line 173 "../src/grid.vala"
							cur = _tmp5_;
#line 174 "../src/grid.vala"
							_tmp6_ = cur;
#line 174 "../src/grid.vala"
							_tmp7_ = cur;
#line 174 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 174 "../src/grid.vala"
							val = _tmp8_;
#line 176 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 880 "grid.c"
								GridPosition _tmp9_;
#line 178 "../src/grid.vala"
								_tmp9_ = free;
#line 178 "../src/grid.vala"
								if (_tmp9_.row == -1) {
#line 179 "../src/grid.vala"
									free.row = row;
#line 888 "grid.c"
								}
#line 180 "../src/grid.vala"
								continue;
#line 892 "grid.c"
							}
#line 184 "../src/grid.vala"
							_tmp10_.row = 0;
#line 184 "../src/grid.vala"
							_tmp10_.col = 0;
#line 184 "../src/grid.vala"
							match = _tmp10_;
#line 185 "../src/grid.vala"
							has_match = FALSE;
#line 902 "grid.c"
							{
								gint k = 0;
#line 186 "../src/grid.vala"
								k = row + 1;
#line 907 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 186 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 186 "../src/grid.vala"
									while (TRUE) {
#line 914 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 186 "../src/grid.vala"
										if (!_tmp11_) {
#line 920 "grid.c"
											gint _tmp12_;
#line 186 "../src/grid.vala"
											_tmp12_ = k;
#line 186 "../src/grid.vala"
											k = _tmp12_ + 1;
#line 926 "grid.c"
										}
#line 186 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 186 "../src/grid.vala"
										if (!(k < rows)) {
#line 186 "../src/grid.vala"
											break;
#line 934 "grid.c"
										}
#line 188 "../src/grid.vala"
										_tmp13_ = cur;
#line 188 "../src/grid.vala"
										_tmp14_ = (*grid)[(k * (*grid_length2)) + _tmp13_.col];
#line 188 "../src/grid.vala"
										k_val = _tmp14_;
#line 190 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 192 "../src/grid.vala"
											if (k_val == val) {
#line 946 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 194 "../src/grid.vala"
												has_match = TRUE;
#line 195 "../src/grid.vala"
												_tmp15_ = cur;
#line 195 "../src/grid.vala"
												_tmp16_.row = k;
#line 195 "../src/grid.vala"
												_tmp16_.col = _tmp15_.col;
#line 195 "../src/grid.vala"
												match = _tmp16_;
#line 959 "grid.c"
											}
#line 197 "../src/grid.vala"
											break;
#line 963 "grid.c"
										}
									}
								}
							}
#line 201 "../src/grid.vala"
							if (has_match) {
#line 970 "grid.c"
								GridPosition _tmp17_;
								gint _tmp18_;
#line 203 "../src/grid.vala"
								_tmp17_ = free;
#line 203 "../src/grid.vala"
								if (_tmp17_.row == -1) {
#line 204 "../src/grid.vala"
									free.row = row;
#line 979 "grid.c"
								}
#line 206 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 207 "../src/grid.vala"
								_tmp18_ = free.row;
#line 207 "../src/grid.vala"
								free.row = _tmp18_ + 1;
#line 987 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 209 "../src/grid.vala"
								_tmp19_ = free;
#line 209 "../src/grid.vala"
								if (_tmp19_.row != -1) {
#line 994 "grid.c"
									gint _tmp20_;
#line 211 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 212 "../src/grid.vala"
									_tmp20_ = free.row;
#line 212 "../src/grid.vala"
									free.row = _tmp20_ + 1;
#line 1002 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_left (gint cols,
                 gint rows,
                 guint8* max_changed,
                 guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2,
                 GeeLinkedList* * to_move,
                 GeeLinkedList* * to_hide,
                 GeeLinkedList* * to_show)
{
#line 218 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 218 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 218 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 1030 "grid.c"
	{
		gint i = 0;
#line 226 "../src/grid.vala"
		i = 0;
#line 1035 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 226 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 226 "../src/grid.vala"
			while (TRUE) {
#line 1042 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 226 "../src/grid.vala"
				if (!_tmp0_) {
#line 1047 "grid.c"
					gint _tmp1_;
#line 226 "../src/grid.vala"
					_tmp1_ = i;
#line 226 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 1053 "grid.c"
				}
#line 226 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 226 "../src/grid.vala"
				if (!(i < rows)) {
#line 226 "../src/grid.vala"
					break;
#line 1061 "grid.c"
				}
#line 228 "../src/grid.vala"
				_tmp2_.row = i;
#line 228 "../src/grid.vala"
				_tmp2_.col = -1;
#line 228 "../src/grid.vala"
				free = _tmp2_;
#line 1069 "grid.c"
				{
					gint j = 0;
#line 230 "../src/grid.vala"
					j = 0;
#line 1074 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 230 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 230 "../src/grid.vala"
						while (TRUE) {
#line 1081 "grid.c"
							gint col = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 230 "../src/grid.vala"
							if (!_tmp3_) {
#line 1094 "grid.c"
								gint _tmp4_;
#line 230 "../src/grid.vala"
								_tmp4_ = j;
#line 230 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1100 "grid.c"
							}
#line 230 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 230 "../src/grid.vala"
							if (!(j < cols)) {
#line 230 "../src/grid.vala"
								break;
#line 1108 "grid.c"
							}
#line 232 "../src/grid.vala"
							col = j;
#line 233 "../src/grid.vala"
							_tmp5_.row = i;
#line 233 "../src/grid.vala"
							_tmp5_.col = col;
#line 233 "../src/grid.vala"
							cur = _tmp5_;
#line 234 "../src/grid.vala"
							_tmp6_ = cur;
#line 234 "../src/grid.vala"
							_tmp7_ = cur;
#line 234 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 234 "../src/grid.vala"
							val = _tmp8_;
#line 236 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 1128 "grid.c"
								GridPosition _tmp9_;
#line 238 "../src/grid.vala"
								_tmp9_ = free;
#line 238 "../src/grid.vala"
								if (_tmp9_.col == -1) {
#line 239 "../src/grid.vala"
									free.col = col;
#line 1136 "grid.c"
								}
#line 240 "../src/grid.vala"
								continue;
#line 1140 "grid.c"
							}
#line 244 "../src/grid.vala"
							_tmp10_.row = 0;
#line 244 "../src/grid.vala"
							_tmp10_.col = 0;
#line 244 "../src/grid.vala"
							match = _tmp10_;
#line 245 "../src/grid.vala"
							has_match = FALSE;
#line 1150 "grid.c"
							{
								gint k = 0;
#line 246 "../src/grid.vala"
								k = col + 1;
#line 1155 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 246 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 246 "../src/grid.vala"
									while (TRUE) {
#line 1162 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 246 "../src/grid.vala"
										if (!_tmp11_) {
#line 1168 "grid.c"
											gint _tmp12_;
#line 246 "../src/grid.vala"
											_tmp12_ = k;
#line 246 "../src/grid.vala"
											k = _tmp12_ + 1;
#line 1174 "grid.c"
										}
#line 246 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 246 "../src/grid.vala"
										if (!(k < cols)) {
#line 246 "../src/grid.vala"
											break;
#line 1182 "grid.c"
										}
#line 248 "../src/grid.vala"
										_tmp13_ = cur;
#line 248 "../src/grid.vala"
										_tmp14_ = (*grid)[(_tmp13_.row * (*grid_length2)) + k];
#line 248 "../src/grid.vala"
										k_val = _tmp14_;
#line 250 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 252 "../src/grid.vala"
											if (k_val == val) {
#line 1194 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 254 "../src/grid.vala"
												has_match = TRUE;
#line 255 "../src/grid.vala"
												_tmp15_ = cur;
#line 255 "../src/grid.vala"
												_tmp16_.row = _tmp15_.row;
#line 255 "../src/grid.vala"
												_tmp16_.col = k;
#line 255 "../src/grid.vala"
												match = _tmp16_;
#line 1207 "grid.c"
											}
#line 257 "../src/grid.vala"
											break;
#line 1211 "grid.c"
										}
									}
								}
							}
#line 261 "../src/grid.vala"
							if (has_match) {
#line 1218 "grid.c"
								GridPosition _tmp17_;
								gint _tmp18_;
#line 263 "../src/grid.vala"
								_tmp17_ = free;
#line 263 "../src/grid.vala"
								if (_tmp17_.col == -1) {
#line 264 "../src/grid.vala"
									free.col = col;
#line 1227 "grid.c"
								}
#line 266 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 267 "../src/grid.vala"
								_tmp18_ = free.col;
#line 267 "../src/grid.vala"
								free.col = _tmp18_ + 1;
#line 1235 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 269 "../src/grid.vala"
								_tmp19_ = free;
#line 269 "../src/grid.vala"
								if (_tmp19_.col != -1) {
#line 1242 "grid.c"
									gint _tmp20_;
#line 271 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 272 "../src/grid.vala"
									_tmp20_ = free.col;
#line 272 "../src/grid.vala"
									free.col = _tmp20_ + 1;
#line 1250 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_right (gint cols,
                  gint rows,
                  guint8* max_changed,
                  guint8** grid,
                  gint* grid_length1,
                  gint* grid_length2,
                  GeeLinkedList* * to_move,
                  GeeLinkedList* * to_hide,
                  GeeLinkedList* * to_show)
{
#line 278 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 278 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 278 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 1278 "grid.c"
	{
		gint i = 0;
#line 286 "../src/grid.vala"
		i = 0;
#line 1283 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 286 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 286 "../src/grid.vala"
			while (TRUE) {
#line 1290 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 286 "../src/grid.vala"
				if (!_tmp0_) {
#line 1295 "grid.c"
					gint _tmp1_;
#line 286 "../src/grid.vala"
					_tmp1_ = i;
#line 286 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 1301 "grid.c"
				}
#line 286 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 286 "../src/grid.vala"
				if (!(i < rows)) {
#line 286 "../src/grid.vala"
					break;
#line 1309 "grid.c"
				}
#line 288 "../src/grid.vala"
				_tmp2_.row = i;
#line 288 "../src/grid.vala"
				_tmp2_.col = cols;
#line 288 "../src/grid.vala"
				free = _tmp2_;
#line 1317 "grid.c"
				{
					gint j = 0;
#line 290 "../src/grid.vala"
					j = 0;
#line 1322 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 290 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 290 "../src/grid.vala"
						while (TRUE) {
#line 1329 "grid.c"
							gint col = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 290 "../src/grid.vala"
							if (!_tmp3_) {
#line 1342 "grid.c"
								gint _tmp4_;
#line 290 "../src/grid.vala"
								_tmp4_ = j;
#line 290 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1348 "grid.c"
							}
#line 290 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 290 "../src/grid.vala"
							if (!(j < cols)) {
#line 290 "../src/grid.vala"
								break;
#line 1356 "grid.c"
							}
#line 292 "../src/grid.vala"
							col = (cols - j) - 1;
#line 293 "../src/grid.vala"
							_tmp5_.row = i;
#line 293 "../src/grid.vala"
							_tmp5_.col = col;
#line 293 "../src/grid.vala"
							cur = _tmp5_;
#line 294 "../src/grid.vala"
							_tmp6_ = cur;
#line 294 "../src/grid.vala"
							_tmp7_ = cur;
#line 294 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 294 "../src/grid.vala"
							val = _tmp8_;
#line 296 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 1376 "grid.c"
								GridPosition _tmp9_;
#line 298 "../src/grid.vala"
								_tmp9_ = free;
#line 298 "../src/grid.vala"
								if (_tmp9_.col == cols) {
#line 299 "../src/grid.vala"
									free.col = col;
#line 1384 "grid.c"
								}
#line 300 "../src/grid.vala"
								continue;
#line 1388 "grid.c"
							}
#line 304 "../src/grid.vala"
							_tmp10_.row = 0;
#line 304 "../src/grid.vala"
							_tmp10_.col = 0;
#line 304 "../src/grid.vala"
							match = _tmp10_;
#line 305 "../src/grid.vala"
							has_match = FALSE;
#line 1398 "grid.c"
							{
								gint k = 0;
#line 306 "../src/grid.vala"
								k = col - 1;
#line 1403 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 306 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 306 "../src/grid.vala"
									while (TRUE) {
#line 1410 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 306 "../src/grid.vala"
										if (!_tmp11_) {
#line 1416 "grid.c"
											gint _tmp12_;
#line 306 "../src/grid.vala"
											_tmp12_ = k;
#line 306 "../src/grid.vala"
											k = _tmp12_ - 1;
#line 1422 "grid.c"
										}
#line 306 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 306 "../src/grid.vala"
										if (!(k >= 0)) {
#line 306 "../src/grid.vala"
											break;
#line 1430 "grid.c"
										}
#line 308 "../src/grid.vala"
										_tmp13_ = cur;
#line 308 "../src/grid.vala"
										_tmp14_ = (*grid)[(_tmp13_.row * (*grid_length2)) + k];
#line 308 "../src/grid.vala"
										k_val = _tmp14_;
#line 310 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 312 "../src/grid.vala"
											if (k_val == val) {
#line 1442 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 314 "../src/grid.vala"
												has_match = TRUE;
#line 315 "../src/grid.vala"
												_tmp15_ = cur;
#line 315 "../src/grid.vala"
												_tmp16_.row = _tmp15_.row;
#line 315 "../src/grid.vala"
												_tmp16_.col = k;
#line 315 "../src/grid.vala"
												match = _tmp16_;
#line 1455 "grid.c"
											}
#line 317 "../src/grid.vala"
											break;
#line 1459 "grid.c"
										}
									}
								}
							}
#line 321 "../src/grid.vala"
							if (has_match) {
#line 1466 "grid.c"
								GridPosition _tmp17_;
								gint _tmp18_;
#line 323 "../src/grid.vala"
								_tmp17_ = free;
#line 323 "../src/grid.vala"
								if (_tmp17_.col == cols) {
#line 324 "../src/grid.vala"
									free.col = col;
#line 1475 "grid.c"
								}
#line 326 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 327 "../src/grid.vala"
								_tmp18_ = free.col;
#line 327 "../src/grid.vala"
								free.col = _tmp18_ - 1;
#line 1483 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 329 "../src/grid.vala"
								_tmp19_ = free;
#line 329 "../src/grid.vala"
								if (_tmp19_.col != cols) {
#line 1490 "grid.c"
									gint _tmp20_;
#line 331 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 332 "../src/grid.vala"
									_tmp20_ = free.col;
#line 332 "../src/grid.vala"
									free.col = _tmp20_ - 1;
#line 1498 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_to_match (GeeLinkedList* * to_hide,
                     GeeLinkedList* * to_show,
                     GridPosition* cur,
                     GridPosition* free,
                     GridPosition* match,
                     guint8** grid,
                     gint* grid_length1,
                     gint* grid_length2,
                     guint8* val,
                     guint8* max_changed)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	TileMovement mov = {0};
	GridPosition _tmp4_;
	GridPosition _tmp5_;
	TileMovement _tmp6_ = {0};
	TileMovement _tmp7_;
	GridPosition _tmp8_;
	GridPosition _tmp9_;
	TileMovement _tmp10_ = {0};
	TileMovement _tmp11_;
	guint8 _tmp12_;
	Tile tile = {0};
	GridPosition _tmp13_;
	Tile _tmp14_ = {0};
	Tile _tmp15_;
	GridPosition _tmp16_;
	GridPosition _tmp17_;
	GridPosition _tmp18_;
	GridPosition _tmp19_;
	GridPosition _tmp20_;
	GridPosition _tmp21_;
#line 342 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 342 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 342 "../src/grid.vala"
	g_return_if_fail (cur != NULL);
#line 342 "../src/grid.vala"
	g_return_if_fail (free != NULL);
#line 342 "../src/grid.vala"
	g_return_if_fail (match != NULL);
#line 351 "../src/grid.vala"
	_tmp0_ = grid_position_to_string (match);
#line 351 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 351 "../src/grid.vala"
	_tmp2_ = g_strconcat ("matching tile found at ", _tmp1_, NULL);
#line 351 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 351 "../src/grid.vala"
	g_debug ("grid.vala:351: %s", _tmp3_);
#line 351 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 351 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 353 "../src/grid.vala"
	_tmp4_ = *cur;
#line 353 "../src/grid.vala"
	_tmp5_ = *free;
#line 353 "../src/grid.vala"
	_tmp6_.from = _tmp4_;
#line 353 "../src/grid.vala"
	_tmp6_.to = _tmp5_;
#line 353 "../src/grid.vala"
	mov = _tmp6_;
#line 354 "../src/grid.vala"
	_tmp7_ = mov;
#line 354 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_hide), &_tmp7_);
#line 355 "../src/grid.vala"
	_tmp8_ = *match;
#line 355 "../src/grid.vala"
	_tmp9_ = *free;
#line 355 "../src/grid.vala"
	_tmp10_.from = _tmp8_;
#line 355 "../src/grid.vala"
	_tmp10_.to = _tmp9_;
#line 355 "../src/grid.vala"
	mov = _tmp10_;
#line 356 "../src/grid.vala"
	_tmp11_ = mov;
#line 356 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_hide), &_tmp11_);
#line 358 "../src/grid.vala"
	_tmp12_ = *val;
#line 358 "../src/grid.vala"
	*val = _tmp12_ + 1;
#line 359 "../src/grid.vala"
	_tmp13_ = *free;
#line 359 "../src/grid.vala"
	_tmp14_.pos = _tmp13_;
#line 359 "../src/grid.vala"
	_tmp14_.val = *val;
#line 359 "../src/grid.vala"
	tile = _tmp14_;
#line 360 "../src/grid.vala"
	_tmp15_ = tile;
#line 360 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_show), &_tmp15_);
#line 362 "../src/grid.vala"
	_tmp16_ = *cur;
#line 362 "../src/grid.vala"
	_tmp17_ = *cur;
#line 362 "../src/grid.vala"
	(*grid)[(_tmp16_.row * (*grid_length2)) + _tmp17_.col] = (guint8) 0;
#line 363 "../src/grid.vala"
	_tmp18_ = *match;
#line 363 "../src/grid.vala"
	_tmp19_ = *match;
#line 363 "../src/grid.vala"
	(*grid)[(_tmp18_.row * (*grid_length2)) + _tmp19_.col] = (guint8) 0;
#line 364 "../src/grid.vala"
	_tmp20_ = *free;
#line 364 "../src/grid.vala"
	_tmp21_ = *free;
#line 364 "../src/grid.vala"
	(*grid)[(_tmp20_.row * (*grid_length2)) + _tmp21_.col] = *val;
#line 365 "../src/grid.vala"
	if ((*max_changed) < (*val)) {
#line 366 "../src/grid.vala"
		*max_changed = *val;
#line 1635 "grid.c"
	}
}

static void
_grid_move_to_end (GeeLinkedList* * to_move,
                   GridPosition* cur,
                   GridPosition* free,
                   guint8** grid,
                   gint* grid_length1,
                   gint* grid_length2,
                   guint8* val)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	TileMovement mov = {0};
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	TileMovement _tmp8_ = {0};
	TileMovement _tmp9_;
	GridPosition _tmp10_;
	GridPosition _tmp11_;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
#line 369 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 369 "../src/grid.vala"
	g_return_if_fail (cur != NULL);
#line 369 "../src/grid.vala"
	g_return_if_fail (free != NULL);
#line 375 "../src/grid.vala"
	_tmp0_ = grid_position_to_string (cur);
#line 375 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 375 "../src/grid.vala"
	_tmp2_ = grid_position_to_string (free);
#line 375 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 375 "../src/grid.vala"
	_tmp4_ = g_strconcat ("moving ", _tmp1_, " to ", _tmp3_, NULL);
#line 375 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 375 "../src/grid.vala"
	g_debug ("grid.vala:375: %s", _tmp5_);
#line 375 "../src/grid.vala"
	_g_free0 (_tmp5_);
#line 375 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 375 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 377 "../src/grid.vala"
	_tmp6_ = *cur;
#line 377 "../src/grid.vala"
	_tmp7_ = *free;
#line 377 "../src/grid.vala"
	_tmp8_.from = _tmp6_;
#line 377 "../src/grid.vala"
	_tmp8_.to = _tmp7_;
#line 377 "../src/grid.vala"
	mov = _tmp8_;
#line 378 "../src/grid.vala"
	_tmp9_ = mov;
#line 378 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_move), &_tmp9_);
#line 380 "../src/grid.vala"
	_tmp10_ = *cur;
#line 380 "../src/grid.vala"
	_tmp11_ = *cur;
#line 380 "../src/grid.vala"
	(*grid)[(_tmp10_.row * (*grid_length2)) + _tmp11_.col] = (guint8) 0;
#line 381 "../src/grid.vala"
	_tmp12_ = *free;
#line 381 "../src/grid.vala"
	_tmp13_ = *free;
#line 381 "../src/grid.vala"
	(*grid)[(_tmp12_.row * (*grid_length2)) + _tmp13_.col] = *val;
#line 1715 "grid.c"
}

gboolean
grid_is_finished (Grid* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 388 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 390 "../src/grid.vala"
	_tmp0_ = _grid_grid_is_full (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 390 "../src/grid.vala"
	if (!_tmp0_) {
#line 391 "../src/grid.vala"
		result = FALSE;
#line 391 "../src/grid.vala"
		return result;
#line 1733 "grid.c"
	}
	{
		gint i = 0;
#line 393 "../src/grid.vala"
		i = 0;
#line 1739 "grid.c"
		{
			gboolean _tmp1_ = FALSE;
#line 393 "../src/grid.vala"
			_tmp1_ = TRUE;
#line 393 "../src/grid.vala"
			while (TRUE) {
#line 393 "../src/grid.vala"
				if (!_tmp1_) {
#line 1748 "grid.c"
					gint _tmp2_;
#line 393 "../src/grid.vala"
					_tmp2_ = i;
#line 393 "../src/grid.vala"
					i = _tmp2_ + 1;
#line 1754 "grid.c"
				}
#line 393 "../src/grid.vala"
				_tmp1_ = FALSE;
#line 393 "../src/grid.vala"
				if (!(i < self->priv->_rows)) {
#line 393 "../src/grid.vala"
					break;
#line 1762 "grid.c"
				}
				{
					gint j = 0;
#line 395 "../src/grid.vala"
					j = 0;
#line 1768 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 395 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 395 "../src/grid.vala"
						while (TRUE) {
#line 1775 "grid.c"
							guint8 val = 0U;
							guint8* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							guint8 _tmp6_;
							gboolean _tmp7_ = FALSE;
							gboolean _tmp10_ = FALSE;
#line 395 "../src/grid.vala"
							if (!_tmp3_) {
#line 1785 "grid.c"
								gint _tmp4_;
#line 395 "../src/grid.vala"
								_tmp4_ = j;
#line 395 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1791 "grid.c"
							}
#line 395 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 395 "../src/grid.vala"
							if (!(j < self->priv->_cols)) {
#line 395 "../src/grid.vala"
								break;
#line 1799 "grid.c"
							}
#line 397 "../src/grid.vala"
							_tmp5_ = self->_grid;
#line 397 "../src/grid.vala"
							_tmp5__length1 = self->_grid_length1;
#line 397 "../src/grid.vala"
							_tmp5__length2 = self->_grid_length2;
#line 397 "../src/grid.vala"
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
#line 397 "../src/grid.vala"
							val = _tmp6_;
#line 399 "../src/grid.vala"
							if (i < (self->priv->_rows - 1)) {
#line 1813 "grid.c"
								guint8* _tmp8_;
								gint _tmp8__length1;
								gint _tmp8__length2;
								guint8 _tmp9_;
#line 399 "../src/grid.vala"
								_tmp8_ = self->_grid;
#line 399 "../src/grid.vala"
								_tmp8__length1 = self->_grid_length1;
#line 399 "../src/grid.vala"
								_tmp8__length2 = self->_grid_length2;
#line 399 "../src/grid.vala"
								_tmp9_ = _tmp8_[((i + 1) * _tmp8__length2) + j];
#line 399 "../src/grid.vala"
								_tmp7_ = val == _tmp9_;
#line 1828 "grid.c"
							} else {
#line 399 "../src/grid.vala"
								_tmp7_ = FALSE;
#line 1832 "grid.c"
							}
#line 399 "../src/grid.vala"
							if (_tmp7_) {
#line 400 "../src/grid.vala"
								result = FALSE;
#line 400 "../src/grid.vala"
								return result;
#line 1840 "grid.c"
							}
#line 402 "../src/grid.vala"
							if (j < (self->priv->_cols - 1)) {
#line 1844 "grid.c"
								guint8* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								guint8 _tmp12_;
#line 402 "../src/grid.vala"
								_tmp11_ = self->_grid;
#line 402 "../src/grid.vala"
								_tmp11__length1 = self->_grid_length1;
#line 402 "../src/grid.vala"
								_tmp11__length2 = self->_grid_length2;
#line 402 "../src/grid.vala"
								_tmp12_ = _tmp11_[(i * _tmp11__length2) + (j + 1)];
#line 402 "../src/grid.vala"
								_tmp10_ = val == _tmp12_;
#line 1859 "grid.c"
							} else {
#line 402 "../src/grid.vala"
								_tmp10_ = FALSE;
#line 1863 "grid.c"
							}
#line 402 "../src/grid.vala"
							if (_tmp10_) {
#line 403 "../src/grid.vala"
								result = FALSE;
#line 403 "../src/grid.vala"
								return result;
#line 1871 "grid.c"
							}
						}
					}
				}
			}
		}
	}
#line 407 "../src/grid.vala"
	result = TRUE;
#line 407 "../src/grid.vala"
	return result;
#line 1883 "grid.c"
}

gboolean
_grid_grid_is_full (guint8** grid,
                    gint* grid_length1,
                    gint* grid_length2)
{
	gboolean result = FALSE;
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 412 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 412 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 413 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 413 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 1904 "grid.c"
	{
		guint i = 0U;
#line 415 "../src/grid.vala"
		i = (guint) 0;
#line 1909 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 415 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 415 "../src/grid.vala"
			while (TRUE) {
#line 415 "../src/grid.vala"
				if (!_tmp2_) {
#line 1918 "grid.c"
					guint _tmp3_;
#line 415 "../src/grid.vala"
					_tmp3_ = i;
#line 415 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 1924 "grid.c"
				}
#line 415 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 415 "../src/grid.vala"
				if (!(i < rows)) {
#line 415 "../src/grid.vala"
					break;
#line 1932 "grid.c"
				}
				{
					guint j = 0U;
#line 416 "../src/grid.vala"
					j = (guint) 0;
#line 1938 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 416 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 416 "../src/grid.vala"
						while (TRUE) {
#line 1945 "grid.c"
							guint8 _tmp6_;
#line 416 "../src/grid.vala"
							if (!_tmp4_) {
#line 1949 "grid.c"
								guint _tmp5_;
#line 416 "../src/grid.vala"
								_tmp5_ = j;
#line 416 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 1955 "grid.c"
							}
#line 416 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 416 "../src/grid.vala"
							if (!(j < cols)) {
#line 416 "../src/grid.vala"
								break;
#line 1963 "grid.c"
							}
#line 417 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 417 "../src/grid.vala"
							if (((gint) _tmp6_) == 0) {
#line 418 "../src/grid.vala"
								result = FALSE;
#line 418 "../src/grid.vala"
								return result;
#line 1973 "grid.c"
							}
						}
					}
				}
			}
		}
	}
#line 419 "../src/grid.vala"
	result = TRUE;
#line 419 "../src/grid.vala"
	return result;
#line 1985 "grid.c"
}

void
grid_clear (Grid* self)
{
#line 422 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/grid.vala"
	_grid_clear (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 1995 "grid.c"
}

static void
_grid_clear (guint8** grid,
             gint* grid_length1,
             gint* grid_length2)
{
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 428 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 428 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 429 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 429 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2015 "grid.c"
	{
		guint i = 0U;
#line 431 "../src/grid.vala"
		i = (guint) 0;
#line 2020 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 431 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 431 "../src/grid.vala"
			while (TRUE) {
#line 431 "../src/grid.vala"
				if (!_tmp2_) {
#line 2029 "grid.c"
					guint _tmp3_;
#line 431 "../src/grid.vala"
					_tmp3_ = i;
#line 431 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2035 "grid.c"
				}
#line 431 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 431 "../src/grid.vala"
				if (!(i < rows)) {
#line 431 "../src/grid.vala"
					break;
#line 2043 "grid.c"
				}
				{
					guint j = 0U;
#line 432 "../src/grid.vala"
					j = (guint) 0;
#line 2049 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 432 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 432 "../src/grid.vala"
						while (TRUE) {
#line 432 "../src/grid.vala"
							if (!_tmp4_) {
#line 2058 "grid.c"
								guint _tmp5_;
#line 432 "../src/grid.vala"
								_tmp5_ = j;
#line 432 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2064 "grid.c"
							}
#line 432 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 432 "../src/grid.vala"
							if (!(j < cols)) {
#line 432 "../src/grid.vala"
								break;
#line 2072 "grid.c"
							}
#line 433 "../src/grid.vala"
							(*grid)[(i * (*grid_length2)) + j] = (guint8) 0;
#line 2076 "grid.c"
						}
					}
				}
			}
		}
	}
}

glong
grid_get_score (Grid* self)
{
	glong result = 0L;
	glong _tmp0_;
#line 436 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 438 "../src/grid.vala"
	_tmp0_ = _grid_get_score (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 438 "../src/grid.vala"
	result = _tmp0_;
#line 438 "../src/grid.vala"
	return result;
#line 2098 "grid.c"
}

static glong
_grid_get_score (guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2)
{
	glong result = 0L;
	glong score = 0L;
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 442 "../src/grid.vala"
	score = (glong) 0;
#line 444 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 444 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 445 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 445 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2122 "grid.c"
	{
		guint i = 0U;
#line 447 "../src/grid.vala"
		i = (guint) 0;
#line 2127 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 447 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 447 "../src/grid.vala"
			while (TRUE) {
#line 447 "../src/grid.vala"
				if (!_tmp2_) {
#line 2136 "grid.c"
					guint _tmp3_;
#line 447 "../src/grid.vala"
					_tmp3_ = i;
#line 447 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2142 "grid.c"
				}
#line 447 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 447 "../src/grid.vala"
				if (!(i < rows)) {
#line 447 "../src/grid.vala"
					break;
#line 2150 "grid.c"
				}
				{
					guint j = 0U;
#line 448 "../src/grid.vala"
					j = (guint) 0;
#line 2156 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 448 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 448 "../src/grid.vala"
						while (TRUE) {
#line 2163 "grid.c"
							guint8 _tmp6_;
#line 448 "../src/grid.vala"
							if (!_tmp4_) {
#line 2167 "grid.c"
								guint _tmp5_;
#line 448 "../src/grid.vala"
								_tmp5_ = j;
#line 448 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2173 "grid.c"
							}
#line 448 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 448 "../src/grid.vala"
							if (!(j < cols)) {
#line 448 "../src/grid.vala"
								break;
#line 2181 "grid.c"
							}
#line 449 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 449 "../src/grid.vala"
							score = score + _grid_calculate_score_value (_tmp6_);
#line 2187 "grid.c"
						}
					}
				}
			}
		}
	}
#line 450 "../src/grid.vala"
	result = score;
#line 450 "../src/grid.vala"
	return result;
#line 2198 "grid.c"
}

static inline glong
_grid_calculate_score_value (guint8 tile_value)
{
	glong result = 0L;
#line 454 "../src/grid.vala"
	if (((gint) tile_value) < 2) {
#line 455 "../src/grid.vala"
		result = (glong) 0;
#line 455 "../src/grid.vala"
		return result;
#line 2211 "grid.c"
	}
#line 456 "../src/grid.vala"
	result = (glong) (pow ((gdouble) 2, (gdouble) tile_value) * (tile_value - 1));
#line 456 "../src/grid.vala"
	return result;
#line 2217 "grid.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  int length)
{
#line 466 "../src/grid.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 2226 "grid.c"
}

Grid*
grid_clone (Grid* self)
{
	Grid* result = NULL;
	Grid* grid = NULL;
	Grid* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 463 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 465 "../src/grid.vala"
	_tmp0_ = grid_new (self->priv->_rows, self->priv->_cols);
#line 465 "../src/grid.vala"
	grid = _tmp0_;
#line 466 "../src/grid.vala"
	_tmp1_ = self->_grid;
#line 466 "../src/grid.vala"
	_tmp1__length1 = self->_grid_length1;
#line 466 "../src/grid.vala"
	_tmp1__length2 = self->_grid_length2;
#line 466 "../src/grid.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _tmp1__length1 * _tmp1__length2) : ((gpointer) _tmp1_);
#line 466 "../src/grid.vala"
	_tmp2__length1 = _tmp1__length1;
#line 466 "../src/grid.vala"
	_tmp2__length2 = _tmp1__length2;
#line 466 "../src/grid.vala"
	grid->_grid = (g_free (grid->_grid), NULL);
#line 466 "../src/grid.vala"
	grid->_grid = _tmp2_;
#line 466 "../src/grid.vala"
	grid->_grid_length1 = _tmp2__length1;
#line 466 "../src/grid.vala"
	grid->_grid_length2 = _tmp2__length2;
#line 467 "../src/grid.vala"
	grid->priv->_target_value = self->priv->_target_value;
#line 468 "../src/grid.vala"
	grid->priv->_target_value_reached = self->priv->_target_value_reached;
#line 470 "../src/grid.vala"
	result = grid;
#line 470 "../src/grid.vala"
	return result;
#line 2275 "grid.c"
}

guint8
grid_get (Grid* self,
          gint row,
          gint col)
{
	guint8 result = 0U;
	gboolean _tmp0_ = FALSE;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8 _tmp2_;
#line 473 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 475 "../src/grid.vala"
	if (row >= self->priv->_rows) {
#line 475 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 2295 "grid.c"
	} else {
#line 475 "../src/grid.vala"
		_tmp0_ = col >= self->priv->_cols;
#line 2299 "grid.c"
	}
#line 475 "../src/grid.vala"
	if (_tmp0_) {
#line 476 "../src/grid.vala"
		result = (guint8) 0;
#line 476 "../src/grid.vala"
		return result;
#line 2307 "grid.c"
	}
#line 478 "../src/grid.vala"
	_tmp1_ = self->_grid;
#line 478 "../src/grid.vala"
	_tmp1__length1 = self->_grid_length1;
#line 478 "../src/grid.vala"
	_tmp1__length2 = self->_grid_length2;
#line 478 "../src/grid.vala"
	_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 478 "../src/grid.vala"
	result = _tmp2_;
#line 478 "../src/grid.vala"
	return result;
#line 2321 "grid.c"
}

gboolean
grid_is_disallowed_grid_size (gint* rows,
                              gint* cols)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 481 "../src/grid.vala"
	_vala_return_val_if_fail ((*rows) >= 1, "rows >= 1", FALSE);
#line 481 "../src/grid.vala"
	_vala_return_val_if_fail ((*rows) <= 9, "rows <= 9", FALSE);
#line 481 "../src/grid.vala"
	_vala_return_val_if_fail ((*cols) >= 1, "cols >= 1", FALSE);
#line 481 "../src/grid.vala"
	_vala_return_val_if_fail ((*cols) <= 9, "cols <= 9", FALSE);
#line 487 "../src/grid.vala"
	if ((*rows) == 1) {
#line 487 "../src/grid.vala"
		_tmp2_ = (*cols) == 1;
#line 2344 "grid.c"
	} else {
#line 487 "../src/grid.vala"
		_tmp2_ = FALSE;
#line 2348 "grid.c"
	}
#line 487 "../src/grid.vala"
	if (_tmp2_) {
#line 487 "../src/grid.vala"
		_tmp1_ = TRUE;
#line 2354 "grid.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 487 "../src/grid.vala"
		if ((*rows) == 1) {
#line 487 "../src/grid.vala"
			_tmp3_ = (*cols) == 2;
#line 2361 "grid.c"
		} else {
#line 487 "../src/grid.vala"
			_tmp3_ = FALSE;
#line 2365 "grid.c"
		}
#line 487 "../src/grid.vala"
		_tmp1_ = _tmp3_;
#line 2369 "grid.c"
	}
#line 487 "../src/grid.vala"
	if (_tmp1_) {
#line 487 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 2375 "grid.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 487 "../src/grid.vala"
		if ((*rows) == 2) {
#line 487 "../src/grid.vala"
			_tmp4_ = (*cols) == 1;
#line 2382 "grid.c"
		} else {
#line 487 "../src/grid.vala"
			_tmp4_ = FALSE;
#line 2386 "grid.c"
		}
#line 487 "../src/grid.vala"
		_tmp0_ = _tmp4_;
#line 2390 "grid.c"
	}
#line 487 "../src/grid.vala"
	result = _tmp0_;
#line 487 "../src/grid.vala"
	return result;
#line 2396 "grid.c"
}

gchar*
grid_save (Grid* self)
{
	gchar* result = NULL;
	gchar* ret_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	glong _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 494 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 496 "../src/grid.vala"
	_tmp0_ = g_strdup_printf ("%i", self->priv->_rows);
#line 496 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 496 "../src/grid.vala"
	_tmp2_ = g_strdup_printf ("%i", self->priv->_cols);
#line 496 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 496 "../src/grid.vala"
	_tmp4_ = g_strconcat (_tmp1_, " ", _tmp3_, "\n", NULL);
#line 496 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 496 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 496 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 496 "../src/grid.vala"
	ret_string = _tmp5_;
#line 497 "../src/grid.vala"
	_grid_convert_to_string (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), &ret_string);
#line 498 "../src/grid.vala"
	_tmp6_ = ret_string;
#line 498 "../src/grid.vala"
	_tmp7_ = _grid_get_score (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 498 "../src/grid.vala"
	_tmp8_ = g_strdup_printf ("%li", _tmp7_);
#line 498 "../src/grid.vala"
	_tmp9_ = _tmp8_;
#line 498 "../src/grid.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 498 "../src/grid.vala"
	_g_free0 (ret_string);
#line 498 "../src/grid.vala"
	ret_string = _tmp10_;
#line 498 "../src/grid.vala"
	_g_free0 (_tmp9_);
#line 499 "../src/grid.vala"
	_tmp11_ = ret_string;
#line 499 "../src/grid.vala"
	_tmp12_ = g_strconcat (_tmp11_, "\n", NULL);
#line 499 "../src/grid.vala"
	_g_free0 (ret_string);
#line 499 "../src/grid.vala"
	ret_string = _tmp12_;
#line 500 "../src/grid.vala"
	result = ret_string;
#line 500 "../src/grid.vala"
	return result;
#line 2467 "grid.c"
}

gchar*
grid_to_string (Grid* self)
{
	gchar* result = NULL;
	gchar* ret_string = NULL;
	gchar* _tmp0_;
#line 503 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 505 "../src/grid.vala"
	_tmp0_ = g_strdup ("\n");
#line 505 "../src/grid.vala"
	ret_string = _tmp0_;
#line 506 "../src/grid.vala"
	_grid_convert_to_string (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), &ret_string);
#line 507 "../src/grid.vala"
	result = ret_string;
#line 507 "../src/grid.vala"
	return result;
#line 2488 "grid.c"
}

static void
_grid_convert_to_string (guint8** grid,
                         gint* grid_length1,
                         gint* grid_length2,
                         gchar* * ret_string)
{
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 510 "../src/grid.vala"
	g_return_if_fail (*ret_string != NULL);
#line 512 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 512 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 513 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 513 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2511 "grid.c"
	{
		guint i = 0U;
#line 515 "../src/grid.vala"
		i = (guint) 0;
#line 2516 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 515 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 515 "../src/grid.vala"
			while (TRUE) {
#line 515 "../src/grid.vala"
				if (!_tmp2_) {
#line 2525 "grid.c"
					guint _tmp3_;
#line 515 "../src/grid.vala"
					_tmp3_ = i;
#line 515 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2531 "grid.c"
				}
#line 515 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 515 "../src/grid.vala"
				if (!(i < rows)) {
#line 515 "../src/grid.vala"
					break;
#line 2539 "grid.c"
				}
				{
					guint j = 0U;
#line 517 "../src/grid.vala"
					j = (guint) 0;
#line 2545 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 517 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 517 "../src/grid.vala"
						while (TRUE) {
#line 2552 "grid.c"
							guint64 val = 0ULL;
							guint8 _tmp6_;
							const gchar* _tmp8_ = NULL;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
#line 517 "../src/grid.vala"
							if (!_tmp4_) {
#line 2561 "grid.c"
								guint _tmp5_;
#line 517 "../src/grid.vala"
								_tmp5_ = j;
#line 517 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2567 "grid.c"
							}
#line 517 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 517 "../src/grid.vala"
							if (!(j < cols)) {
#line 517 "../src/grid.vala"
								break;
#line 2575 "grid.c"
							}
#line 520 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 520 "../src/grid.vala"
							if (((gint) _tmp6_) == 0) {
#line 521 "../src/grid.vala"
								val = (guint64) 0;
#line 2583 "grid.c"
							} else {
								guint8 _tmp7_;
#line 523 "../src/grid.vala"
								_tmp7_ = (*grid)[(i * (*grid_length2)) + j];
#line 523 "../src/grid.vala"
								val = (guint64) pow ((gdouble) 2, (gdouble) _tmp7_);
#line 2590 "grid.c"
							}
#line 524 "../src/grid.vala"
							if (j == (cols - 1)) {
#line 524 "../src/grid.vala"
								_tmp8_ = "\n";
#line 2596 "grid.c"
							} else {
#line 524 "../src/grid.vala"
								_tmp8_ = " ";
#line 2600 "grid.c"
							}
#line 524 "../src/grid.vala"
							_tmp9_ = g_strdup_printf ("%llu%s", val, _tmp8_);
#line 524 "../src/grid.vala"
							_tmp10_ = _tmp9_;
#line 524 "../src/grid.vala"
							_tmp11_ = g_strconcat (*ret_string, _tmp10_, NULL);
#line 524 "../src/grid.vala"
							_g_free0 (*ret_string);
#line 524 "../src/grid.vala"
							*ret_string = _tmp11_;
#line 524 "../src/grid.vala"
							_g_free0 (_tmp10_);
#line 2614 "grid.c"
						}
					}
				}
			}
		}
	}
}

static guint8*
_vala_array_dup2 (guint8* self,
                  int length)
{
#line 541 "../src/grid.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 2629 "grid.c"
}

gboolean
grid_load (Grid* self,
           gchar* * content)
{
	gboolean result = FALSE;
	guint8* grid = NULL;
	guint8* _tmp0_;
	gint grid_length1;
	gint grid_length2;
	gboolean _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
#line 533 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 533 "../src/grid.vala"
	g_return_val_if_fail (*content != NULL, FALSE);
#line 535 "../src/grid.vala"
	_tmp0_ = g_new0 (guint8, 1 * 0);
#line 535 "../src/grid.vala"
	grid = _tmp0_;
#line 535 "../src/grid.vala"
	grid_length1 = 1;
#line 535 "../src/grid.vala"
	grid_length2 = 0;
#line 536 "../src/grid.vala"
	_tmp1_ = _grid_load_from_string (content, &grid, (gint*) (&grid_length1), (gint*) (&grid_length2));
#line 536 "../src/grid.vala"
	if (!_tmp1_) {
#line 537 "../src/grid.vala"
		result = FALSE;
#line 537 "../src/grid.vala"
		grid = (g_free (grid), NULL);
#line 537 "../src/grid.vala"
		return result;
#line 2678 "grid.c"
	}
#line 539 "../src/grid.vala"
	_tmp2_ = grid;
#line 539 "../src/grid.vala"
	_tmp2__length1 = grid_length1;
#line 539 "../src/grid.vala"
	_tmp2__length2 = grid_length2;
#line 539 "../src/grid.vala"
	_tmp3_ = _tmp2__length1;
#line 539 "../src/grid.vala"
	self->priv->_rows = _tmp3_;
#line 540 "../src/grid.vala"
	_tmp4_ = grid;
#line 540 "../src/grid.vala"
	_tmp4__length1 = grid_length1;
#line 540 "../src/grid.vala"
	_tmp4__length2 = grid_length2;
#line 540 "../src/grid.vala"
	_tmp5_ = _tmp4__length2;
#line 540 "../src/grid.vala"
	self->priv->_cols = _tmp5_;
#line 541 "../src/grid.vala"
	_tmp6_ = grid;
#line 541 "../src/grid.vala"
	_tmp6__length1 = grid_length1;
#line 541 "../src/grid.vala"
	_tmp6__length2 = grid_length2;
#line 541 "../src/grid.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup2 (_tmp6_, _tmp6__length1 * _tmp6__length2) : ((gpointer) _tmp6_);
#line 541 "../src/grid.vala"
	_tmp7__length1 = _tmp6__length1;
#line 541 "../src/grid.vala"
	_tmp7__length2 = _tmp6__length2;
#line 541 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 541 "../src/grid.vala"
	self->_grid = _tmp7_;
#line 541 "../src/grid.vala"
	self->_grid_length1 = _tmp7__length1;
#line 541 "../src/grid.vala"
	self->_grid_length2 = _tmp7__length2;
#line 542 "../src/grid.vala"
	result = TRUE;
#line 542 "../src/grid.vala"
	grid = (g_free (grid), NULL);
#line 542 "../src/grid.vala"
	return result;
#line 2726 "grid.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar* * unparsed)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 786 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 788 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, (guint) 0);
#line 788 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 788 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 789 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 789 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 789 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 789 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 790 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 791 "glib-2.0.vapi"
		result = TRUE;
#line 791 "glib-2.0.vapi"
		if (_result_) {
#line 791 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2767 "grid.c"
		}
#line 791 "glib-2.0.vapi"
		if (unparsed) {
#line 791 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2773 "grid.c"
		}
#line 791 "glib-2.0.vapi"
		return result;
#line 2777 "grid.c"
	} else {
		gchar* _tmp5_;
#line 793 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 793 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 794 "glib-2.0.vapi"
		result = FALSE;
#line 794 "glib-2.0.vapi"
		if (_result_) {
#line 794 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2790 "grid.c"
		}
#line 794 "glib-2.0.vapi"
		if (unparsed) {
#line 794 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2796 "grid.c"
		}
#line 794 "glib-2.0.vapi"
		return result;
#line 2800 "grid.c"
	}
#line 786 "glib-2.0.vapi"
	if (_result_) {
#line 786 "glib-2.0.vapi"
		*_result_ = _vala__result_;
#line 2806 "grid.c"
	}
#line 786 "glib-2.0.vapi"
	if (unparsed) {
#line 786 "glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 2812 "grid.c"
	}
}

static gboolean
_grid_load_from_string (gchar* * content,
                        guint8** grid,
                        gint* grid_length1,
                        gint* grid_length2)
{
	gboolean result = FALSE;
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** tokens = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint tokens_length1;
	gint _tokens_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	guint64 number_64 = 0ULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	guint64 _tmp10_ = 0ULL;
	gboolean _tmp11_;
	gboolean _tmp12_ = FALSE;
	gint rows = 0;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	guint64 _tmp15_ = 0ULL;
	gboolean _tmp16_;
	gboolean _tmp17_ = FALSE;
	gint cols = 0;
	gboolean _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
#line 545 "../src/grid.vala"
	g_return_val_if_fail (*content != NULL, FALSE);
#line 548 "../src/grid.vala"
	_tmp1_ = _tmp0_ = g_strsplit (*content, "\n", 0);
#line 548 "../src/grid.vala"
	lines = _tmp1_;
#line 548 "../src/grid.vala"
	lines_length1 = _vala_array_length (_tmp0_);
#line 548 "../src/grid.vala"
	_lines_size_ = lines_length1;
#line 551 "../src/grid.vala"
	_tmp2_ = lines;
#line 551 "../src/grid.vala"
	_tmp2__length1 = lines_length1;
#line 551 "../src/grid.vala"
	if (_tmp2__length1 < 4) {
#line 552 "../src/grid.vala"
		result = FALSE;
#line 552 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 552 "../src/grid.vala"
		return result;
#line 2881 "grid.c"
	}
#line 554 "../src/grid.vala"
	_tmp3_ = lines;
#line 554 "../src/grid.vala"
	_tmp3__length1 = lines_length1;
#line 554 "../src/grid.vala"
	_tmp4_ = _tmp3_[0];
#line 554 "../src/grid.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, " ", 0);
#line 554 "../src/grid.vala"
	tokens = _tmp6_;
#line 554 "../src/grid.vala"
	tokens_length1 = _vala_array_length (_tmp5_);
#line 554 "../src/grid.vala"
	_tokens_size_ = tokens_length1;
#line 555 "../src/grid.vala"
	_tmp7_ = tokens;
#line 555 "../src/grid.vala"
	_tmp7__length1 = tokens_length1;
#line 555 "../src/grid.vala"
	if (_tmp7__length1 != 2) {
#line 556 "../src/grid.vala"
		result = FALSE;
#line 556 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 556 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 556 "../src/grid.vala"
		return result;
#line 2911 "grid.c"
	}
#line 560 "../src/grid.vala"
	_tmp8_ = tokens;
#line 560 "../src/grid.vala"
	_tmp8__length1 = tokens_length1;
#line 560 "../src/grid.vala"
	_tmp9_ = _tmp8_[0];
#line 560 "../src/grid.vala"
	_tmp11_ = uint64_try_parse (_tmp9_, &_tmp10_, NULL);
#line 560 "../src/grid.vala"
	number_64 = _tmp10_;
#line 560 "../src/grid.vala"
	if (!_tmp11_) {
#line 561 "../src/grid.vala"
		result = FALSE;
#line 561 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 561 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 561 "../src/grid.vala"
		return result;
#line 2933 "grid.c"
	}
#line 562 "../src/grid.vala"
	if (number_64 == ((guint64) 0)) {
#line 562 "../src/grid.vala"
		_tmp12_ = TRUE;
#line 2939 "grid.c"
	} else {
#line 562 "../src/grid.vala"
		_tmp12_ = number_64 > ((guint64) 9);
#line 2943 "grid.c"
	}
#line 562 "../src/grid.vala"
	if (_tmp12_) {
#line 563 "../src/grid.vala"
		result = FALSE;
#line 563 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 563 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 563 "../src/grid.vala"
		return result;
#line 2955 "grid.c"
	}
#line 564 "../src/grid.vala"
	rows = (gint) number_64;
#line 566 "../src/grid.vala"
	_tmp13_ = tokens;
#line 566 "../src/grid.vala"
	_tmp13__length1 = tokens_length1;
#line 566 "../src/grid.vala"
	_tmp14_ = _tmp13_[1];
#line 566 "../src/grid.vala"
	_tmp16_ = uint64_try_parse (_tmp14_, &_tmp15_, NULL);
#line 566 "../src/grid.vala"
	number_64 = _tmp15_;
#line 566 "../src/grid.vala"
	if (!_tmp16_) {
#line 567 "../src/grid.vala"
		result = FALSE;
#line 567 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 567 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 567 "../src/grid.vala"
		return result;
#line 2979 "grid.c"
	}
#line 568 "../src/grid.vala"
	if (number_64 == ((guint64) 0)) {
#line 568 "../src/grid.vala"
		_tmp17_ = TRUE;
#line 2985 "grid.c"
	} else {
#line 568 "../src/grid.vala"
		_tmp17_ = number_64 > ((guint64) 9);
#line 2989 "grid.c"
	}
#line 568 "../src/grid.vala"
	if (_tmp17_) {
#line 569 "../src/grid.vala"
		result = FALSE;
#line 569 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 569 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 569 "../src/grid.vala"
		return result;
#line 3001 "grid.c"
	}
#line 570 "../src/grid.vala"
	cols = (gint) number_64;
#line 572 "../src/grid.vala"
	_tmp18_ = grid_is_disallowed_grid_size (&rows, &cols);
#line 572 "../src/grid.vala"
	if (_tmp18_) {
#line 573 "../src/grid.vala"
		result = FALSE;
#line 573 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 573 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 573 "../src/grid.vala"
		return result;
#line 3017 "grid.c"
	}
#line 575 "../src/grid.vala"
	_tmp19_ = lines;
#line 575 "../src/grid.vala"
	_tmp19__length1 = lines_length1;
#line 575 "../src/grid.vala"
	if (_tmp19__length1 < (rows + 2)) {
#line 576 "../src/grid.vala"
		result = FALSE;
#line 576 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 576 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 576 "../src/grid.vala"
		return result;
#line 3033 "grid.c"
	}
#line 578 "../src/grid.vala"
	_tmp20_ = g_new0 (guint8, rows * cols);
#line 578 "../src/grid.vala"
	*grid = (g_free (*grid), NULL);
#line 578 "../src/grid.vala"
	*grid = _tmp20_;
#line 578 "../src/grid.vala"
	*grid_length1 = rows;
#line 578 "../src/grid.vala"
	*grid_length2 = cols;
#line 3045 "grid.c"
	{
		guint i = 0U;
#line 580 "../src/grid.vala"
		i = (guint) 0;
#line 3050 "grid.c"
		{
			gboolean _tmp21_ = FALSE;
#line 580 "../src/grid.vala"
			_tmp21_ = TRUE;
#line 580 "../src/grid.vala"
			while (TRUE) {
#line 3057 "grid.c"
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar** _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gchar** _tmp27_;
				gint _tmp27__length1;
#line 580 "../src/grid.vala"
				if (!_tmp21_) {
#line 3067 "grid.c"
					guint _tmp22_;
#line 580 "../src/grid.vala"
					_tmp22_ = i;
#line 580 "../src/grid.vala"
					i = _tmp22_ + 1;
#line 3073 "grid.c"
				}
#line 580 "../src/grid.vala"
				_tmp21_ = FALSE;
#line 580 "../src/grid.vala"
				if (!(i < ((guint) rows))) {
#line 580 "../src/grid.vala"
					break;
#line 3081 "grid.c"
				}
#line 582 "../src/grid.vala"
				_tmp23_ = lines;
#line 582 "../src/grid.vala"
				_tmp23__length1 = lines_length1;
#line 582 "../src/grid.vala"
				_tmp24_ = _tmp23_[i + 1];
#line 582 "../src/grid.vala"
				_grid_parse_line (_tmp24_, &_tmp25_, &_tmp26_);
#line 582 "../src/grid.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 582 "../src/grid.vala"
				tokens = _tmp25_;
#line 582 "../src/grid.vala"
				tokens_length1 = _tmp26_;
#line 582 "../src/grid.vala"
				_tokens_size_ = tokens_length1;
#line 584 "../src/grid.vala"
				_tmp27_ = tokens;
#line 584 "../src/grid.vala"
				_tmp27__length1 = tokens_length1;
#line 584 "../src/grid.vala"
				if (_tmp27__length1 != cols) {
#line 585 "../src/grid.vala"
					result = FALSE;
#line 585 "../src/grid.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 585 "../src/grid.vala"
					lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 585 "../src/grid.vala"
					return result;
#line 3113 "grid.c"
				}
				{
					guint j = 0U;
#line 587 "../src/grid.vala"
					j = (guint) 0;
#line 3119 "grid.c"
					{
						gboolean _tmp28_ = FALSE;
#line 587 "../src/grid.vala"
						_tmp28_ = TRUE;
#line 587 "../src/grid.vala"
						while (TRUE) {
#line 3126 "grid.c"
							gchar** _tmp30_;
							gint _tmp30__length1;
							const gchar* _tmp31_;
							guint64 _tmp32_ = 0ULL;
							gboolean _tmp33_;
							guint8 number = 0U;
							guint8 _tmp34_ = 0U;
							gboolean _tmp35_;
#line 587 "../src/grid.vala"
							if (!_tmp28_) {
#line 3137 "grid.c"
								guint _tmp29_;
#line 587 "../src/grid.vala"
								_tmp29_ = j;
#line 587 "../src/grid.vala"
								j = _tmp29_ + 1;
#line 3143 "grid.c"
							}
#line 587 "../src/grid.vala"
							_tmp28_ = FALSE;
#line 587 "../src/grid.vala"
							if (!(j < ((guint) cols))) {
#line 587 "../src/grid.vala"
								break;
#line 3151 "grid.c"
							}
#line 589 "../src/grid.vala"
							_tmp30_ = tokens;
#line 589 "../src/grid.vala"
							_tmp30__length1 = tokens_length1;
#line 589 "../src/grid.vala"
							_tmp31_ = _tmp30_[j];
#line 589 "../src/grid.vala"
							_tmp33_ = uint64_try_parse (_tmp31_, &_tmp32_, NULL);
#line 589 "../src/grid.vala"
							number_64 = _tmp32_;
#line 589 "../src/grid.vala"
							if (!_tmp33_) {
#line 590 "../src/grid.vala"
								result = FALSE;
#line 590 "../src/grid.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 590 "../src/grid.vala"
								lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 590 "../src/grid.vala"
								return result;
#line 3173 "grid.c"
							}
#line 592 "../src/grid.vala"
							_tmp35_ = _grid_convert_tile_number (&number_64, &_tmp34_);
#line 592 "../src/grid.vala"
							number = _tmp34_;
#line 592 "../src/grid.vala"
							if (!_tmp35_) {
#line 593 "../src/grid.vala"
								result = FALSE;
#line 593 "../src/grid.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 593 "../src/grid.vala"
								lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 593 "../src/grid.vala"
								return result;
#line 3189 "grid.c"
							}
#line 594 "../src/grid.vala"
							(*grid)[(i * (*grid_length2)) + j] = number;
#line 3193 "grid.c"
						}
					}
				}
			}
		}
	}
#line 598 "../src/grid.vala"
	result = TRUE;
#line 598 "../src/grid.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 598 "../src/grid.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 598 "../src/grid.vala"
	return result;
#line 3208 "grid.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 607 "../src/grid.vala"
	if ((*length) == (*size)) {
#line 607 "../src/grid.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 607 "../src/grid.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3223 "grid.c"
	}
#line 607 "../src/grid.vala"
	(*array)[(*length)++] = value;
#line 607 "../src/grid.vala"
	(*array)[*length] = NULL;
#line 3229 "grid.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 608 "../src/grid.vala"
	result = g_new0 (gchar*, length + 1);
#line 608 "../src/grid.vala"
	for (i = 0; i < length; i++) {
#line 3242 "grid.c"
		gchar* _tmp0_;
#line 608 "../src/grid.vala"
		_tmp0_ = g_strdup (self[i]);
#line 608 "../src/grid.vala"
		result[i] = _tmp0_;
#line 3248 "grid.c"
	}
#line 608 "../src/grid.vala"
	return result;
#line 3252 "grid.c"
}

static inline void
_grid_parse_line (const gchar* line,
                  gchar*** tokens,
                  gint* tokens_length1)
{
	gchar** _vala_tokens = NULL;
	gint _vala_tokens_length1 = 0;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tokens = NULL;
	gchar** _tmp2_;
	gint _tokens_length1;
	gint __tokens_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
#line 601 "../src/grid.vala"
	g_return_if_fail (line != NULL);
#line 603 "../src/grid.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, " ", 0);
#line 603 "../src/grid.vala"
	_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 603 "../src/grid.vala"
	_vala_tokens = _tmp1_;
#line 603 "../src/grid.vala"
	_vala_tokens_length1 = _vala_array_length (_tmp0_);
#line 604 "../src/grid.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 604 "../src/grid.vala"
	_tokens = _tmp2_;
#line 604 "../src/grid.vala"
	_tokens_length1 = 0;
#line 604 "../src/grid.vala"
	__tokens_size_ = _tokens_length1;
#line 605 "../src/grid.vala"
	_tmp3_ = _vala_tokens;
#line 605 "../src/grid.vala"
	_tmp3__length1 = _vala_tokens_length1;
#line 3296 "grid.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 605 "../src/grid.vala"
		token_collection = _tmp3_;
#line 605 "../src/grid.vala"
		token_collection_length1 = _tmp3__length1;
#line 605 "../src/grid.vala"
		for (token_it = 0; token_it < _tmp3__length1; token_it = token_it + 1) {
#line 3308 "grid.c"
			gchar* _tmp4_;
			gchar* token = NULL;
#line 605 "../src/grid.vala"
			_tmp4_ = g_strdup (token_collection[token_it]);
#line 605 "../src/grid.vala"
			token = _tmp4_;
#line 3315 "grid.c"
			{
				const gchar* _tmp5_;
#line 606 "../src/grid.vala"
				_tmp5_ = token;
#line 606 "../src/grid.vala"
				if (g_strcmp0 (_tmp5_, "") != 0) {
#line 3322 "grid.c"
					gchar** _tmp6_;
					gint _tmp6__length1;
					const gchar* _tmp7_;
					gchar* _tmp8_;
#line 607 "../src/grid.vala"
					_tmp6_ = _tokens;
#line 607 "../src/grid.vala"
					_tmp6__length1 = _tokens_length1;
#line 607 "../src/grid.vala"
					_tmp7_ = token;
#line 607 "../src/grid.vala"
					_tmp8_ = g_strdup (_tmp7_);
#line 607 "../src/grid.vala"
					_vala_array_add1 (&_tokens, &_tokens_length1, &__tokens_size_, _tmp8_);
#line 3337 "grid.c"
				}
#line 605 "../src/grid.vala"
				_g_free0 (token);
#line 3341 "grid.c"
			}
		}
	}
#line 608 "../src/grid.vala"
	_tmp9_ = _tokens;
#line 608 "../src/grid.vala"
	_tmp9__length1 = _tokens_length1;
#line 608 "../src/grid.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup3 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
#line 608 "../src/grid.vala"
	_tmp10__length1 = _tmp9__length1;
#line 608 "../src/grid.vala"
	_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 608 "../src/grid.vala"
	_vala_tokens = _tmp10_;
#line 608 "../src/grid.vala"
	_vala_tokens_length1 = _tmp10__length1;
#line 601 "../src/grid.vala"
	_tokens = (_vala_array_free (_tokens, _tokens_length1, (GDestroyNotify) g_free), NULL);
#line 601 "../src/grid.vala"
	if (tokens) {
#line 601 "../src/grid.vala"
		*tokens = _vala_tokens;
#line 3365 "grid.c"
	} else {
#line 601 "../src/grid.vala"
		_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 3369 "grid.c"
	}
#line 601 "../src/grid.vala"
	if (tokens_length1) {
#line 601 "../src/grid.vala"
		*tokens_length1 = _vala_tokens_length1;
#line 3375 "grid.c"
	}
}

static inline gboolean
_grid_convert_tile_number (guint64* number_64,
                           guint8* number)
{
	guint8 _vala_number = 0U;
	gboolean result = FALSE;
#line 614 "../src/grid.vala"
	if ((*number_64) == ((guint64) 0)) {
#line 616 "../src/grid.vala"
		_vala_number = (guint8) 0;
#line 617 "../src/grid.vala"
		result = TRUE;
#line 617 "../src/grid.vala"
		if (number) {
#line 617 "../src/grid.vala"
			*number = _vala_number;
#line 3395 "grid.c"
		}
#line 617 "../src/grid.vala"
		return result;
#line 3399 "grid.c"
	}
	{
		gboolean _tmp0_ = FALSE;
#line 619 "../src/grid.vala"
		_vala_number = (guint8) 1;
#line 619 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 619 "../src/grid.vala"
		while (TRUE) {
#line 619 "../src/grid.vala"
			if (!_tmp0_) {
#line 3411 "grid.c"
				guint8 _tmp1_;
#line 619 "../src/grid.vala"
				_tmp1_ = _vala_number;
#line 619 "../src/grid.vala"
				_vala_number = _tmp1_ + 1;
#line 3417 "grid.c"
			}
#line 619 "../src/grid.vala"
			_tmp0_ = FALSE;
#line 619 "../src/grid.vala"
			if (!(((gint) _vala_number) <= 81)) {
#line 619 "../src/grid.vala"
				break;
#line 3425 "grid.c"
			}
#line 620 "../src/grid.vala"
			if ((*number_64) == ((guint64) pow ((gdouble) 2, (gdouble) _vala_number))) {
#line 621 "../src/grid.vala"
				result = TRUE;
#line 621 "../src/grid.vala"
				if (number) {
#line 621 "../src/grid.vala"
					*number = _vala_number;
#line 3435 "grid.c"
				}
#line 621 "../src/grid.vala"
				return result;
#line 3439 "grid.c"
			}
		}
	}
#line 623 "../src/grid.vala"
	result = FALSE;
#line 623 "../src/grid.vala"
	if (number) {
#line 623 "../src/grid.vala"
		*number = _vala_number;
#line 3449 "grid.c"
	}
#line 623 "../src/grid.vala"
	return result;
#line 3453 "grid.c"
}

gint
grid_get_rows (Grid* self)
{
	gint result;
#line 24 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/grid.vala"
	result = self->priv->_rows;
#line 24 "../src/grid.vala"
	return result;
#line 3466 "grid.c"
}

static void
grid_set_rows (Grid* self,
               gint value)
{
#line 24 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/grid.vala"
	self->priv->_rows = value;
#line 3477 "grid.c"
}

gint
grid_get_cols (Grid* self)
{
	gint result;
#line 25 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/grid.vala"
	result = self->priv->_cols;
#line 25 "../src/grid.vala"
	return result;
#line 3490 "grid.c"
}

static void
grid_set_cols (Grid* self,
               gint value)
{
#line 25 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/grid.vala"
	self->priv->_cols = value;
#line 3501 "grid.c"
}

guint
grid_get_target_value (Grid* self)
{
	guint result;
#line 27 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 27 "../src/grid.vala"
	result = self->priv->_target_value;
#line 27 "../src/grid.vala"
	return result;
#line 3514 "grid.c"
}

void
grid_set_target_value (Grid* self,
                       guint value)
{
#line 27 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/grid.vala"
	self->priv->_target_value = value;
#line 3525 "grid.c"
}

gboolean
grid_get_target_value_reached (Grid* self)
{
	gboolean result;
#line 28 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/grid.vala"
	result = self->priv->_target_value_reached;
#line 28 "../src/grid.vala"
	return result;
#line 3538 "grid.c"
}

void
grid_set_target_value_reached (Grid* self,
                               gboolean value)
{
#line 28 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/grid.vala"
	self->priv->_target_value_reached = value;
#line 3549 "grid.c"
}

static GObject *
grid_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Grid * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp3_;
	gint _tmp4_;
	guint8* _tmp5_;
#line 30 "../src/grid.vala"
	parent_class = G_OBJECT_CLASS (grid_parent_class);
#line 30 "../src/grid.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRID, Grid);
#line 32 "../src/grid.vala"
	_tmp1_ = self->priv->_rows;
#line 32 "../src/grid.vala"
	if (_tmp1_ < 1) {
#line 32 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 3577 "grid.c"
	} else {
		gint _tmp2_;
#line 32 "../src/grid.vala"
		_tmp2_ = self->priv->_cols;
#line 32 "../src/grid.vala"
		_tmp0_ = _tmp2_ < 1;
#line 3584 "grid.c"
	}
#line 32 "../src/grid.vala"
	if (_tmp0_) {
#line 33 "../src/grid.vala"
		g_assert_not_reached ();
#line 3590 "grid.c"
	}
#line 35 "../src/grid.vala"
	_tmp3_ = self->priv->_rows;
#line 35 "../src/grid.vala"
	_tmp4_ = self->priv->_cols;
#line 35 "../src/grid.vala"
	_tmp5_ = g_new0 (guint8, _tmp3_ * _tmp4_);
#line 35 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 35 "../src/grid.vala"
	self->_grid = _tmp5_;
#line 35 "../src/grid.vala"
	self->_grid_length1 = _tmp3_;
#line 35 "../src/grid.vala"
	self->_grid_length2 = _tmp4_;
#line 36 "../src/grid.vala"
	_grid_clear (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 30 "../src/grid.vala"
	return obj;
#line 3610 "grid.c"
}

static void
grid_class_init (GridClass * klass,
                 gpointer klass_data)
{
#line 20 "../src/grid.vala"
	grid_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/grid.vala"
	g_type_class_adjust_private_offset (klass, &Grid_private_offset);
#line 20 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_grid_get_property;
#line 20 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_grid_set_property;
#line 20 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->constructor = grid_constructor;
#line 20 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->finalize = grid_finalize;
#line 20 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_ROWS_PROPERTY, grid_properties[GRID_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_COLS_PROPERTY, grid_properties[GRID_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_TARGET_VALUE_PROPERTY, grid_properties[GRID_TARGET_VALUE_PROPERTY] = g_param_spec_uint ("target-value", "target-value", "target-value", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_TARGET_VALUE_REACHED_PROPERTY, grid_properties[GRID_TARGET_VALUE_REACHED_PROPERTY] = g_param_spec_boolean ("target-value-reached", "target-value-reached", "target-value-reached", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3637 "grid.c"
}

static void
grid_instance_init (Grid * self,
                    gpointer klass)
{
#line 20 "../src/grid.vala"
	self->priv = grid_get_instance_private (self);
#line 27 "../src/grid.vala"
	self->priv->_target_value = (guint) 0;
#line 28 "../src/grid.vala"
	self->priv->_target_value_reached = FALSE;
#line 3650 "grid.c"
}

static void
grid_finalize (GObject * obj)
{
	Grid * self;
#line 20 "../src/grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRID, Grid);
#line 22 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 20 "../src/grid.vala"
	G_OBJECT_CLASS (grid_parent_class)->finalize (obj);
#line 3663 "grid.c"
}

GType
grid_get_type (void)
{
	static volatile gsize grid_type_id__volatile = 0;
	if (g_once_init_enter (&grid_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Grid), 0, (GInstanceInitFunc) grid_instance_init, NULL };
		GType grid_type_id;
		grid_type_id = g_type_register_static (G_TYPE_OBJECT, "Grid", &g_define_type_info, 0);
		Grid_private_offset = g_type_add_instance_private (grid_type_id, sizeof (GridPrivate));
		g_once_init_leave (&grid_type_id__volatile, grid_type_id);
	}
	return grid_type_id__volatile;
}

static void
_vala_grid_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Grid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRID, Grid);
#line 20 "../src/grid.vala"
	switch (property_id) {
#line 20 "../src/grid.vala"
		case GRID_ROWS_PROPERTY:
#line 20 "../src/grid.vala"
		g_value_set_int (value, grid_get_rows (self));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_COLS_PROPERTY:
#line 20 "../src/grid.vala"
		g_value_set_int (value, grid_get_cols (self));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_TARGET_VALUE_PROPERTY:
#line 20 "../src/grid.vala"
		g_value_set_uint (value, grid_get_target_value (self));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_TARGET_VALUE_REACHED_PROPERTY:
#line 20 "../src/grid.vala"
		g_value_set_boolean (value, grid_get_target_value_reached (self));
#line 20 "../src/grid.vala"
		break;
#line 3714 "grid.c"
		default:
#line 20 "../src/grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/grid.vala"
		break;
#line 3720 "grid.c"
	}
}

static void
_vala_grid_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Grid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRID, Grid);
#line 20 "../src/grid.vala"
	switch (property_id) {
#line 20 "../src/grid.vala"
		case GRID_ROWS_PROPERTY:
#line 20 "../src/grid.vala"
		grid_set_rows (self, g_value_get_int (value));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_COLS_PROPERTY:
#line 20 "../src/grid.vala"
		grid_set_cols (self, g_value_get_int (value));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_TARGET_VALUE_PROPERTY:
#line 20 "../src/grid.vala"
		grid_set_target_value (self, g_value_get_uint (value));
#line 20 "../src/grid.vala"
		break;
#line 20 "../src/grid.vala"
		case GRID_TARGET_VALUE_REACHED_PROPERTY:
#line 20 "../src/grid.vala"
		grid_set_target_value_reached (self, g_value_get_boolean (value));
#line 20 "../src/grid.vala"
		break;
#line 3758 "grid.c"
		default:
#line 20 "../src/grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/grid.vala"
		break;
#line 3764 "grid.c"
	}
}

gchar*
grid_position_to_string (GridPosition *self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 634 "../src/grid.vala"
	_tmp0_ = g_strdup_printf ("%i", (*self).row);
#line 634 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 634 "../src/grid.vala"
	_tmp2_ = g_strdup_printf ("%i", (*self).col);
#line 634 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 634 "../src/grid.vala"
	_tmp4_ = g_strconcat ("(", _tmp1_, ",", _tmp3_, ")", NULL);
#line 634 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 634 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 634 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 634 "../src/grid.vala"
	result = _tmp5_;
#line 634 "../src/grid.vala"
	return result;
#line 3798 "grid.c"
}

GridPosition*
grid_position_dup (const GridPosition* self)
{
	GridPosition* dup;
#line 627 "../src/grid.vala"
	dup = g_new0 (GridPosition, 1);
#line 627 "../src/grid.vala"
	memcpy (dup, self, sizeof (GridPosition));
#line 627 "../src/grid.vala"
	return dup;
#line 3811 "grid.c"
}

void
grid_position_free (GridPosition* self)
{
#line 627 "../src/grid.vala"
	g_free (self);
#line 3819 "grid.c"
}

GType
grid_position_get_type (void)
{
	static volatile gsize grid_position_type_id__volatile = 0;
	if (g_once_init_enter (&grid_position_type_id__volatile)) {
		GType grid_position_type_id;
		grid_position_type_id = g_boxed_type_register_static ("GridPosition", (GBoxedCopyFunc) grid_position_dup, (GBoxedFreeFunc) grid_position_free);
		g_once_init_leave (&grid_position_type_id__volatile, grid_position_type_id);
	}
	return grid_position_type_id__volatile;
}

TileMovement*
tile_movement_dup (const TileMovement* self)
{
	TileMovement* dup;
#line 638 "../src/grid.vala"
	dup = g_new0 (TileMovement, 1);
#line 638 "../src/grid.vala"
	memcpy (dup, self, sizeof (TileMovement));
#line 638 "../src/grid.vala"
	return dup;
#line 3844 "grid.c"
}

void
tile_movement_free (TileMovement* self)
{
#line 638 "../src/grid.vala"
	g_free (self);
#line 3852 "grid.c"
}

GType
tile_movement_get_type (void)
{
	static volatile gsize tile_movement_type_id__volatile = 0;
	if (g_once_init_enter (&tile_movement_type_id__volatile)) {
		GType tile_movement_type_id;
		tile_movement_type_id = g_boxed_type_register_static ("TileMovement", (GBoxedCopyFunc) tile_movement_dup, (GBoxedFreeFunc) tile_movement_free);
		g_once_init_leave (&tile_movement_type_id__volatile, tile_movement_type_id);
	}
	return tile_movement_type_id__volatile;
}

Tile*
tile_dup (const Tile* self)
{
	Tile* dup;
#line 644 "../src/grid.vala"
	dup = g_new0 (Tile, 1);
#line 644 "../src/grid.vala"
	memcpy (dup, self, sizeof (Tile));
#line 644 "../src/grid.vala"
	return dup;
#line 3877 "grid.c"
}

void
tile_free (Tile* self)
{
#line 644 "../src/grid.vala"
	g_free (self);
#line 3885 "grid.c"
}

GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		GType tile_type_id;
		tile_type_id = g_boxed_type_register_static ("Tile", (GBoxedCopyFunc) tile_dup, (GBoxedFreeFunc) tile_free);
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}

gchar*
move_request_debug_string (MoveRequest request)
{
	gchar* result = NULL;
#line 658 "../src/grid.vala"
	switch (request) {
#line 658 "../src/grid.vala"
		case MOVE_REQUEST_UP:
#line 3908 "grid.c"
		{
			gchar* _tmp0_;
#line 660 "../src/grid.vala"
			_tmp0_ = g_strdup ("move up");
#line 660 "../src/grid.vala"
			result = _tmp0_;
#line 660 "../src/grid.vala"
			return result;
#line 3917 "grid.c"
		}
#line 658 "../src/grid.vala"
		case MOVE_REQUEST_RIGHT:
#line 3921 "grid.c"
		{
			gchar* _tmp1_;
#line 661 "../src/grid.vala"
			_tmp1_ = g_strdup ("move right");
#line 661 "../src/grid.vala"
			result = _tmp1_;
#line 661 "../src/grid.vala"
			return result;
#line 3930 "grid.c"
		}
#line 658 "../src/grid.vala"
		case MOVE_REQUEST_DOWN:
#line 3934 "grid.c"
		{
			gchar* _tmp2_;
#line 662 "../src/grid.vala"
			_tmp2_ = g_strdup ("move down");
#line 662 "../src/grid.vala"
			result = _tmp2_;
#line 662 "../src/grid.vala"
			return result;
#line 3943 "grid.c"
		}
#line 658 "../src/grid.vala"
		case MOVE_REQUEST_LEFT:
#line 3947 "grid.c"
		{
			gchar* _tmp3_;
#line 663 "../src/grid.vala"
			_tmp3_ = g_strdup ("move left");
#line 663 "../src/grid.vala"
			result = _tmp3_;
#line 663 "../src/grid.vala"
			return result;
#line 3956 "grid.c"
		}
		default:
		{
#line 664 "../src/grid.vala"
			g_assert_not_reached ();
#line 3962 "grid.c"
		}
	}
}

GType
move_request_get_type (void)
{
	static volatile gsize move_request_type_id__volatile = 0;
	if (g_once_init_enter (&move_request_type_id__volatile)) {
		static const GEnumValue values[] = {{MOVE_REQUEST_UP, "MOVE_REQUEST_UP", "up"}, {MOVE_REQUEST_RIGHT, "MOVE_REQUEST_RIGHT", "right"}, {MOVE_REQUEST_DOWN, "MOVE_REQUEST_DOWN", "down"}, {MOVE_REQUEST_LEFT, "MOVE_REQUEST_LEFT", "left"}, {0, NULL, NULL}};
		GType move_request_type_id;
		move_request_type_id = g_enum_register_static ("MoveRequest", values);
		g_once_init_leave (&move_request_type_id__volatile, move_request_type_id);
	}
	return move_request_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

